!function(n){
/***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS2

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
"use strict";function e(n){return n.split("")}function t(n,e){return e.indexOf(n)>=0}function i(n,e){for(var t=0,i=e.length;t<i;++t)if(n(e[t]))return e[t]}function r(n){Object.defineProperty(n.prototype,"stack",{get:function(){var n=new Error(this.message);n.name=this.name;try{throw n}catch(n){return n.stack}}})}function o(n,e){this.message=n,this.defs=e}function a(n,e,t){!0===n&&(n={});var i=n||{};if(t)for(var r in i)b(i,r)&&!b(e,r)&&o.croak("`"+r+"` is not a supported option",e);for(var r in e)b(e,r)&&(i[r]=n&&b(n,r)?n[r]:e[r]);return i}function u(n,e){var t=0;for(var i in e)b(e,i)&&(n[i]=e[i],t++);return t}function s(){}function c(){return!1}function f(){return!0}function l(){return this}function p(){return null}o.prototype=Object.create(Error.prototype),o.prototype.constructor=o,o.prototype.name="DefaultsError",r(o),o.croak=function(n,e){throw new o(n,e)};var h=function(){function n(n,o,a){var u,s=[],c=[];function f(){var f=o(n[u],u),l=f instanceof r;return l&&(f=f.v),f instanceof t?(f=f.v)instanceof i?c.push.apply(c,a?f.v.slice().reverse():f.v):c.push(f):f!==e&&(f instanceof i?s.push.apply(s,a?f.v.slice().reverse():f.v):s.push(f)),l}if(n instanceof Array)if(a){for(u=n.length;--u>=0&&!f(););s.reverse(),c.reverse()}else for(u=0;u<n.length&&!f();++u);else for(u in n)if(b(n,u)&&f())break;return c.concat(s)}n.at_top=function(n){return new t(n)},n.splice=function(n){return new i(n)},n.last=function(n){return new r(n)};var e=n.skip={};function t(n){this.v=n}function i(n){this.v=n}function r(n){this.v=n}return n}();function d(n,e){n.indexOf(e)<0&&n.push(e)}function m(n,e){return n.replace(/\{(.+?)\}/g,function(n,t){return e&&e[t]})}function v(n,e){for(var t=n.length;--t>=0;)n[t]===e&&n.splice(t,1)}function D(n,e){if(n.length<2)return n.slice();return function n(t){if(t.length<=1)return t;var i=Math.floor(t.length/2),r=t.slice(0,i),o=t.slice(i);return function(n,t){for(var i=[],r=0,o=0,a=0;r<n.length&&o<t.length;)e(n[r],t[o])<=0?i[a++]=n[r++]:i[a++]=t[o++];return r<n.length&&i.push.apply(i,n.slice(r)),o<t.length&&i.push.apply(i,t.slice(o)),i}(r=n(r),o=n(o))}(n)}function g(n){n instanceof Array||(n=n.split(" "));var e="",t=[];n:for(var i=0;i<n.length;++i){for(var r=0;r<t.length;++r)if(t[r][0].length==n[i].length){t[r].push(n[i]);continue n}t.push([n[i]])}function o(n){return JSON.stringify(n).replace(/[\u2028\u2029]/g,function(n){switch(n){case"\u2028":return"\\u2028";case"\u2029":return"\\u2029"}return n})}function a(n){if(1==n.length)return e+="return str === "+o(n[0])+";";e+="switch(str){";for(var t=0;t<n.length;++t)e+="case "+o(n[t])+":";e+="return true}return false;"}if(t.length>3){t.sort(function(n,e){return e.length-n.length}),e+="switch(str.length){";for(i=0;i<t.length;++i){var u=t[i];e+="case "+u[0].length+":",a(u)}e+="}"}else a(n);return new Function("str",e)}function _(n,e){for(var t=n.length;--t>=0;)if(!e(n[t]))return!1;return!0}function y(){this._values=Object.create(null),this._size=0}function b(n,e){return Object.prototype.hasOwnProperty.call(n,e)}function E(n){for(var e,t=n.parent(-1),i=0;e=n.parent(i);i++){if(e instanceof x&&e.body===t)return!0;if(!(e instanceof On&&e.expressions[0]===t||"Call"==e.TYPE&&e.expression===t||e instanceof Mn&&e.expression===t||e instanceof zn&&e.expression===t||e instanceof Nn&&e.condition===t||e instanceof In&&e.left===t||e instanceof Sn&&e.expression===t))return!1;t=e}}function w(n,e){return!0===n||n instanceof RegExp&&n.test(e)}function F(e,t,i,r){arguments.length<4&&(r=A);var o=t=t?t.split(/\s+/):[];r&&r.PROPS&&(t=t.concat(r.PROPS));for(var a="return function AST_"+e+"(props){ if (props) { ",u=t.length;--u>=0;)a+="this."+t[u]+" = props."+t[u]+";";var s=r&&new r;(s&&s.initialize||i&&i.initialize)&&(a+="this.initialize();"),a+="}}";var c=new Function(a)();if(s&&(c.prototype=s,c.BASE=r),r&&r.SUBCLASSES.push(c),c.prototype.CTOR=c,c.PROPS=t||null,c.SELF_PROPS=o,c.SUBCLASSES=[],e&&(c.prototype.TYPE=c.TYPE=e),i)for(u in i)b(i,u)&&(/^\$/.test(u)?c[u.substr(1)]=i[u]:c.prototype[u]=i[u]);return c.DEFMETHOD=function(n,e){this.prototype[n]=e},void 0!==n&&(n["AST_"+e]=c),c}y.prototype={set:function(n,e){return this.has(n)||++this._size,this._values["$"+n]=e,this},add:function(n,e){return this.has(n)?this.get(n).push(e):this.set(n,[e]),this},get:function(n){return this._values["$"+n]},del:function(n){return this.has(n)&&(--this._size,delete this._values["$"+n]),this},has:function(n){return"$"+n in this._values},each:function(n){for(var e in this._values)n(this._values[e],e.substr(1))},size:function(){return this._size},map:function(n){var e=[];for(var t in this._values)e.push(n(this._values[t],t.substr(1)));return e},clone:function(){var n=new y;for(var e in this._values)n._values[e]=this._values[e];return n._size=this._size,n},toObject:function(){return this._values}},y.fromObject=function(n){var e=new y;return e._size=u(e._values,n),e};var C=F("Token","type value line col pos endline endcol endpos nlb comments_before comments_after file raw",{},null),A=F("Node","start end",{_clone:function(n){if(n){var e=this.clone();return e.transform(new _t(function(n){if(n!==e)return n.clone(!0)}))}return new this.CTOR(this)},clone:function(n){return this._clone(n)},$documentation:"Base class of all AST nodes",$propdoc:{start:"[AST_Token] The first token of this node",end:"[AST_Token] The last token of this node"},_walk:function(n){return n._visit(this)},walk:function(n){return this._walk(n)}},null);A.warn_function=null,A.warn=function(n,e){A.warn_function&&A.warn_function(m(n,e))};var x=F("Statement",null,{$documentation:"Base class of all statements"}),k=F("Debugger",null,{$documentation:"Represents a debugger statement"},x),B=F("Directive","value quote",{$documentation:'Represents a directive, like "use strict";',$propdoc:{value:"[string] The value of this directive as a plain string (it's not an AST_String!)",quote:"[string] the original quote character"}},x),O=F("SimpleStatement","body",{$documentation:"A statement consisting of an expression, i.e. a = 1 + 2",$propdoc:{body:"[AST_Node] an expression node (should not be instanceof AST_Statement)"},_walk:function(n){return n._visit(this,function(){this.body._walk(n)})}},x);function $(n,e){var t=n.body;if(t instanceof A)t._walk(e);else for(var i=0,r=t.length;i<r;i++)t[i]._walk(e)}function M(n){var e=this._clone(n);return this.block_scope&&(e.block_scope=this.block_scope.clone()),e}var z=F("Block","body block_scope",{$documentation:"A body of statements (usually braced)",$propdoc:{body:"[AST_Statement*] an array of statements",block_scope:"[AST_Scope] the block scope"},_walk:function(n){return n._visit(this,function(){$(this,n)})},clone:M},x),q=F("BlockStatement",null,{$documentation:"A block statement"},z),T=F("EmptyStatement",null,{$documentation:"The empty statement (empty block or simply a semicolon)"},x),S=F("StatementWithBody","body",{$documentation:"Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",$propdoc:{body:"[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"}},x),I=F("LabeledStatement","label",{$documentation:"Statement with a label",$propdoc:{label:"[AST_Label] a label definition"},_walk:function(n){return n._visit(this,function(){this.label._walk(n),this.body._walk(n)})},clone:function(n){var e=this._clone(n);if(n){var t=e.label,i=this.label;e.walk(new Te(function(n){n instanceof cn&&n.label&&n.label.thedef===i&&(n.label.thedef=t,t.references.push(n))}))}return e}},S),N=F("IterationStatement","block_scope",{$documentation:"Internal class.  All loops inherit from it.",$propdoc:{block_scope:"[AST_Scope] the block scope for this iteration statement."},clone:M},S),H=F("DWLoop","condition",{$documentation:"Base class for do/while statements",$propdoc:{condition:"[AST_Node] the loop condition.  Should not be instanceof AST_Statement"}},N),P=F("Do",null,{$documentation:"A `do` statement",_walk:function(n){return n._visit(this,function(){this.body._walk(n),this.condition._walk(n)})}},H),R=F("While",null,{$documentation:"A `while` statement",_walk:function(n){return n._visit(this,function(){this.condition._walk(n),this.body._walk(n)})}},H),j=F("For","init condition step",{$documentation:"A `for` statement",$propdoc:{init:"[AST_Node?] the `for` initialization code, or null if empty",condition:"[AST_Node?] the `for` termination clause, or null if empty",step:"[AST_Node?] the `for` update clause, or null if empty"},_walk:function(n){return n._visit(this,function(){this.init&&this.init._walk(n),this.condition&&this.condition._walk(n),this.step&&this.step._walk(n),this.body._walk(n)})}},N),U=F("ForIn","init object",{$documentation:"A `for ... in` statement",$propdoc:{init:"[AST_Node] the `for/in` initialization code",object:"[AST_Node] the object that we're looping through"},_walk:function(n){return n._visit(this,function(){this.init._walk(n),this.object._walk(n),this.body._walk(n)})}},N),L=F("ForOf","await",{$documentation:"A `for ... of` statement"},U),Y=F("With","expression",{$documentation:"A `with` statement",$propdoc:{expression:"[AST_Node] the `with` expression"},_walk:function(n){return n._visit(this,function(){this.expression._walk(n),this.body._walk(n)})}},S),V=F("Scope","variables functions uses_with uses_eval parent_scope enclosed cname",{$documentation:"Base class for all statements introducing a lexical scope",$propdoc:{variables:"[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope",functions:"[Object/S] like `variables`, but only lists function declarations",uses_with:"[boolean/S] tells whether this scope uses the `with` statement",uses_eval:"[boolean/S] tells whether this scope contains a direct call to the global `eval`",parent_scope:"[AST_Scope?/S] link to the parent scope",enclosed:"[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",cname:"[integer/S] current index for mangling variables (used internally by the mangler)"},get_defun_scope:function(){for(var n=this;n.is_block_scope();)n=n.parent_scope;return n},clone:function(n){var e=this._clone(n);return this.variables&&(e.variables=this.variables.clone()),this.functions&&(e.functions=this.functions.clone()),this.enclosed&&(e.enclosed=this.enclosed.slice()),e},pinned:function(){return this.uses_eval||this.uses_with}},z),W=F("Toplevel","globals",{$documentation:"The toplevel scope",$propdoc:{globals:"[Object/S] a map of name -> SymbolDef for all undeclared names"},wrap_commonjs:function(n){var e=this.body,t="(function(exports){'$ORIG';})(typeof "+n+"=='undefined'?("+n+"={}):"+n+");";return t=(t=gt(t)).transform(new _t(function(n){if(n instanceof B&&"$ORIG"==n.value)return h.splice(e)}))},wrap_enclose:function(n){"string"!=typeof n&&(n="");var e=n.indexOf(":");e<0&&(e=n.length);var t=this.body;return gt(["(function(",n.slice(0,e),'){"$ORIG"})(',n.slice(e+1),")"].join("")).transform(new _t(function(n){if(n instanceof B&&"$ORIG"==n.value)return h.splice(t)}))}},V),X=F("Expansion","expression",{$documentation:"An expandible argument, such as ...rest, a splat, such as [1,2,...all], or an expansion in a variable declaration, such as var [first, ...rest] = list",$propdoc:{expression:"[AST_Node] the thing to be expanded"},_walk:function(n){var e=this;return n._visit(this,function(){e.expression.walk(n)})}}),J=F("Lambda","name argnames uses_arguments is_generator async",{$documentation:"Base class for functions",$propdoc:{name:"[AST_SymbolDeclaration?] the name of this function",argnames:"[AST_SymbolFunarg|AST_Destructuring|AST_Expansion|AST_DefaultAssign*] array of function arguments, destructurings, or expanding arguments",uses_arguments:"[boolean/S] tells whether this function accesses the arguments array",is_generator:"[boolean] is this a generator method",async:"[boolean] is this method async"},args_as_names:function(){for(var n=[],e=0;e<this.argnames.length;e++)this.argnames[e]instanceof nn?n=n.concat(this.argnames[e].all_symbols()):n.push(this.argnames[e]);return n},_walk:function(n){return n._visit(this,function(){this.name&&this.name._walk(n);for(var e=this.argnames,t=0,i=e.length;t<i;t++)e[t]._walk(n);$(this,n)})}},V),Z=F("Accessor",null,{$documentation:"A setter/getter function.  The `name` property is always null."},J),Q=F("Function","inlined",{$documentation:"A function expression"},J),K=F("Arrow","inlined",{$documentation:"An ES6 Arrow function ((a) => b)"},J),G=F("Defun","inlined",{$documentation:"A function definition"},J),nn=F("Destructuring","names is_array",{$documentation:"A destructuring of several names. Used in destructuring assignment and with destructuring function argument names",$propdoc:{names:"[AST_Node*] Array of properties or elements",is_array:"[Boolean] Whether the destructuring represents an object or array"},_walk:function(n){return n._visit(this,function(){this.names.forEach(function(e){e._walk(n)})})},all_symbols:function(){var n=[];return this.walk(new Te(function(e){e instanceof Qn&&n.push(e),e instanceof X&&n.push(e.expression)})),n}}),en=F("PrefixedTemplateString","template_string prefix",{$documentation:"A templatestring with a prefix, such as String.raw`foobarbaz`",$propdoc:{template_string:"[AST_TemplateString] The template string",prefix:"[AST_SymbolRef|AST_PropAccess] The prefix, which can be a symbol such as `foo` or a dotted expression such as `String.raw`."},_walk:function(n){this.prefix._walk(n),this.template_string._walk(n)}}),tn=F("TemplateString","segments",{$documentation:"A template string literal",$propdoc:{segments:"[AST_Node*] One or more segments, starting with AST_TemplateSegment. AST_Node may follow AST_TemplateSegment, but each AST_Node must be followed by AST_TemplateSegment."},_walk:function(n){return n._visit(this,function(){this.segments.forEach(function(e){e._walk(n)})})}}),rn=F("TemplateSegment","value raw",{$documentation:"A segment of a template string literal",$propdoc:{value:"Content of the segment",raw:"Raw content of the segment"}}),on=F("Jump",null,{$documentation:"Base class for \u201cjumps\u201d (for now that's `return`, `throw`, `break` and `continue`)"},x),an=F("Exit","value",{$documentation:"Base class for \u201cexits\u201d (`return` and `throw`)",$propdoc:{value:"[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"},_walk:function(n){return n._visit(this,this.value&&function(){this.value._walk(n)})}},on),un=F("Return",null,{$documentation:"A `return` statement"},an),sn=F("Throw",null,{$documentation:"A `throw` statement"},an),cn=F("LoopControl","label",{$documentation:"Base class for loop control statements (`break` and `continue`)",$propdoc:{label:"[AST_LabelRef?] the label, or null if none"},_walk:function(n){return n._visit(this,this.label&&function(){this.label._walk(n)})}},on),fn=F("Break",null,{$documentation:"A `break` statement"},cn),ln=F("Continue",null,{$documentation:"A `continue` statement"},cn),pn=F("If","condition alternative",{$documentation:"A `if` statement",$propdoc:{condition:"[AST_Node] the `if` condition",alternative:"[AST_Statement?] the `else` part, or null if not present"},_walk:function(n){return n._visit(this,function(){this.condition._walk(n),this.body._walk(n),this.alternative&&this.alternative._walk(n)})}},S),hn=F("Switch","expression",{$documentation:"A `switch` statement",$propdoc:{expression:"[AST_Node] the `switch` \u201cdiscriminant\u201d"},_walk:function(n){return n._visit(this,function(){this.expression._walk(n),$(this,n)})}},z),dn=F("SwitchBranch",null,{$documentation:"Base class for `switch` branches"},z),mn=F("Default",null,{$documentation:"A `default` switch branch"},dn),vn=F("Case","expression",{$documentation:"A `case` switch branch",$propdoc:{expression:"[AST_Node] the `case` expression"},_walk:function(n){return n._visit(this,function(){this.expression._walk(n),$(this,n)})}},dn),Dn=F("Try","bcatch bfinally",{$documentation:"A `try` statement",$propdoc:{bcatch:"[AST_Catch?] the catch block, or null if not present",bfinally:"[AST_Finally?] the finally block, or null if not present"},_walk:function(n){return n._visit(this,function(){$(this,n),this.bcatch&&this.bcatch._walk(n),this.bfinally&&this.bfinally._walk(n)})}},z),gn=F("Catch","argname",{$documentation:"A `catch` node; only makes sense as part of a `try` statement",$propdoc:{argname:"[AST_SymbolCatch|AST_Destructuring|AST_Expansion|AST_DefaultAssign] symbol for the exception"},_walk:function(n){return n._visit(this,function(){this.argname&&this.argname._walk(n),$(this,n)})}},z),_n=F("Finally",null,{$documentation:"A `finally` node; only makes sense as part of a `try` statement"},z),yn=F("Definitions","definitions",{$documentation:"Base class for `var` or `const` nodes (variable declarations/initializations)",$propdoc:{definitions:"[AST_VarDef*] array of variable definitions"},_walk:function(n){return n._visit(this,function(){for(var e=this.definitions,t=0,i=e.length;t<i;t++)e[t]._walk(n)})}},x),bn=F("Var",null,{$documentation:"A `var` statement"},yn),En=F("Let",null,{$documentation:"A `let` statement"},yn),wn=F("Const",null,{$documentation:"A `const` statement"},yn),Fn=F("NameMapping","foreign_name name",{$documentation:"The part of the export/import statement that declare names from a module.",$propdoc:{foreign_name:"[AST_SymbolExportForeign|AST_SymbolImportForeign] The name being exported/imported (as specified in the module)",name:"[AST_SymbolExport|AST_SymbolImport] The name as it is visible to this module."},_walk:function(n){return n._visit(this,function(){this.foreign_name._walk(n),this.name._walk(n)})}}),Cn=F("Import","imported_name imported_names module_name",{$documentation:"An `import` statement",$propdoc:{imported_name:"[AST_SymbolImport] The name of the variable holding the module's default export.",imported_names:"[AST_NameMapping*] The names of non-default imported variables",module_name:"[AST_String] String literal describing where this module came from"},_walk:function(n){return n._visit(this,function(){this.imported_name&&this.imported_name._walk(n),this.imported_names&&this.imported_names.forEach(function(e){e._walk(n)}),this.module_name._walk(n)})}}),An=F("Export","exported_definition exported_value is_default exported_names module_name",{$documentation:"An `export` statement",$propdoc:{exported_definition:"[AST_Defun|AST_Definitions|AST_DefClass?] An exported definition",exported_value:"[AST_Node?] An exported value",exported_names:"[AST_NameMapping*?] List of exported names",module_name:"[AST_String?] Name of the file to load exports from",is_default:"[Boolean] Whether this is the default exported value of this module"},_walk:function(n){n._visit(this,function(){this.exported_definition&&this.exported_definition._walk(n),this.exported_value&&this.exported_value._walk(n),this.exported_names&&this.exported_names.forEach(function(e){e._walk(n)}),this.module_name&&this.module_name._walk(n)})}},x),xn=F("VarDef","name value",{$documentation:"A variable declaration; only appears in a AST_Definitions node",$propdoc:{name:"[AST_Destructuring|AST_SymbolConst|AST_SymbolLet|AST_SymbolVar] name of the variable",value:"[AST_Node?] initializer, or null of there's no initializer"},_walk:function(n){return n._visit(this,function(){this.name._walk(n),this.value&&this.value._walk(n)})}}),kn=F("Call","expression args",{$documentation:"A function call expression",$propdoc:{expression:"[AST_Node] expression to invoke as function",args:"[AST_Node*] array of arguments"},_walk:function(n){return n._visit(this,function(){for(var e=this.args,t=0,i=e.length;t<i;t++)e[t]._walk(n);this.expression._walk(n)})}}),Bn=F("New",null,{$documentation:"An object instantiation.  Derives from a function call since it has exactly the same properties"},kn),On=F("Sequence","expressions",{$documentation:"A sequence expression (comma-separated expressions)",$propdoc:{expressions:"[AST_Node*] array of expressions (at least two)"},_walk:function(n){return n._visit(this,function(){this.expressions.forEach(function(e){e._walk(n)})})}}),$n=F("PropAccess","expression property",{$documentation:'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',$propdoc:{expression:"[AST_Node] the \u201ccontainer\u201d expression",property:"[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"}}),Mn=F("Dot",null,{$documentation:"A dotted property access expression",_walk:function(n){return n._visit(this,function(){this.expression._walk(n)})}},$n),zn=F("Sub",null,{$documentation:'Index-style property access, i.e. `a["foo"]`',_walk:function(n){return n._visit(this,function(){this.expression._walk(n),this.property._walk(n)})}},$n),qn=F("Unary","operator expression",{$documentation:"Base class for unary expressions",$propdoc:{operator:"[string] the operator",expression:"[AST_Node] expression that this unary operator applies to"},_walk:function(n){return n._visit(this,function(){this.expression._walk(n)})}}),Tn=F("UnaryPrefix",null,{$documentation:"Unary prefix expression, i.e. `typeof i` or `++i`"},qn),Sn=F("UnaryPostfix",null,{$documentation:"Unary postfix expression, i.e. `i++`"},qn),In=F("Binary","operator left right",{$documentation:"Binary expression, i.e. `a + b`",$propdoc:{left:"[AST_Node] left-hand side expression",operator:"[string] the operator",right:"[AST_Node] right-hand side expression"},_walk:function(n){return n._visit(this,function(){this.left._walk(n),this.right._walk(n)})}}),Nn=F("Conditional","condition consequent alternative",{$documentation:"Conditional expression using the ternary operator, i.e. `a ? b : c`",$propdoc:{condition:"[AST_Node]",consequent:"[AST_Node]",alternative:"[AST_Node]"},_walk:function(n){return n._visit(this,function(){this.condition._walk(n),this.consequent._walk(n),this.alternative._walk(n)})}}),Hn=F("Assign",null,{$documentation:"An assignment expression \u2014 `a = b + 5`"},In),Pn=F("DefaultAssign",null,{$documentation:"A default assignment expression like in `(a = 3) => a`"},In),Rn=F("Array","elements",{$documentation:"An array literal",$propdoc:{elements:"[AST_Node*] array of elements"},_walk:function(n){return n._visit(this,function(){for(var e=this.elements,t=0,i=e.length;t<i;t++)e[t]._walk(n)})}}),jn=F("Object","properties",{$documentation:"An object literal",$propdoc:{properties:"[AST_ObjectProperty*] array of properties"},_walk:function(n){return n._visit(this,function(){for(var e=this.properties,t=0,i=e.length;t<i;t++)e[t]._walk(n)})}}),Un=F("ObjectProperty","key value",{$documentation:"Base class for literal object properties",$propdoc:{key:"[string|AST_Node] property name. For ObjectKeyVal this is a string. For getters, setters and computed property this is an AST_Node.",value:"[AST_Node] property value.  For getters and setters this is an AST_Accessor."},_walk:function(n){return n._visit(this,function(){this.key instanceof A&&this.key._walk(n),this.value._walk(n)})}}),Ln=F("ObjectKeyVal","quote",{$documentation:"A key: value object property",$propdoc:{quote:"[string] the original quote character"}},Un),Yn=F("ObjectSetter","quote static",{$propdoc:{quote:"[string|undefined] the original quote character, if any",static:"[boolean] whether this is a static setter (classes only)"},$documentation:"An object setter property"},Un),Vn=F("ObjectGetter","quote static",{$propdoc:{quote:"[string|undefined] the original quote character, if any",static:"[boolean] whether this is a static getter (classes only)"},$documentation:"An object getter property"},Un),Wn=F("ConciseMethod","quote static is_generator async",{$propdoc:{quote:"[string|undefined] the original quote character, if any",static:"[boolean] is this method static (classes only)",is_generator:"[boolean] is this a generator method",async:"[boolean] is this method async"},$documentation:"An ES6 concise method inside an object or class"},Un),Xn=F("Class","name extends properties inlined",{$propdoc:{name:"[AST_SymbolClass|AST_SymbolDefClass?] optional class name.",extends:"[AST_Node]? optional parent class",properties:"[AST_ObjectProperty*] array of properties"},$documentation:"An ES6 class",_walk:function(n){return n._visit(this,function(){this.name&&this.name._walk(n),this.extends&&this.extends._walk(n),this.properties.forEach(function(e){e._walk(n)})})}},V),Jn=F("DefClass",null,{$documentation:"A class definition"},Xn),Zn=F("ClassExpression",null,{$documentation:"A class expression."},Xn),Qn=F("Symbol","scope name thedef",{$propdoc:{name:"[string] name of this symbol",scope:"[AST_Scope/S] the current scope (not necessarily the definition scope)",thedef:"[SymbolDef/S] the definition of this symbol"},$documentation:"Base class for all symbols"}),Kn=F("NewTarget",null,{$documentation:"A reference to new.target"}),Gn=F("SymbolDeclaration","init",{$documentation:"A declaration symbol (symbol in var/const, function name or argument, symbol in catch)"},Qn),ne=F("SymbolVar",null,{$documentation:"Symbol defining a variable"},Gn),ee=F("SymbolBlockDeclaration",null,{$documentation:"Base class for block-scoped declaration symbols"},Gn),te=F("SymbolConst",null,{$documentation:"A constant declaration"},ee),ie=F("SymbolLet",null,{$documentation:"A block-scoped `let` declaration"},ee),re=F("SymbolFunarg",null,{$documentation:"Symbol naming a function argument"},ne),oe=F("SymbolDefun",null,{$documentation:"Symbol defining a function"},Gn),ae=F("SymbolMethod",null,{$documentation:"Symbol in an object defining a method"},Qn),ue=F("SymbolLambda",null,{$documentation:"Symbol naming a function expression"},Gn),se=F("SymbolDefClass",null,{$documentation:"Symbol naming a class's name in a class declaration. Lexically scoped to its containing scope, and accessible within the class."},ee),ce=F("SymbolClass",null,{$documentation:"Symbol naming a class's name. Lexically scoped to the class."},Gn),fe=F("SymbolCatch",null,{$documentation:"Symbol naming the exception in catch"},ee),le=F("SymbolImport",null,{$documentation:"Symbol referring to an imported name"},ee),pe=F("SymbolImportForeign",null,{$documentation:"A symbol imported from a module, but it is defined in the other module, and its real name is irrelevant for this module's purposes"},Qn),he=F("Label","references",{$documentation:"Symbol naming a label (declaration)",$propdoc:{references:"[AST_LoopControl*] a list of nodes referring to this label"},initialize:function(){this.references=[],this.thedef=this}},Qn),de=F("SymbolRef",null,{$documentation:"Reference to some symbol (not definition/declaration)"},Qn),me=F("SymbolExport",null,{$documentation:"Symbol referring to a name to export"},de),ve=F("SymbolExportForeign",null,{$documentation:"A symbol exported from this module, but it is used in the other module, and its real name is irrelevant for this module's purposes"},Qn),De=F("LabelRef",null,{$documentation:"Reference to a label symbol"},Qn),ge=F("This",null,{$documentation:"The `this` symbol"},Qn),_e=F("Super",null,{$documentation:"The `super` symbol"},ge),ye=F("Constant",null,{$documentation:"Base class for all constants",getValue:function(){return this.value}}),be=F("String","value quote",{$documentation:"A string literal",$propdoc:{value:"[string] the contents of this string",quote:"[string] the original quote character"}},ye),Ee=F("Number","value literal",{$documentation:"A number literal",$propdoc:{value:"[number] the numeric value",literal:"[string] numeric value as string (optional)"}},ye),we=F("RegExp","value",{$documentation:"A regexp literal",$propdoc:{value:"[RegExp] the actual regexp"}},ye),Fe=F("Atom",null,{$documentation:"Base class for atoms"},ye),Ce=F("Null",null,{$documentation:"The `null` atom",value:null},Fe),Ae=F("NaN",null,{$documentation:"The impossible value",value:NaN},Fe),xe=F("Undefined",null,{$documentation:"The `undefined` value",value:void 0},Fe),ke=F("Hole",null,{$documentation:"A hole in an array",value:void 0},Fe),Be=F("Infinity",null,{$documentation:"The `Infinity` value",value:1/0},Fe),Oe=F("Boolean",null,{$documentation:"Base class for booleans"},Fe),$e=F("False",null,{$documentation:"The `false` atom",value:!1},Oe),Me=F("True",null,{$documentation:"The `true` atom",value:!0},Oe),ze=F("Await","expression",{$documentation:"An `await` statement",$propdoc:{expression:"[AST_Node] the mandatory expression being awaited"},_walk:function(n){return n._visit(this,function(){this.expression._walk(n)})}}),qe=F("Yield","expression is_star",{$documentation:"A `yield` statement",$propdoc:{expression:"[AST_Node?] the value returned or thrown by this statement; could be null (representing undefined) but only when is_star is set to false",is_star:"[Boolean] Whether this is a yield or yield* statement"},_walk:function(n){return n._visit(this,this.expression&&function(){this.expression._walk(n)})}});function Te(n){this.visit=n,this.stack=[],this.directives=Object.create(null)}Te.prototype={_visit:function(n,e){this.push(n);var t=this.visit(n,e?function(){e.call(n)}:s);return!t&&e&&e.call(n),this.pop(),t},parent:function(n){return this.stack[this.stack.length-2-(n||0)]},push:function(n){n instanceof J?this.directives=Object.create(this.directives):n instanceof B&&!this.directives[n.value]?this.directives[n.value]=n:n instanceof Xn&&(this.directives=Object.create(this.directives),this.directives["use strict"]||(this.directives["use strict"]=n)),this.stack.push(n)},pop:function(){var n=this.stack.pop();(n instanceof J||n instanceof Xn)&&(this.directives=Object.getPrototypeOf(this.directives))},self:function(){return this.stack[this.stack.length-1]},find_parent:function(n){for(var e=this.stack,t=e.length;--t>=0;){var i=e[t];if(i instanceof n)return i}},has_directive:function(n){var e=this.directives[n];if(e)return e;var t=this.stack[this.stack.length-1];if(t instanceof V&&t.body)for(var i=0;i<t.body.length;++i){var r=t.body[i];if(!(r instanceof B))break;if(r.value==n)return r}},loopcontrol_target:function(n){var e=this.stack;if(n.label)for(var t=e.length;--t>=0;){if((i=e[t])instanceof I&&i.label.name==n.label.name)return i.body}else for(t=e.length;--t>=0;){var i;if((i=e[t])instanceof N||n instanceof fn&&i instanceof hn)return i}}};var Se="break case catch class const continue debugger default delete do else export extends finally for function if in instanceof let new return switch throw try typeof var void while with",Ie="false null true",Ne="enum implements import interface package private protected public static super this "+Ie+" "+Se,He="return new delete throw else case yield await";Se=g(Se),Ne=g(Ne),He=g(He),Ie=g(Ie);var Pe=g(e("+-*&%=<>!?|~^")),Re=/[0-9a-f]/i,je=/^0x[0-9a-f]+$/i,Ue=/^0[0-7]+$/,Le=/^0o[0-7]+$/i,Ye=/^0b[01]+$/i,Ve=/^\d*\.?\d*(?:e[+-]?\d*(?:\d\.?|\.?\d)\d*)?$/i,We=g(["in","instanceof","typeof","new","void","delete","++","--","+","-","!","~","&","|","^","*","**","/","%",">>","<<",">>>","<",">","<=",">=","==","===","!=","!==","?","=","+=","-=","/=","*=","**=","%=",">>=","<<=",">>>=","|=","^=","&=","&&","||"]),Xe=g(e(" \xa0\n\r\t\f\v\u200b\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000\ufeff")),Je=g(e("\n\r\u2028\u2029")),Ze=g(e(";]),:")),Qe=g(e("[{(,;:")),Ke=g(e("[]{}(),;:")),Ge={ID_Start:/[A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,ID_Continue:/[0-9A-Z_a-z\xAA\xB5\xB7\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1369-\u1371\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFC-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C4\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDEC0-\uDEF8]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/};function nt(n,e){var t=n.charAt(e);if(et(t)){var i=n.charAt(e+1);if(tt(i))return t+i}if(tt(t)){var r=n.charAt(e-1);if(et(r))return r+t}return t}function et(n){return"string"==typeof n&&(n=n.charCodeAt(0)),n>=55296&&n<=56319}function tt(n){return"string"==typeof n&&(n=n.charCodeAt(0)),n>=56320&&n<=57343}function it(n){return n>=48&&n<=57}function rt(n){return"string"==typeof n&&!Ne(n)}function ot(n){var e=n.charCodeAt(0);return Ge.ID_Start.test(n)||36==e||95==e}function at(n){var e=n.charCodeAt(0);return Ge.ID_Continue.test(n)||36==e||95==e||8204==e||8205==e}function ut(n){return/^[a-z_$][a-z0-9_$]*$/i.test(n)}function st(n,e,t,i,r){this.message=n,this.filename=e,this.line=t,this.col=i,this.pos=r}function ct(n,e,t,i,r){throw new st(n,e,t,i,r)}function ft(n,e,t){return n.type==e&&(null==t||n.value==t)}st.prototype=Object.create(Error.prototype),st.prototype.constructor=st,st.prototype.name="SyntaxError",r(st);var lt={};function pt(n,e,t,i){var r={text:n,filename:e,pos:0,tokpos:0,line:1,tokline:0,col:0,tokcol:0,newline_before:!1,regex_allowed:!1,brace_counter:0,template_braces:[],comments_before:[],directives:{},directive_stack:[]};function o(){return nt(r.text,r.pos)}function a(n,e){var t=nt(r.text,r.pos++);if(n&&!t)throw lt;return Je(t)?(r.newline_before=r.newline_before||!e,++r.line,r.col=0,e||"\r"!=t||"\n"!=o()||(++r.pos,t="\n")):(t.length>1&&(++r.pos,++r.col),++r.col),t}function u(n){for(;n-- >0;)a()}function s(n){return r.text.substr(r.pos,n.length)==n}function c(n,e){var t=r.text.indexOf(n,r.pos);if(e&&-1==t)throw lt;return t}function f(){r.tokline=r.line,r.tokcol=r.col,r.tokpos=r.pos}var l=!1,p=null;function h(t,i,o){r.regex_allowed="operator"==t&&!dt(i)||"keyword"==t&&He(i)||"punc"==t&&Qe(i)||"arrow"==t,"punc"==t&&"."==i?l=!0:o||(l=!1);var a={type:t,value:i,line:r.tokline,col:r.tokcol,pos:r.tokpos,endline:r.line,endcol:r.col,endpos:r.pos,nlb:r.newline_before,file:e};return/^(?:num|string|regexp)$/i.test(t)&&(a.raw=n.substring(a.pos,a.endpos)),o||(a.comments_before=r.comments_before,a.comments_after=r.comments_before=[]),r.newline_before=!1,a=new C(a),o||(p=a),a}function d(){for(;Xe(o());)a()}function m(n){ct(n,e,r.tokline,r.tokcol,r.tokpos)}function v(n){var e=!1,t=!1,i=!1,r="."==n,u=function(n){for(var e,t="",i=0;(e=o())&&n(e,i++);)t+=a();return t}(function(o,a){switch(o.charCodeAt(0)){case 98:case 66:return i=!0;case 111:case 79:case 120:case 88:return!i&&(i=!0);case 101:case 69:return!!i||!e&&(e=t=!0);case 45:return t||0==a&&!n;case 43:return t;case t=!1,46:return!(r||i||e)&&(r=!0)}return Re.test(o)});n&&(u=n+u),Ue.test(u)&&B.has_directive("use strict")&&m("Legacy octal literals are not allowed in strict mode");var s=function(n){if(je.test(n))return parseInt(n.substr(2),16);if(Ue.test(n))return parseInt(n.substr(1),8);if(Le.test(n))return parseInt(n.substr(2),8);if(Ye.test(n))return parseInt(n.substr(2),2);if(Ve.test(n))return parseFloat(n);var e=parseFloat(n);return e==n?e:void 0}(u);if(!isNaN(s))return h("num",s);m("Invalid syntax: "+u)}function D(n,e,t){var i,u=a(!0,n);switch(u.charCodeAt(0)){case 110:return"\n";case 114:return"\r";case 116:return"\t";case 98:return"\b";case 118:return"\v";case 102:return"\f";case 120:return String.fromCharCode(g(2,e));case 117:if("{"==o()){for(a(!0),"}"===o()&&m("Expecting hex-character between {}");"0"==o();)a(!0);var s,f=c("}",!0)-r.pos;return(f>6||(s=g(f,e))>1114111)&&m("Unicode reference out of bounds"),a(!0),(i=s)>65535?(i-=65536,String.fromCharCode(55296+(i>>10))+String.fromCharCode(i%1024+56320)):String.fromCharCode(i)}return String.fromCharCode(g(4,e));case 10:return"";case 13:if("\n"==o())return a(!0,n),""}return u>="0"&&u<="7"?(t&&e&&m("Octal escape sequences are not allowed in template strings"),function(n,e){var t=o();t>="0"&&t<="7"&&(n+=a(!0))[0]<="3"&&(t=o())>="0"&&t<="7"&&(n+=a(!0));if("0"===n)return"\0";n.length>0&&B.has_directive("use strict")&&e&&m("Legacy octal escape sequences are not allowed in strict mode");return String.fromCharCode(parseInt(n,8))}(u,e)):u}function g(n,e){for(var t=0;n>0;--n){if(!e&&isNaN(parseInt(o(),16)))return parseInt(t,16)||"";var i=a(!0);isNaN(parseInt(i,16))&&m("Invalid hex-character pattern in string"),t+=i}return parseInt(t,16)}var _=k("Unterminated string constant",function(n){for(var e=a(),t="";;){var i=a(!0,!0);if("\\"==i)i=D(!0,!0);else if(Je(i))m("Unterminated string constant");else if(i==e)break;t+=i}var r=h("string",t);return r.quote=n,r}),y=k("Unterminated template",function(n){n&&r.template_braces.push(r.brace_counter);var e,t,i="",u="";for(a(!0,!0);"`"!=(e=a(!0,!0));){if("\r"==e)"\n"==o()&&++r.pos,e="\n";else if("$"==e&&"{"==o())return a(!0,!0),r.brace_counter++,(t=h(n?"template_head":"template_substitution",i)).begin=n,t.raw=u,t.end=!1,t;if(u+=e,"\\"==e){var s=r.pos;e=D(!0,!("name"===p.type||"punc"===p.type&&(")"===p.value||"]"===p.value)),!0),u+=r.text.substr(s,r.pos-s)}i+=e}return r.template_braces.pop(),(t=h(n?"template_head":"template_substitution",i)).begin=n,t.raw=u,t.end=!0,t});function b(n){var e,t=r.regex_allowed,i=function(){for(var n=r.text,e=r.pos,t=r.text.length;e<t;++e){var i=n[e];if(Je(i))return e}return-1}();return-1==i?(e=r.text.substr(r.pos),r.pos=r.text.length):(e=r.text.substring(r.pos,i),r.pos=i),r.col=r.tokcol+(r.pos-r.tokpos),r.comments_before.push(h(n,e,!0)),r.regex_allowed=t,B}var E=k("Unterminated multiline comment",function(){var n=r.regex_allowed,e=c("*/",!0),t=r.text.substring(r.pos,e).replace(/\r\n|\r|\u2028|\u2029/g,"\n");return u(function(n){for(var e=0,t=0;t<n.length;t++)et(n.charCodeAt(t))&&tt(n.charCodeAt(t+1))&&(e++,t++);return n.length-e}(t)+2),r.comments_before.push(h("comment2",t,!0)),r.newline_before=r.newline_before||t.indexOf("\n")>=0,r.regex_allowed=n,B}),w=k("Unterminated identifier name",function(){var n,e="",t=!1,i=function(){return t=!0,a(),"u"!==o()&&m("Expecting UnicodeEscapeSequence -- uXXXX or u{XXXX}"),D(!1,!0)};if("\\"===(e=o()))ot(e=i())||m("First identifier char is an invalid identifier char");else{if(!ot(e))return"";a()}for(;null!=(n=o());){if("\\"===(n=o()))at(n=i())||m("Invalid escaped identifier char");else{if(!at(n))break;a()}e+=n}return Ne(e)&&t&&m("Escaped characters are not allowed in keywords"),e}),F=k("Unterminated regular expression",function(n){for(var e,t=!1,i=!1;e=a(!0);)if(Je(e))m("Unexpected line terminator");else if(t)n+="\\"+e,t=!1;else if("["==e)i=!0,n+=e;else if("]"==e&&i)i=!1,n+=e;else{if("/"==e&&!i)break;"\\"==e?t=!0:n+=e}var r=w();try{var o=new RegExp(n,r);return o.raw_source="/"+n+"/"+r,h("regexp",o)}catch(n){m(n.message)}});function A(n){return h("operator",function n(e){if(!o())return e;var t=e+o();return We(t)?(a(),n(t)):e}(n||a()))}function x(){switch(a(),o()){case"/":return a(),b("comment1");case"*":return a(),E()}return r.regex_allowed?F(""):A("/")}function k(n,e){return function(t){try{return e(t)}catch(e){if(e!==lt)throw e;m(n)}}}function B(n){if(null!=n)return F(n);for(i&&0==r.pos&&s("#!")&&(f(),u(2),b("comment5"));;){if(d(),f(),t){if(s("\x3c!--")){u(4),b("comment3");continue}if(s("--\x3e")&&r.newline_before){u(3),b("comment4");continue}}var e=o();if(!e)return h("eof");var c=e.charCodeAt(0);switch(c){case 34:case 39:return _(e);case 46:return a(),it(o().charCodeAt(0))?v("."):"."===o()?(a(),a(),h("expand","...")):h("punc",".");case 47:var p=x();if(p===B)continue;return p;case 61:return a(),">"===o()?(a(),h("arrow","=>")):A("=");case 96:return y(!0);case 123:r.brace_counter++;break;case 125:if(r.brace_counter--,r.template_braces.length>0&&r.template_braces[r.template_braces.length-1]===r.brace_counter)return y(!1)}if(it(c))return v();if(Ke(e))return h("punc",a());if(Pe(e))return A();if(92==c||ot(e))return D=void 0,D=w(),l?h("name",D):Ie(D)?h("atom",D):Se(D)?We(D)?h("operator",D):h("keyword",D):h("name",D);break}var D;m("Unexpected character '"+e+"'")}return B.next=a,B.peek=o,B.context=function(n){return n&&(r=n),r},B.add_directive=function(n){r.directive_stack[r.directive_stack.length-1].push(n),void 0===r.directives[n]?r.directives[n]=1:r.directives[n]++},B.push_directives_stack=function(){r.directive_stack.push([])},B.pop_directives_stack=function(){for(var n=r.directive_stack[r.directive_stack.length-1],e=0;e<n.length;e++)r.directives[n[e]]--;r.directive_stack.pop()},B.has_directive=function(n){return r.directives[n]>0},B}var ht=g(["typeof","void","delete","--","++","!","~","-","+"]),dt=g(["--","++"]),mt=g(["=","+=","-=","/=","*=","**=","%=",">>=","<<=",">>>=","|=","^=","&="]),vt=function(n,e){for(var t=0;t<n.length;++t)for(var i=n[t],r=0;r<i.length;++r)e[i[r]]=t+1;return e}([["||"],["&&"],["|"],["^"],["&"],["==","===","!=","!=="],["<",">","<=",">=","in","instanceof"],[">>","<<",">>>"],["+","-"],["*","/","%"],["**"]],{}),Dt=g(["atom","num","string","regexp","name"]);function gt(n,e){e=a(e,{bare_returns:!1,ecma:8,expression:!1,filename:null,html5_comments:!0,module:!1,shebang:!0,strict:!1,toplevel:null},!0);var t={input:"string"==typeof n?pt(n,e.filename,e.html5_comments,e.shebang):n,token:null,prev:null,peeked:null,in_function:0,in_async:-1,in_generator:-1,in_directives:!0,in_loop:0,labels:[]};function r(n,e){return ft(t.token,n,e)}function o(){return t.peeked||(t.peeked=t.input())}function u(){return t.prev=t.token,t.peeked||o(),t.token=t.peeked,t.peeked=null,t.in_directives=t.in_directives&&("string"==t.token.type||r("punc",";")),t.token}function s(){return t.prev}function c(n,e,i,r){var o=t.input.context();ct(n,o.filename,null!=e?e:o.tokline,null!=i?i:o.tokcol,null!=r?r:o.tokpos)}function f(n,e){c(e,n.line,n.col)}function l(n){null==n&&(n=t.token),f(n,"Unexpected token: "+n.type+" ("+n.value+")")}function p(n,e){if(r(n,e))return u();f(t.token,"Unexpected token "+t.token.type+" \xab"+t.token.value+"\xbb, expected "+n+" \xab"+e+"\xbb")}function h(n){return p("punc",n)}function d(n){return n.nlb||!_(n.comments_before,function(n){return!n.nlb})}function m(){return!e.strict&&(r("eof")||r("punc","}")||d(t.token))}function v(){return t.in_generator===t.in_function}function D(){return t.in_async===t.in_function}function g(n){r("punc",";")?u():n||m()||l()}function y(){h("(");var n=tt(!0);return h(")"),n}function E(n){return function(){var e=t.token,i=n.apply(null,arguments),r=s();return i.start=e,i.end=r,i}}function w(){(r("operator","/")||r("operator","/="))&&(t.peeked=null,t.token=t.input(t.token.value.substr(1)))}t.token=u();var F=E(function(n,a,v){switch(w(),t.token.type){case"string":if(t.in_directives){var _=o();-1==t.token.raw.indexOf("\\")&&(ft(_,"punc",";")||ft(_,"punc","}")||d(_)||ft(_,"eof"))?t.input.add_directive(t.token.value):t.in_directives=!1}var b=t.in_directives,E=C();return b&&E.body instanceof be?new B(E.body):E;case"template_head":case"num":case"regexp":case"operator":case"atom":return C();case"name":if("async"==t.token.value&&ft(o(),"keyword","function"))return u(),u(),a&&c("functions are not allowed as the body of a loop"),M(G,!1,!0,n);if("import"==t.token.value&&!ft(o(),"punc","(")){u();var A=function(){var n,e,i=s();r("name")&&(n=Le(le));r("punc",",")&&u();((e=Pe(!0))||n)&&p("name","from");var o=t.token;"string"!==o.type&&l();return u(),new Cn({start:i,imported_name:n,imported_names:e,module_name:new be({start:o,value:o.value,quote:o.quote,end:o}),end:t.token})}();return g(),A}return ft(o(),"punc",":")?function(){var n=Le(he);"await"===n.name&&D()&&f(t.prev,"await cannot be used as label inside async function");i(function(e){return e.name==n.name},t.labels)&&c("Label "+n.name+" defined twice");h(":"),t.labels.push(n);var e=F();t.labels.pop(),e instanceof N||n.references.forEach(function(e){e instanceof ln&&(e=e.label.start,c("Continue label `"+n.name+"` refers to non-IterationStatement.",e.line,e.col,e.pos))});return new I({body:e,label:n})}():C();case"punc":switch(t.token.value){case"{":return new q({start:t.token,body:on(),end:s()});case"[":case"(":return C();case";":return t.in_directives=!1,u(),new T;default:l()}case"keyword":switch(t.token.value){case"break":return u(),x(fn);case"continue":return u(),x(ln);case"debugger":return u(),g(),new k;case"do":u();var $=it(F);p("keyword","while");var z=y();return g(!0),new P({body:$,condition:z});case"while":return u(),new R({condition:y(),body:it(function(){return F(!1,!0)})});case"for":return u(),function(){var n="`for await` invalid in this context",e=t.token;"name"==e.type&&"await"==e.value?(D()||f(e,n),u()):e=!1;h("(");var i=null;if(r("punc",";"))e&&f(e,n);else{i=r("keyword","var")?(u(),dn(!0)):r("keyword","let")?(u(),qn(!0)):r("keyword","const")?(u(),Xn(!0)):tt(!0,!0);var o=r("operator","in"),a=r("name","of");if(e&&!a&&f(e,n),o||a)return i instanceof yn?i.definitions.length>1&&f(i.start,"Only one variable declaration allowed in for..in loop"):Ge(i)||(i=nt(i))instanceof nn||f(i.start,"Invalid left-hand side in for..in loop"),u(),o?function(n){var e=tt(!0);return h(")"),new U({init:n,object:e,body:it(function(){return F(!1,!0)})})}(i):function(n,e){var t=n instanceof yn?n.definitions[0].name:null,i=tt(!0);return h(")"),new L({await:e,init:n,name:t,object:i,body:it(function(){return F(!1,!0)})})}(i,!!e)}return function(n){h(";");var e=r("punc",";")?null:tt(!0);h(";");var t=r("punc",")")?null:tt(!0);return h(")"),new j({init:n,condition:e,step:t,body:it(function(){return F(!1,!0)})})}(i)}();case"class":return u(),a&&c("classes are not allowed as the body of a loop"),v&&c("classes are not allowed as the body of an if"),Te(Jn);case"function":return u(),a&&c("functions are not allowed as the body of a loop"),M(G,!1,!1,n);case"if":return u(),function(){var n=y(),e=F(!1,!1,!0),t=null;r("keyword","else")&&(u(),t=F(!1,!1,!0));return new pn({condition:n,body:e,alternative:t})}();case"return":0!=t.in_function||e.bare_returns||c("'return' outside of function"),u();var H=null;return r("punc",";")?u():m()||(H=tt(!0),g()),new un({value:H});case"switch":return u(),new hn({expression:y(),body:it(an)});case"throw":u(),d(t.token)&&c("Illegal newline after 'throw'");H=tt(!0);return g(),new sn({value:H});case"try":return u(),function(){var n=on(),e=null,i=null;if(r("keyword","catch")){var o=t.token;if(u(),r("punc","{"))var a=null;else{h("(");var a=S(void 0,fe);h(")")}e=new gn({start:o,argname:a,body:on(),end:s()})}if(r("keyword","finally")){var o=t.token;u(),i=new _n({start:o,body:on(),end:s()})}e||i||c("Missing catch/finally blocks");return new Dn({body:n,bcatch:e,bfinally:i})}();case"var":u();A=dn();return g(),A;case"let":u();A=qn();return g(),A;case"const":u();A=Xn();return g(),A;case"with":return t.input.has_directive("use strict")&&c("Strict mode may not include a with statement"),u(),new Y({expression:y(),body:F()});case"export":if(!ft(o(),"punc","(")){u();A=function(){var n,e,i,a,c,f=t.token;if(r("keyword","default"))n=!0,u();else if(e=Pe(!1)){if(r("name","from")){u();var p=t.token;return"string"!==p.type&&l(),u(),new An({start:f,is_default:n,exported_names:e,module_name:new be({start:p,value:p.value,quote:p.quote,end:p}),end:s()})}return new An({start:f,is_default:n,exported_names:e,end:s()})}r("punc","{")||n&&(r("keyword","class")||r("keyword","function"))&&ft(o(),"punc")?(a=tt(!1),g()):(i=F(n))instanceof yn&&n?l(i.start):i instanceof yn||i instanceof J||i instanceof Jn?c=i:i instanceof O?a=i.body:l(i.start);return new An({start:f,is_default:n,exported_value:a,exported_definition:c,end:s()})}();return r("punc",";")&&g(),A}}}l()});function C(n){return new O({body:(n=tt(!0),g(),n)})}function x(n){var e,r=null;m()||(r=Le(De,!0)),null!=r?((e=i(function(n){return n.name==r.name},t.labels))||c("Undefined label "+r.name),r.thedef=e):0==t.in_loop&&c(n.TYPE+" not inside a loop or switch"),g();var o=new n({label:r});return e&&e.references.push(o),o}var $=function(n,e,i){d(t.token)&&c("Unexpected newline before arrow (=>)"),p("arrow","=>");var o=V(r("punc","{"),!1,i),a=o instanceof Array&&o.length?o[o.length-1].end:o instanceof Array?n:o.end;return new K({start:n,end:a,async:i,argnames:e,body:o})},M=function(n,e,i,o){t.token;var a=n===G,c=r("operator","*");c&&u();var f=r("name")?Le(a?oe:ue):null;a&&!f&&(o?n=Q:l()),!f||n===Z||f instanceof Gn||l(s());var p=[],h=V(!0,c||e,i,f,p);return new n({start:p.start,end:h.end,is_generator:c,async:i,name:f,argnames:p,body:h})};function z(n,e){var t={},i=!1,r=!1,o=!1,a=!!e,u={add_parameter:function(e){if(void 0!==t["$"+e.value])!1===i&&(i=e),u.check_strict();else if(t["$"+e.value]=!0,n)switch(e.value){case"arguments":case"eval":case"yield":a&&f(e,"Unexpected "+e.value+" identifier as parameter inside strict mode");break;default:Ne(e.value)&&l()}},mark_default_assignment:function(n){!1===r&&(r=n)},mark_spread:function(n){!1===o&&(o=n)},mark_strict_mode:function(){a=!0},is_strict:function(){return!1!==r||!1!==o||a},check_strict:function(){u.is_strict()&&!1!==i&&f(i,"Parameter "+i.value+" was used already")}};return u}function S(n,e){var i,o=!1;return void 0===n&&(n=z(!0,t.input.has_directive("use strict"))),r("expand","...")&&(o=t.token,n.mark_spread(t.token),u()),i=H(n,e),r("operator","=")&&!1===o&&(n.mark_default_assignment(t.token),u(),i=new Pn({start:i.start,left:i,operator:"=",right:tt(!1),end:t.token})),!1!==o&&(r("punc",")")||l(),i=new X({start:o,expression:i,end:o})),n.check_strict(),i}function H(n,e){var i,a=[],f=!0,p=!1,d=t.token;if(void 0===n&&(n=z(!1,t.input.has_directive("use strict"))),e=void 0===e?re:e,r("punc","[")){for(u();!r("punc","]");){if(f?f=!1:h(","),r("expand","...")&&(p=!0,i=t.token,n.mark_spread(t.token),u()),r("punc"))switch(t.token.value){case",":a.push(new ke({start:t.token,end:t.token}));continue;case"]":break;case"[":case"{":a.push(H(n,e));break;default:l()}else r("name")?(n.add_parameter(t.token),a.push(Le(e))):c("Invalid function parameter");r("operator","=")&&!1===p&&(n.mark_default_assignment(t.token),u(),a[a.length-1]=new Pn({start:a[a.length-1].start,left:a[a.length-1],operator:"=",right:tt(!1),end:t.token})),p&&(r("punc","]")||c("Rest element must be last element"),a[a.length-1]=new X({start:i,expression:a[a.length-1],end:i}))}return h("]"),n.check_strict(),new nn({start:d,names:a,is_array:!0,end:s()})}if(r("punc","{")){for(u();!r("punc","}");){if(f?f=!1:h(","),r("expand","...")&&(p=!0,i=t.token,n.mark_spread(t.token),u()),r("name")&&(ft(o(),"punc")||ft(o(),"operator"))&&-1!==[",","}","="].indexOf(o().value)){n.add_parameter(t.token);var m=s(),v=Le(e);p?a.push(new X({start:i,expression:v,end:v.end})):a.push(new Ln({start:m,key:v.name,value:v,end:v.end}))}else{if(r("punc","}"))continue;var D=t.token,g=Re();null===g?l(s()):"name"!==s().type||r("punc",":")?(h(":"),a.push(new Ln({start:D,quote:D.quote,key:g,value:H(n,e),end:s()}))):a.push(new Ln({start:s(),key:g,value:new e({start:s(),name:g,end:s()}),end:s()}))}p?r("punc","}")||c("Rest element must be last element"):r("operator","=")&&(n.mark_default_assignment(t.token),u(),a[a.length-1].value=new Pn({start:a[a.length-1].value.start,left:a[a.length-1].value,operator:"=",right:tt(!1),end:t.token}))}return h("}"),n.check_strict(),new nn({start:d,names:a,is_array:!1,end:s()})}if(r("name"))return n.add_parameter(t.token),Le(e);c("Invalid function parameter")}function V(n,i,o,a,s){var c=t.in_loop,f=t.labels,p=t.in_generator,d=t.in_async;if(++t.in_function,i&&(t.in_generator=t.in_function),o&&(t.in_async=t.in_function),s&&function(n){t.token;var i=z(!0,t.input.has_directive("use strict"));for(h("(");!r("punc",")");){var o=S(i);if(n.push(o),r("punc",")")||(h(","),r("punc",")")&&e.ecma<8&&l()),o instanceof X)break}u()}(s),n&&(t.in_directives=!0),t.in_loop=0,t.labels=[],n){t.input.push_directives_stack();var m=on();a&&Ue(a),s&&s.forEach(Ue),t.input.pop_directives_stack()}else m=tt(!1);return--t.in_function,t.in_loop=c,t.labels=f,t.in_generator=p,t.in_async=d,m}function on(){h("{");for(var n=[];!r("punc","}");)r("eof")&&l(),n.push(F());return u(),n}function an(){h("{");for(var n,e=[],i=null,o=null;!r("punc","}");)r("eof")&&l(),r("keyword","case")?(o&&(o.end=s()),i=[],o=new vn({start:(n=t.token,u(),n),expression:tt(!0),body:i}),e.push(o),h(":")):r("keyword","default")?(o&&(o.end=s()),i=[],o=new mn({start:(n=t.token,u(),h(":"),n),body:i}),e.push(o)):(i||l(),i.push(F()));return o&&(o.end=s()),u(),e}function cn(n,e){for(var i,o=[];;){var a="var"===e?ne:"const"===e?te:"let"===e?ie:null;if(r("punc","{")||r("punc","[")?i=new xn({start:t.token,name:H(void 0,a),value:r("operator","=")?(p("operator","="),tt(!1,n)):null,end:s()}):"import"==(i=new xn({start:t.token,name:Le(a),value:r("operator","=")?(u(),tt(!1,n)):n||"const"!==e?null:c("Missing initializer in const declaration"),end:s()})).name.name&&c("Unexpected token: import"),o.push(i),!r("punc",","))break;u()}return o}var dn=function(n){return new bn({start:s(),definitions:cn(n,"var"),end:s()})},qn=function(n){return new En({start:s(),definitions:cn(n,"let"),end:s()})},Xn=function(n){return new wn({start:s(),definitions:cn(n,"const"),end:s()})};function Qn(){var n,e=t.token;switch(e.type){case"name":n=je(de);break;case"num":n=new Ee({start:e,end:e,value:e.value});break;case"string":n=new be({start:e,end:e,value:e.value,quote:e.quote});break;case"regexp":n=new we({start:e,end:e,value:e.value});break;case"atom":switch(e.value){case"false":n=new $e({start:e,end:e});break;case"true":n=new Me({start:e,end:e});break;case"null":n=new Ce({start:e,end:e})}}return u(),n}function ee(n,e,t,i){var r=function(n,e){return e?new Pn({start:n.start,left:n,operator:"=",right:e,end:e.end}):n};return n instanceof jn?r(new nn({start:n.start,end:n.end,is_array:!1,names:n.properties.map(ee)}),i):n instanceof Ln?(n.value=ee(n.value,0,[n.key]),r(n,i)):n instanceof ke?n:n instanceof nn?(n.names=n.names.map(ee),r(n,i)):n instanceof de?r(new re({name:n.name,start:n.start,end:n.end}),i):n instanceof X?(n.expression=ee(n.expression),r(n,i)):n instanceof Rn?r(new nn({start:n.start,end:n.end,is_array:!0,names:n.elements.map(ee)}),i):n instanceof Hn?r(ee(n.left,void 0,void 0,n.right),i):n instanceof Pn?(n.left=ee(n.left,0,[n.left]),n):void c("Invalid function parameter",n.start.line,n.start.col)}var ye=function(n,i){if(r("operator","new"))return function(n){var i=t.token;if(p("operator","new"),r("punc","."))return u(),p("name","target"),Ve(new Kn({start:i,end:s()}),n);var o,a=ye(!1);r("punc","(")?(u(),o=Ae(")",e.ecma>=8)):o=[];var c=new Bn({start:i,expression:a,args:o,end:s()});return Ye(c),Ve(c,n)}(n);var a,c=t.token,f=r("name","async")&&"["!=(a=o()).value&&"arrow"!=a.type&&Qn();if(r("punc")){switch(t.token.value){case"(":if(f&&!n)break;var d=function(n,i){var o,a,c,f=[];for(h("(");!r("punc",")");)o&&l(o),r("expand","...")?(o=t.token,i&&(a=t.token),u(),f.push(new X({start:s(),expression:tt(),end:t.token}))):f.push(tt()),r("punc",")")||(h(","),r("punc",")")&&(e.ecma<8&&l(),c=s(),i&&(a=c)));return h(")"),n&&r("arrow","=>")?o&&c&&l(c):a&&l(a),f}(i,!f);if(i&&r("arrow","=>"))return $(c,d.map(ee),!!f);var m=f?new kn({expression:f,args:d}):1==d.length?d[0]:new On({expressions:d});if(m.start){var v=c.comments_before.length;if([].unshift.apply(m.start.comments_before,c.comments_before),c.comments_before=m.start.comments_before,c.comments_before_length=v,0==v&&c.comments_before.length>0){var D=c.comments_before[0];D.nlb||(D.nlb=c.nlb,c.nlb=!1)}c.comments_after=m.start.comments_after}m.start=c;var g=s();return m.end&&(g.comments_before=m.end.comments_before,[].push.apply(m.end.comments_after,g.comments_after),g.comments_after=m.end.comments_after),m.end=g,m instanceof kn&&Ye(m),Ve(m,n);case"[":return Ve(xe(),n);case"{":return Ve(Oe(),n)}f||l()}if(i&&r("name")&&ft(o(),"arrow")){var _=new re({name:t.token.value,start:c,end:c});return u(),$(c,[_],!!f)}if(r("keyword","function")){u();var y=M(Q,!1,!!f);return y.start=c,y.end=s(),Ve(y,n)}if(f)return Ve(f,n);if(r("keyword","class")){u();var b=Te(Zn);return b.start=c,b.end=s(),Ve(b,n)}return r("template_head")?Ve(Fe(!1),n):Dt(t.token.type)?Ve(Qn(),n):void l()};function Fe(n){var e=[],i=t.token;for(e.push(new rn({start:t.token,raw:t.token.raw,value:t.token.value,end:t.token}));!1===t.token.end;)u(),w(),e.push(tt(!0)),ft("template_substitution")||l(),e.push(new rn({start:t.token,raw:t.token.raw,value:t.token.value,end:t.token}));return u(),new tn({start:i,segments:e,end:t.token})}function Ae(n,e,i){for(var o=!0,a=[];!r("punc",n)&&(o?o=!1:h(","),!e||!r("punc",n));)r("punc",",")&&i?a.push(new ke({start:t.token,end:t.token})):r("expand","...")?(u(),a.push(new X({start:s(),expression:tt(),end:t.token}))):a.push(tt(!1));return u(),a}var xe=E(function(){return h("["),new Rn({elements:Ae("]",!e.strict,!0)})}),Be=E(function(n,e){return M(Z,n,e)}),Oe=E(function(){var n=t.token,i=!0,o=[];for(h("{");!r("punc","}")&&(i?i=!1:h(","),e.strict||!r("punc","}"));)if("expand"!=(n=t.token).type){var a,c=Re();if(r("punc",":"))null===c?l(s()):(u(),a=tt(!1));else{var f=Se(c,n);if(f){o.push(f);continue}a=new de({start:s(),name:c,end:s()})}r("operator","=")&&(u(),a=new Hn({start:n,left:a,operator:"=",right:tt(!1),end:s()})),o.push(new Ln({start:n,quote:n.quote,key:c instanceof A?c:""+c,value:a,end:s()}))}else u(),o.push(new X({start:n,expression:tt(!1),end:s()}));return u(),new jn({properties:o})});function Te(n){var e,i,o,a,c=[];for(t.input.push_directives_stack(),t.input.add_directive("use strict"),"name"==t.token.type&&"extends"!=t.token.value&&(o=Le(n===Jn?se:ce)),n!==Jn||o||l(),"extends"==t.token.value&&(u(),a=tt(!0)),h("{"),r("punc",";")&&u();!r("punc","}");)e=t.token,(i=Se(Re(),e,!0))||l(),c.push(i),r("punc",";")&&u();return t.input.pop_directives_stack(),u(),new n({start:e,name:o,extends:a,properties:c,end:s()})}function Se(n,e,i){var o=function(n,e){return"string"==typeof n||"number"==typeof n?new ae({start:e,name:""+n,end:s()}):(null===n&&l(),n)},a=!1,u=!1,c=!1,f=e;if(i&&"static"===n&&!r("punc","(")&&(u=!0,f=t.token,n=Re()),"async"!==n||r("punc","(")||r("punc",",")||r("punc","}")||(a=!0,f=t.token,n=Re()),null===n&&(c=!0,f=t.token,null===(n=Re())&&l()),r("punc","("))return n=o(n,e),new Wn({start:e,static:u,is_generator:c,async:a,key:n,quote:n instanceof ae?f.quote:void 0,value:Be(c,a),end:s()});if(f=t.token,"get"==n){if(!r("punc")||r("punc","["))return n=o(Re(),e),new Vn({start:e,static:u,key:n,quote:n instanceof ae?f.quote:void 0,value:Be(),end:s()})}else if("set"==n&&(!r("punc")||r("punc","[")))return n=o(Re(),e),new Yn({start:e,static:u,key:n,quote:n instanceof ae?f.quote:void 0,value:Be(),end:s()})}function Ie(n){function e(n){return new n({name:Re(),start:s(),end:s()})}var i,o,a=n?pe:ve,c=n?le:me,f=t.token;return n?i=e(a):o=e(c),r("name","as")?(u(),n?o=e(c):i=e(a)):n?o=new c(i):i=new a(o),new Fn({start:f,foreign_name:i,name:o,end:s()})}function He(n,e){var i,r=n?pe:ve,o=n?le:me,a=t.token,u=s();return e=e||new o({name:"*",start:a,end:u}),i=new r({name:"*",start:a,end:u}),new Fn({start:a,foreign_name:i,name:e,end:u})}function Pe(n){var e;if(r("punc","{")){for(u(),e=[];!r("punc","}");)e.push(Ie(n)),r("punc",",")&&u();u()}else if(r("operator","*")){var t;u(),n&&r("name","as")&&(u(),t=Le(n?le:ve)),e=[He(n,t)]}return e}function Re(){var n=t.token;switch(n.type){case"punc":if("["===n.value){u();var e=tt(!1);return h("]"),e}l(n);case"operator":if("*"===n.value)return u(),null;-1===["delete","in","instanceof","new","typeof","void"].indexOf(n.value)&&l(n);case"name":"yield"==n.value&&(v()?f(n,"Yield cannot be used as identifier inside generators"):ft(o(),"punc",":")||ft(o(),"punc","(")||!t.input.has_directive("use strict")||f(n,"Unexpected yield identifier inside strict mode"));case"string":case"num":case"keyword":case"atom":return u(),n.value;default:l(n)}}function je(n){var e=t.token.value;return new("this"==e?ge:"super"==e?_e:n)({name:String(e),start:t.token,end:t.token})}function Ue(n){var e=n.name;v()&&"yield"==e&&f(n.start,"Yield cannot be used as identifier inside generators"),t.input.has_directive("use strict")&&("yield"==e&&f(n.start,"Unexpected yield identifier inside strict mode"),n instanceof Gn&&("arguments"==e||"eval"==e)&&f(n.start,"Unexpected "+e+" in strict mode"))}function Le(n,e){if(!r("name"))return e||c("Name expected"),null;var t=je(n);return Ue(t),u(),t}function Ye(n){for(var e=n.start,t=e.comments_before,i=b(e,"comments_before_length")?e.comments_before_length:t.length;--i>=0;){var r=t[i];if(/[@#]__PURE__/.test(r.value)){n.pure=r;break}}}var Ve=function(n,e){var i,o=n.start;if(r("punc","."))return u(),Ve(new Mn({start:o,expression:n,property:(i=t.token,"name"!=i.type&&l(),u(),i.value),end:s()}),e);if(r("punc","[")){u();var a=tt(!0);return h("]"),Ve(new zn({start:o,expression:n,property:a,end:s()}),e)}if(e&&r("punc","(")){u();var c=new kn({start:o,expression:n,args:We(),end:s()});return Ye(c),Ve(c,!0)}return r("template_head")?Ve(new en({start:o,prefix:n,template_string:Fe(),end:s()}),e):n},We=E(function(){for(var n=[];!r("punc",")");)r("expand","...")?(u(),n.push(new X({start:s(),expression:tt(!1),end:s()}))):n.push(tt(!1)),r("punc",")")||(h(","),r("punc",")")&&e.ecma<8&&l());return u(),n}),Xe=function(n,e){var i=t.token;if("name"==i.type&&"await"==i.value){if(D())return u(),D()||c("Unexpected await expression outside async function",t.prev.line,t.prev.col,t.prev.pos),new ze({start:s(),end:t.token,expression:Xe(!0)});t.input.has_directive("use strict")&&f(t.token,"Unexpected await identifier inside strict mode")}if(r("operator")&&ht(i.value)){u(),w();var o=Je(Tn,i,Xe(n));return o.start=i,o.end=s(),o}for(var a=ye(n,e);r("operator")&&dt(t.token.value)&&!d(t.token);)a instanceof K&&l(),(a=Je(Sn,t.token,a)).start=i,a.end=t.token,u();return a};function Je(n,e,i){var r=e.value;switch(r){case"++":case"--":Ge(i)||c("Invalid use of "+r+" operator",e.line,e.col,e.pos);break;case"delete":i instanceof de&&t.input.has_directive("use strict")&&c("Calling delete on expression not allowed in strict mode",i.start.line,i.start.col,i.start.pos)}return new n({operator:r,expression:i})}var Qe=function(n,e,i){var o=r("operator")?t.token.value:null;"in"==o&&i&&(o=null),"**"==o&&n instanceof Tn&&!ft(n.start,"punc","(")&&"--"!==n.operator&&"++"!==n.operator&&l(n.start);var a=null!=o?vt[o]:null;if(null!=a&&(a>e||"**"===o&&e===a)){u();var s=Qe(Xe(!0),a,i);return Qe(new In({start:n.start,left:n,operator:o,right:s,end:s.end}),e,i)}return n};var Ke=function(n){var e=t.token,i=function(n){return Qe(Xe(!0,!0),0,n)}(n);if(r("operator","?")){u();var o=tt(!1);return h(":"),new Nn({start:e,condition:i,consequent:o,alternative:tt(!1,n),end:s()})}return i};function Ge(n){return n instanceof $n||n instanceof de}function nt(n){if(n instanceof jn)n=new nn({start:n.start,names:n.properties.map(nt),is_array:!1,end:n.end});else if(n instanceof Rn){for(var e=[],t=0;t<n.elements.length;t++)n.elements[t]instanceof X&&(t+1!==n.elements.length&&f(n.elements[t].start,"Spread must the be last element in destructuring array"),n.elements[t].expression=nt(n.elements[t].expression)),e.push(nt(n.elements[t]));n=new nn({start:n.start,names:e,is_array:!0,end:n.end})}else n instanceof Un?n.value=nt(n.value):n instanceof Hn&&(n=new Pn({start:n.start,left:n.left,operator:"=",right:n.right,end:n.end}));return n}var et=function(n){w();var e=t.token;if("name"==e.type&&"yield"==e.value){if(v())return u(),function(){v()||c("Unexpected yield expression outside generator function",t.prev.line,t.prev.col,t.prev.pos);var n=t.token,e=!1,i=!0;return m()||r("punc")&&Ze(t.token.value)?i=!1:r("operator","*")&&(e=!0,u()),new qe({start:n,is_star:e,expression:i?tt():null,end:s()})}();t.input.has_directive("use strict")&&f(t.token,"Unexpected yield identifier inside strict mode")}var i=Ke(n),o=t.token.value;if(r("operator")&&mt(o)){if(Ge(i)||(i=nt(i))instanceof nn)return u(),new Hn({start:e,left:i,operator:o,right:et(n),end:s()});c("Invalid assignment")}return i},tt=function(n,e){for(var i=t.token,a=[];a.push(et(e)),n&&r("punc",",");)u(),n=!0;return 1==a.length?a[0]:new On({start:i,expressions:a,end:o()})};function it(n){++t.in_loop;var e=n();return--t.in_loop,e}return e.expression?tt(!0):function(){var n=t.token,i=[];for(t.input.push_directives_stack(),e.module&&t.input.add_directive("use strict");!r("eof");)i.push(F());t.input.pop_directives_stack();var o=s(),a=e.toplevel;return a?(a.body=a.body.concat(i),a.end=o):a=new W({start:n,body:i,end:o}),a}()}function _t(n,e){Te.call(this),this.before=n,this.after=e}function yt(n,e,t){this.name=e.name,this.orig=[e],this.init=t,this.eliminated=0,this.scope=n,this.references=[],this.replaced=0,this.global=!1,this.export=!1,this.mangled_name=null,this.undeclared=!1,this.id=yt.next_id++}_t.prototype=new Te,function(n){function e(e,t){e.DEFMETHOD("transform",function(e,i){var r,o;return e.push(this),e.before&&(r=e.before(this,t,i)),r===n&&(t(r=this,e),e.after&&(o=e.after(r,i))!==n&&(r=o)),e.pop(),r})}function t(n,e){return h(n,function(n){return n.transform(e,!0)})}e(A,s),e(I,function(n,e){n.label=n.label.transform(e),n.body=n.body.transform(e)}),e(O,function(n,e){n.body=n.body.transform(e)}),e(z,function(n,e){n.body=t(n.body,e)}),e(P,function(n,e){n.body=n.body.transform(e),n.condition=n.condition.transform(e)}),e(R,function(n,e){n.condition=n.condition.transform(e),n.body=n.body.transform(e)}),e(j,function(n,e){n.init&&(n.init=n.init.transform(e)),n.condition&&(n.condition=n.condition.transform(e)),n.step&&(n.step=n.step.transform(e)),n.body=n.body.transform(e)}),e(U,function(n,e){n.init=n.init.transform(e),n.object=n.object.transform(e),n.body=n.body.transform(e)}),e(Y,function(n,e){n.expression=n.expression.transform(e),n.body=n.body.transform(e)}),e(an,function(n,e){n.value&&(n.value=n.value.transform(e))}),e(cn,function(n,e){n.label&&(n.label=n.label.transform(e))}),e(pn,function(n,e){n.condition=n.condition.transform(e),n.body=n.body.transform(e),n.alternative&&(n.alternative=n.alternative.transform(e))}),e(hn,function(n,e){n.expression=n.expression.transform(e),n.body=t(n.body,e)}),e(vn,function(n,e){n.expression=n.expression.transform(e),n.body=t(n.body,e)}),e(Dn,function(n,e){n.body=t(n.body,e),n.bcatch&&(n.bcatch=n.bcatch.transform(e)),n.bfinally&&(n.bfinally=n.bfinally.transform(e))}),e(gn,function(n,e){n.argname&&(n.argname=n.argname.transform(e)),n.body=t(n.body,e)}),e(yn,function(n,e){n.definitions=t(n.definitions,e)}),e(xn,function(n,e){n.name=n.name.transform(e),n.value&&(n.value=n.value.transform(e))}),e(nn,function(n,e){n.names=t(n.names,e)}),e(J,function(n,e){n.name&&(n.name=n.name.transform(e)),n.argnames=t(n.argnames,e),n.body instanceof A?n.body=n.body.transform(e):n.body=t(n.body,e)}),e(kn,function(n,e){n.expression=n.expression.transform(e),n.args=t(n.args,e)}),e(On,function(n,e){n.expressions=t(n.expressions,e)}),e(Mn,function(n,e){n.expression=n.expression.transform(e)}),e(zn,function(n,e){n.expression=n.expression.transform(e),n.property=n.property.transform(e)}),e(qe,function(n,e){n.expression&&(n.expression=n.expression.transform(e))}),e(ze,function(n,e){n.expression=n.expression.transform(e)}),e(qn,function(n,e){n.expression=n.expression.transform(e)}),e(In,function(n,e){n.left=n.left.transform(e),n.right=n.right.transform(e)}),e(Nn,function(n,e){n.condition=n.condition.transform(e),n.consequent=n.consequent.transform(e),n.alternative=n.alternative.transform(e)}),e(Rn,function(n,e){n.elements=t(n.elements,e)}),e(jn,function(n,e){n.properties=t(n.properties,e)}),e(Un,function(n,e){n.key instanceof A&&(n.key=n.key.transform(e)),n.value=n.value.transform(e)}),e(Xn,function(n,e){n.name&&(n.name=n.name.transform(e)),n.extends&&(n.extends=n.extends.transform(e)),n.properties=t(n.properties,e)}),e(X,function(n,e){n.expression=n.expression.transform(e)}),e(Fn,function(n,e){n.foreign_name=n.foreign_name.transform(e),n.name=n.name.transform(e)}),e(Cn,function(n,e){n.imported_name&&(n.imported_name=n.imported_name.transform(e)),n.imported_names&&t(n.imported_names,e),n.module_name=n.module_name.transform(e)}),e(An,function(n,e){n.exported_definition&&(n.exported_definition=n.exported_definition.transform(e)),n.exported_value&&(n.exported_value=n.exported_value.transform(e)),n.exported_names&&t(n.exported_names,e),n.module_name&&(n.module_name=n.module_name.transform(e))}),e(tn,function(n,e){n.segments=t(n.segments,e)}),e(en,function(n,e){n.prefix=n.prefix.transform(e),n.template_string=n.template_string.transform(e)})}(),yt.next_id=1;var bt=1,Et=2;function wt(n,e){var i=n.enclosed;n:for(;;){var r=Ft(++n.cname);if(rt(r)&&!t(r,e.reserved)){for(var o=i.length;--o>=0;){var a=i[o];if(r==(a.mangled_name||a.unmangleable(e)&&a.name))continue n}return r}}}yt.prototype={unmangleable:function(n){return n||(n={}),this.global&&!n.toplevel||this.export&bt||this.undeclared||!n.eval&&this.scope.pinned()||(this.orig[0]instanceof ue||this.orig[0]instanceof oe)&&w(n.keep_fnames,this.orig[0].name)||this.orig[0]instanceof ae||(this.orig[0]instanceof ce||this.orig[0]instanceof se)&&w(n.keep_classnames,this.orig[0].name)},mangle:function(n){var e=n.cache&&n.cache.props;if(this.global&&e&&e.has(this.name))this.mangled_name=e.get(this.name);else if(!this.mangled_name&&!this.unmangleable(n)){var t,i=this.scope,r=this.orig[0];n.ie8&&r instanceof ue&&(i=i.parent_scope),(t=this.redefined())?this.mangled_name=t.mangled_name||t.name:this.mangled_name=i.next_mangled(n,this),this.global&&e&&e.set(this.name,this.mangled_name)}},redefined:function(){return this.defun&&this.defun.variables.get(this.name)}},W.DEFMETHOD("figure_out_scope",function(n){n=a(n,{cache:null,ie8:!1,safari10:!1});var e=this,t=e.parent_scope=null,i=new y,r=null,o=null,u=[],s=new Te(function(e,a){if(e.is_block_scope()){var c=t;return e.block_scope=t=new V(e),t.init_scope_vars(c),e instanceof V||(t.uses_with=c.uses_with,t.uses_eval=c.uses_eval,t.directives=c.directives),n.safari10&&(e instanceof j||e instanceof U)&&u.push(t),a(),t=c,!0}if(e instanceof nn)return o=e,a(),o=null,!0;if(e instanceof V){e.init_scope_vars(t);c=t;var f=r,l=i;return r=t=e,i=new y,a(),t=c,r=f,i=l,!0}if(e instanceof I){var p=e.label;if(i.has(p.name))throw new Error(m("Label {name} defined twice",p));return i.set(p.name,p),a(),i.del(p.name),!0}if(e instanceof Y)for(var h=t;h;h=h.parent_scope)h.uses_with=!0;else{if(e instanceof Qn&&(e.scope=t),e instanceof he&&(e.thedef=e,e.references=[]),e instanceof ue)r.def_function(e,"arguments"==e.name?void 0:r);else if(e instanceof oe)D((e.scope=r.parent_scope.get_defun_scope()).def_function(e,r),1);else if(e instanceof ce)D(r.def_variable(e,r),1);else if(e instanceof le)t.def_variable(e);else if(e instanceof se)D((e.scope=r.parent_scope).def_function(e,r),1);else if(e instanceof ne||e instanceof ie||e instanceof te){if(_((d=e instanceof ee?t.def_variable(e,null):r.def_variable(e,"SymbolVar"==e.TYPE?null:void 0)).orig,function(n){return n===e||(e instanceof ee?n instanceof ue:!(n instanceof ie||n instanceof te))})||ct(e.name+" redeclared",e.start.file,e.start.line,e.start.col,e.start.pos),e instanceof re||D(d,2),d.destructuring=o,r!==t){e.mark_enclosed(n);var d=t.find_variable(e);e.thedef!==d&&(e.thedef=d,e.reference(n))}}else if(e instanceof fe)t.def_variable(e).defun=r;else if(e instanceof De){var v=i.get(e.name);if(!v)throw new Error(m("Undefined label {name} [{line},{col}]",{name:e.name,line:e.start.line,col:e.start.col}));e.thedef=v}t instanceof W||!(e instanceof An||e instanceof Cn)||ct(e.TYPE+" statement may only appear at top level",e.start.file,e.start.line,e.start.col,e.start.pos)}function D(n,e){if(o){var t=0;do{e++}while(s.parent(t++)!==o)}var i=s.parent(e);if(n.export=i instanceof An&&bt){var r=i.exported_definition;(r instanceof G||r instanceof Jn)&&i.is_default&&(n.export=Et)}}});e.walk(s),e.globals=new y;s=new Te(function(t,i){if(t instanceof cn&&t.label)return t.label.thedef.references.push(t),!0;if(t instanceof de){var r,o=t.name;if("eval"==o&&s.parent()instanceof kn)for(var a=t.scope;a&&!a.uses_eval;a=a.parent_scope)a.uses_eval=!0;return s.parent()instanceof Fn&&s.parent(1).module_name||!(r=t.scope.find_variable(o))?(r=e.def_global(t),t instanceof me&&(r.export=bt)):r.scope instanceof J&&"arguments"==o&&(r.scope.uses_arguments=!0),t.thedef=r,t.reference(n),!t.scope.is_block_scope()||r.orig[0]instanceof ee||(t.scope=t.scope.get_defun_scope()),!0}var u;if(t instanceof fe&&(u=t.definition().redefined()))for(a=t.scope;a&&(d(a.enclosed,u),a!==u.scope);)a=a.parent_scope});if(e.walk(s),(n.ie8||n.safari10)&&e.walk(new Te(function(t,i){if(t instanceof fe){var r=t.name,o=t.thedef.references,a=t.thedef.defun,u=a.find_variable(r)||e.globals.get(r)||a.def_variable(t);return o.forEach(function(e){e.thedef=u,e.reference(n)}),t.thedef=u,t.reference(n),!0}})),n.safari10)for(var c=0;c<u.length;c++){(t=u[c]).parent_scope.variables.each(function(n){d(t.enclosed,n)})}}),W.DEFMETHOD("def_global",function(n){var e=this.globals,t=n.name;if(e.has(t))return e.get(t);var i=new yt(this,n);return i.undeclared=!0,i.global=!0,e.set(t,i),i}),V.DEFMETHOD("init_scope_vars",function(n){this.variables=new y,this.functions=new y,this.uses_with=!1,this.uses_eval=!1,this.parent_scope=n,this.enclosed=[],this.cname=-1}),A.DEFMETHOD("is_block_scope",c),Xn.DEFMETHOD("is_block_scope",c),J.DEFMETHOD("is_block_scope",c),W.DEFMETHOD("is_block_scope",c),dn.DEFMETHOD("is_block_scope",c),z.DEFMETHOD("is_block_scope",f),N.DEFMETHOD("is_block_scope",f),J.DEFMETHOD("init_scope_vars",function(){V.prototype.init_scope_vars.apply(this,arguments),this.uses_arguments=!1,this.def_variable(new re({name:"arguments",start:this.start,end:this.end}))}),K.DEFMETHOD("init_scope_vars",function(){V.prototype.init_scope_vars.apply(this,arguments),this.uses_arguments=!1}),Qn.DEFMETHOD("mark_enclosed",function(n){for(var e=this.definition(),t=this.scope;t&&(d(t.enclosed,e),n.keep_fnames&&t.functions.each(function(t){w(n.keep_fnames,t.name)&&d(e.scope.enclosed,t)}),t!==e.scope);)t=t.parent_scope}),Qn.DEFMETHOD("reference",function(n){this.definition().references.push(this),this.mark_enclosed(n)}),V.DEFMETHOD("find_variable",function(n){return n instanceof Qn&&(n=n.name),this.variables.get(n)||this.parent_scope&&this.parent_scope.find_variable(n)}),V.DEFMETHOD("def_function",function(n,e){var t=this.def_variable(n,e);return(!t.init||t.init instanceof G)&&(t.init=e),this.functions.set(n.name,t),t}),V.DEFMETHOD("def_variable",function(n,e){var t=this.variables.get(n.name);return t?(t.orig.push(n),t.init&&(t.scope!==n.scope||t.init instanceof Q)&&(t.init=e)):(t=new yt(this,n,e),this.variables.set(n.name,t),t.global=!this.parent_scope),n.thedef=t}),V.DEFMETHOD("next_mangled",function(n){return wt(this,n)}),W.DEFMETHOD("next_mangled",function(n){var e;do{e=wt(this,n)}while(t(e,this.mangled_names));return e}),Q.DEFMETHOD("next_mangled",function(n,e){for(var t=e.orig[0]instanceof re&&this.name&&this.name.definition(),i=t?t.mangled_name||t.name:null;;){var r=wt(this,n);if(!i||i!=r)return r}}),Qn.DEFMETHOD("unmangleable",function(n){var e=this.definition();return!e||e.unmangleable(n)}),he.DEFMETHOD("unmangleable",c),Qn.DEFMETHOD("unreferenced",function(){return!this.definition().references.length&&!this.scope.pinned()}),Qn.DEFMETHOD("definition",function(){return this.thedef}),Qn.DEFMETHOD("global",function(){return this.definition().global}),W.DEFMETHOD("_default_mangler_options",function(n){return(n=a(n,{eval:!1,ie8:!1,keep_classnames:!1,keep_fnames:!1,module:!1,reserved:[],toplevel:!1})).module&&(n.toplevel=!0),Array.isArray(n.reserved)||(n.reserved=[]),d(n.reserved,"arguments"),n}),W.DEFMETHOD("mangle_names",function(n){n=this._default_mangler_options(n);var e=-1,i=[],r=this.mangled_names=[];n.cache&&(this.globals.each(a),n.cache.props&&n.cache.props.each(function(n){d(r,n)}));var o=new Te(function(t,r){if(t instanceof I){var o=e;return r(),e=o,!0}if(t instanceof V)t.variables.each(a);else if(t.is_block_scope())t.block_scope.variables.each(a);else{if(t instanceof he){var u;do{u=Ft(++e)}while(!rt(u));return t.mangled_name=u,!0}!n.ie8&&!n.safari10&&t instanceof fe&&i.push(t.definition())}});function a(e){t(e.name,n.reserved)||e.export&bt||i.push(e)}this.walk(o),i.forEach(function(e){e.mangle(n)})}),W.DEFMETHOD("find_colliding_names",function(n){var e=n.cache&&n.cache.props,t=Object.create(null);return n.reserved.forEach(i),this.globals.each(r),this.walk(new Te(function(n){n instanceof V&&n.variables.each(r),n instanceof fe&&r(n.definition())})),t;function i(n){t[n]=!0}function r(t){var r=t.name;if(t.global&&e&&e.has(r))r=e.get(r);else if(!t.unmangleable(n))return;i(r)}}),W.DEFMETHOD("expand_names",function(n){Ft.reset(),Ft.sort(),n=this._default_mangler_options(n);var e=this.find_colliding_names(n),i=0;function r(r){if(!(r.global&&n.cache||r.unmangleable(n)||t(r.name,n.reserved))){var o=r.redefined();r.name=o?o.name:function(){var n;do{n=Ft(i++)}while(e[n]||!rt(n));return n}(),r.orig.forEach(function(n){n.name=r.name}),r.references.forEach(function(n){n.name=r.name})}}this.globals.each(r),this.walk(new Te(function(n){n instanceof V&&n.variables.each(r),n instanceof fe&&r(n.definition())}))}),A.DEFMETHOD("tail_node",l),On.DEFMETHOD("tail_node",function(){return this.expressions[this.expressions.length-1]}),W.DEFMETHOD("compute_char_frequency",function(n){n=this._default_mangler_options(n);try{A.prototype.print=function(e,t){this._print(e,t),this instanceof Qn&&!this.unmangleable(n)?Ft.consider(this.name,-1):n.properties&&(this instanceof Mn?Ft.consider(this.property,-1):this instanceof zn&&function n(e){e instanceof be?Ft.consider(e.value,-1):e instanceof Nn?(n(e.consequent),n(e.alternative)):e instanceof On&&n(e.tail_node())}(this.property))},Ft.consider(this.print_to_string(),1)}finally{A.prototype.print=A.prototype._print}Ft.sort()});var Ft=function(){var n,e,t="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".split(""),i="0123456789".split("");function r(){e=Object.create(null),t.forEach(function(n){e[n]=0}),i.forEach(function(n){e[n]=0})}function o(n,t){return e[t]-e[n]}function a(e){var t="",i=54;e++;do{t+=n[--e%i],e=Math.floor(e/i),i=64}while(e>0);return t}return a.consider=function(n,t){for(var i=n.length;--i>=0;)e[n[i]]+=t},a.sort=function(){n=D(t,o).concat(D(i,o))},a.reset=r,r(),a}(),Ct=/^$|[;{][\s\n]*$/;function At(n){return"comment2"==n.type&&/@preserve|@license|@cc_on/i.test(n.value)}function xt(n){var e=!n;void 0===(n=a(n,{ascii_only:!1,beautify:!1,braces:!1,comments:!1,ecma:5,ie8:!1,indent_level:4,indent_start:0,inline_script:!0,keep_quoted_props:!1,max_line_len:!1,preamble:null,quote_keys:!1,quote_style:0,safari10:!1,semicolons:!0,shebang:!0,shorthand:void 0,source_map:null,webkit:!1,width:80,wrap_iife:!1},!0)).shorthand&&(n.shorthand=n.ecma>5);var t=c;if(n.comments){var i=n.comments;if("string"==typeof n.comments&&/^\/.*\/[a-zA-Z]*$/.test(n.comments)){var r=n.comments.lastIndexOf("/");i=new RegExp(n.comments.substr(1,r-1),n.comments.substr(r+1))}t=i instanceof RegExp?function(n){return"comment5"!=n.type&&i.test(n.value)}:"function"==typeof i?function(n){return"comment5"!=n.type&&i(this,n)}:"some"===i?At:f}var o=0,u=0,l=1,p=0,h="",d=n.ascii_only?function(e,t){return n.ecma>=6&&(e=e.replace(/[\ud800-\udbff][\udc00-\udfff]/g,function(n){var e,t;return"\\u{"+(e=n,t=0,et(e.charAt(t))?65536+(e.charCodeAt(t)-55296<<10)+e.charCodeAt(t+1)-56320:e.charCodeAt(t)).toString(16)+"}"})),e.replace(/[\u0000-\u001f\u007f-\uffff]/g,function(n){var e=n.charCodeAt(0).toString(16);if(e.length<=2&&!t){for(;e.length<2;)e="0"+e;return"\\x"+e}for(;e.length<4;)e="0"+e;return"\\u"+e})}:function(n){for(var e="",t=0,i=n.length;t<i;t++)et(n[t])&&!tt(n[t+1])||tt(n[t])&&!et(n[t-1])?e+="\\u"+n.charCodeAt(t).toString(16):e+=n[t];return e};function m(e,t){var i=function(e,t){var i=0,r=0;function o(){return"'"+e.replace(/\x27/g,"\\'")+"'"}function a(){return'"'+e.replace(/\x22/g,'\\"')+'"'}if(e=e.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g,function(t,o){switch(t){case'"':return++i,'"';case"'":return++r,"'";case"\\":return"\\\\";case"\n":return"\\n";case"\r":return"\\r";case"\t":return"\\t";case"\b":return"\\b";case"\f":return"\\f";case"\v":return n.ie8?"\\x0B":"\\v";case"\u2028":return"\\u2028";case"\u2029":return"\\u2029";case"\ufeff":return"\\ufeff";case"\0":return/[0-9]/.test(nt(e,o+1))?"\\x00":"\\0"}return t}),e=d(e),"`"===t)return"`"+e.replace(/`/g,"\\`")+"`";switch(n.quote_style){case 1:return o();case 2:return a();case 3:return"'"==t?o():a();default:return i>r?o():a()}}(e,t);return n.inline_script&&(i=(i=(i=i.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi,"<\\/$1$2")).replace(/\x3c!--/g,"\\x3c!--")).replace(/--\x3e/g,"--\\x3e")),i}function v(e){return function n(e,t){if(t<=0)return"";if(1==t)return e;var i=n(e,t>>1);return i+=i,1&t&&(i+=e),i}(" ",n.indent_start+o-e*n.indent_level)}var D,y,b=!1,E=!1,w=!1,F=0,C=!1,k=!1,B=-1,O="",$=n.source_map&&[],M=$?function(){$.forEach(function(e){try{n.source_map.add(e.token.file,e.line,e.col,e.token.line,e.token.col,e.name||"name"!=e.token.type?e.name:e.token.value)}catch(n){null!=e.token.file&&A.warn("Couldn't figure out mapping for {file}:{line},{col} \u2192 {cline},{ccol} [{name}]",{file:e.token.file,line:e.token.line,col:e.token.col,cline:e.line,ccol:e.col,name:e.name||""})}}),$=[]}:s,z=n.max_line_len?function(){if(u>n.max_line_len){if(F){var e=h.slice(0,F),t=h.slice(F);if($){var i=t.length-u;$.forEach(function(n){n.line++,n.col+=i})}h=e+"\n"+t,l++,p++,u=t.length}u>n.max_line_len&&A.warn("Output exceeds {max_line_len} characters",n)}F&&(F=0,M())}:s,q=g("( [ + * / - , . `");function T(e){var t=nt(e=String(e),0),i=nt(O,O.length-1);C&&t&&(C=!1,"\n"!=t&&(T("\n"),I())),k&&t&&(k=!1,/[\s;})]/.test(t)||S()),B=-1;i=O.charAt(O.length-1);w&&(w=!1,(":"==i&&"}"==t||(!t||";}".indexOf(t)<0)&&";"!=i)&&(n.semicolons||q(t)?(h+=";",u++,p++):(z(),h+="\n",p++,l++,u=0,/^\s+$/.test(e)&&(w=!0)),n.beautify||(E=!1))),E&&((at(i)&&(at(t)||"\\"==t)||"/"==t&&t==i||("+"==t||"-"==t)&&t==O)&&(h+=" ",u++,p++),E=!1),D&&($.push({token:D,name:y,line:l,col:u}),D=!1,F||M()),h+=e,b="("==e[e.length-1],p+=e.length;var r=e.split(/\r?\n/),o=r.length-1;l+=o,u+=r[0].length,o>0&&(z(),u=r[o].length),O=e}var S=n.beautify?function(){T(" ")}:function(){E=!0},I=n.beautify?function(e){n.beautify&&T(v(e?.5:0))}:s,N=n.beautify?function(n,e){!0===n&&(n=j());var t=o;o=n;var i=e();return o=t,i}:function(n,e){return e()},H=n.beautify?function(){if(B<0)return T("\n");"\n"!=h[B]&&(h=h.slice(0,B)+"\n"+h.slice(B),p++,l++),B++}:n.max_line_len?function(){z(),F=h.length}:s,P=n.beautify?function(){T(";")}:function(){w=!0};function R(){w=!1,T(";")}function j(){return o+n.indent_level}function U(){return F&&z(),h}function L(){var n=h.lastIndexOf("\n");return/^ *$/.test(h.slice(n+1))}var Y=[];return{get:U,toString:U,indent:I,indentation:function(){return o},current_width:function(){return u-o},should_break:function(){return n.width&&this.current_width()>=n.width},has_parens:function(){return b},newline:H,print:T,star:function(){T("*")},space:S,comma:function(){T(","),S()},colon:function(){T(":"),S()},last:function(){return O},semicolon:P,force_semicolon:R,to_utf8:d,print_name:function(n){T(function(n){return n=n.toString(),n=d(n,!0)}(n))},print_string:function(n,e,t){var i=m(n,e);!0===t&&-1===i.indexOf("\\")&&(Ct.test(h)||R(),R()),T(i)},print_template_string_chars:function(n){var e=m(n,"`").replace(/\${/g,"\\${");return T(e.substr(1,e.length-2))},encode_string:m,next_indent:j,with_indent:N,with_block:function(n){var e;return T("{"),H(),N(j(),function(){e=n()}),I(),T("}"),e},with_parens:function(n){T("(");var e=n();return T(")"),e},with_square:function(n){T("[");var e=n();return T("]"),e},add_mapping:$?function(n,e){D=n,y=e}:s,option:function(e){return n[e]},prepend_comments:e?s:function(e){var i=this,r=e.start;if(r&&(!r.comments_before||r.comments_before._dumped!==i)){var o=r.comments_before;if(o||(o=r.comments_before=[]),o._dumped=i,e instanceof an&&e.value){var a=new Te(function(n){var e=a.parent();if(!(e instanceof an||e instanceof In&&e.left===n||"Call"==e.TYPE&&e.expression===n||e instanceof Nn&&e.condition===n||e instanceof Mn&&e.expression===n||e instanceof On&&e.expressions[0]===n||e instanceof zn&&e.expression===n||e instanceof Sn))return!0;if(n.start){var t=n.start.comments_before;t&&t._dumped!==i&&(t._dumped=i,o=o.concat(t))}});a.push(e),e.value.walk(a)}if(0==p){o.length>0&&n.shebang&&"comment5"==o[0].type&&(T("#!"+o.shift().value+"\n"),I());var u=n.preamble;u&&T(u.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g,"\n"))}if(0!=(o=o.filter(t,e)).length){var s=L();o.forEach(function(n,e){s||(n.nlb?(T("\n"),I(),s=!0):e>0&&S()),/comment[134]/.test(n.type)?(T("//"+n.value.replace(/[@#]__PURE__/g," ")+"\n"),I(),s=!0):"comment2"==n.type&&(T("/*"+n.value.replace(/[@#]__PURE__/g," ")+"*/"),s=!1)}),s||(r.nlb?(T("\n"),I()):S())}}},append_comments:e||t===c?s:function(n,e){var i=n.end;if(i){var r=i[e?"comments_before":"comments_after"];if(r&&r._dumped!==this&&(n instanceof x||_(r,function(n){return!/comment[134]/.test(n.type)}))){r._dumped=this;var o=h.length;r.filter(t,n).forEach(function(n,t){k=!1,C?(T("\n"),I(),C=!1):n.nlb&&(t>0||!L())?(T("\n"),I()):(t>0||!e)&&S(),/comment[134]/.test(n.type)?(T("//"+n.value.replace(/[@#]__PURE__/g," ")),C=!0):"comment2"==n.type&&(T("/*"+n.value.replace(/[@#]__PURE__/g," ")+"*/"),k=!0)}),h.length>o&&(B=o)}}},line:function(){return l},col:function(){return u},pos:function(){return p},push_node:function(n){Y.push(n)},pop_node:function(){return Y.pop()},parent:function(n){return Y[Y.length-2-(n||0)]}}}function kt(n,e){if(!(this instanceof kt))return new kt(n,e);_t.call(this,this.before,this.after),void 0===n.defaults||n.defaults||(e=!0),this.options=a(n,{arguments:!1,arrows:!e,booleans:!e,booleans_as_integers:!1,collapse_vars:!e,comparisons:!e,computed_props:!e,conditionals:!e,dead_code:!e,defaults:!0,directives:!e,drop_console:!1,drop_debugger:!e,ecma:5,evaluate:!e,expression:!1,global_defs:!1,hoist_funs:!1,hoist_props:!e,hoist_vars:!1,ie8:!1,if_return:!e,inline:!e,join_vars:!e,keep_classnames:!1,keep_fargs:!0,keep_fnames:!1,keep_infinity:!1,loops:!e,module:!1,negate_iife:!e,passes:1,properties:!e,pure_getters:!e&&"strict",pure_funcs:null,reduce_funcs:!e,reduce_vars:!e,sequences:!e,side_effects:!e,switches:!e,top_retain:null,toplevel:!(!n||!n.top_retain),typeofs:!e,unsafe:!1,unsafe_arrows:!1,unsafe_comps:!1,unsafe_Function:!1,unsafe_math:!1,unsafe_methods:!1,unsafe_proto:!1,unsafe_regexp:!1,unsafe_undefined:!1,unused:!e,warnings:!1},!0);var t=this.options.global_defs;if("object"==typeof t)for(var i in t)/^@/.test(i)&&b(t,i)&&(t[i.slice(1)]=gt(t[i],{expression:!0}));!0===this.options.inline&&(this.options.inline=3);var r=this.options.pure_funcs;this.pure_funcs="function"==typeof r?r:r?function(n){return r.indexOf(n.expression.print_to_string())<0}:f;var o=this.options.top_retain;o instanceof RegExp?this.top_retain=function(n){return o.test(n.name)}:"function"==typeof o?this.top_retain=o:o&&("string"==typeof o&&(o=o.split(/,/)),this.top_retain=function(n){return o.indexOf(n.name)>=0}),this.options.module&&(this.directives["use strict"]=!0,this.options.toplevel=!0);var u=this.options.toplevel;this.toplevel="string"==typeof u?{funcs:/funcs/.test(u),vars:/vars/.test(u)}:{funcs:u,vars:u};var s=this.options.sequences;this.sequences_limit=1==s?800:0|s,this.warnings_produced={}}!function(){function n(n,e){n.DEFMETHOD("_codegen",e)}var e=!1,t=null,i=null;function r(n,e){Array.isArray(n)?n.forEach(function(n){r(n,e)}):n.DEFMETHOD("needs_parens",e)}function o(n,t,i,r){var o=n.length-1;e=r,n.forEach(function(n,r){!0!==e||n instanceof B||n instanceof T||n instanceof O&&n.body instanceof be||(e=!1),n instanceof T||(i.indent(),n.print(i),r==o&&t||(i.newline(),t&&i.newline())),!0===e&&n instanceof O&&n.body instanceof be&&(e=!1)}),e=!1}function a(n,e){e.print("{"),e.with_indent(e.next_indent(),function(){e.append_comments(n,!0)}),e.print("}")}function u(n,e,t){n.body.length>0?e.with_block(function(){o(n.body,!1,e,t)}):a(n,e)}function f(n,e,t){var i=!1;t&&n.walk(new Te(function(n){return!!(i||n instanceof V)||(n instanceof In&&"in"==n.operator?(i=!0,!0):void 0)})),n.print(e,i)}function l(n,e,t){t.option("quote_keys")?t.print_string(n):""+ +n==n&&n>=0?t.print(d(n)):(Ne(n)?!t.option("ie8"):ut(n))?e&&t.option("keep_quoted_props")?t.print_string(n,e):t.print_name(n):t.print_string(n,e)}function p(n,e){e.option("braces")?m(n,e):!n||n instanceof T?e.force_semicolon():n.print(e)}function h(n,e){return n.args.length>0||e.option("beautify")}function d(n){var e,t=n.toString(10),i=[t.replace(/^0\./,".").replace("e+","e")];return Math.floor(n)===n?(n>=0?i.push("0x"+n.toString(16).toLowerCase(),"0"+n.toString(8)):i.push("-0x"+(-n).toString(16).toLowerCase(),"-0"+(-n).toString(8)),(e=/^(.*?)(0+)$/.exec(n))&&i.push(e[1]+"e"+e[2].length)):(e=/^0?\.(0+)(.*)$/.exec(n))&&i.push(e[2]+"e-"+(e[1].length+e[2].length),t.substr(t.indexOf("."))),function(n){for(var e=n[0],t=e.length,i=1;i<n.length;++i)n[i].length<t&&(t=(e=n[i]).length);return e}(i)}function m(n,e){!n||n instanceof T?e.print("{}"):n instanceof q?n.print(e):e.with_block(function(){e.indent(),n.print(e),e.newline()})}function v(n,e){n.forEach(function(n){n.DEFMETHOD("add_source_map",e)})}A.DEFMETHOD("print",function(n,e){var r=this,o=r._codegen;function a(){n.prepend_comments(r),r.add_source_map(n),o(r,n),n.append_comments(r)}r instanceof V?t=r:!i&&r instanceof B&&"use asm"==r.value&&(i=t),n.push_node(r),e||r.needs_parens(n)?n.with_parens(a):a(),n.pop_node(),r===i&&(i=null)}),A.DEFMETHOD("_print",A.prototype.print),A.DEFMETHOD("print_to_string",function(n){var e=xt(n);return this.print(e),e.get()}),r(A,c),r(Q,function(n){if(!n.has_parens()&&E(n))return!0;var e;if(n.option("webkit")&&((e=n.parent())instanceof $n&&e.expression===this))return!0;return!!n.option("wrap_iife")&&((e=n.parent())instanceof kn&&e.expression===this)}),r(K,function(n){var e=n.parent();return e instanceof $n&&e.expression===this}),r(jn,function(n){return!n.has_parens()&&E(n)}),r(Zn,E),r(qn,function(n){var e=n.parent();return e instanceof $n&&e.expression===this||e instanceof kn&&e.expression===this||e instanceof In&&"**"===e.operator&&this instanceof Tn&&e.left===this&&"++"!==this.operator&&"--"!==this.operator}),r(ze,function(n){var e=n.parent();return e instanceof $n&&e.expression===this||e instanceof kn&&e.expression===this||n.option("safari10")&&e instanceof Tn}),r(On,function(n){var e=n.parent();return e instanceof kn||e instanceof qn||e instanceof In||e instanceof xn||e instanceof $n||e instanceof Rn||e instanceof Un||e instanceof Nn||e instanceof K||e instanceof Pn||e instanceof X||e instanceof L&&this===e.object||e instanceof qe||e instanceof An}),r(In,function(n){var e=n.parent();if(e instanceof kn&&e.expression===this)return!0;if(e instanceof qn)return!0;if(e instanceof $n&&e.expression===this)return!0;if(e instanceof In){var t=e.operator,i=vt[t],r=this.operator,o=vt[r];if(i>o||i==o&&(this===e.right||"**"==t))return!0}}),r(qe,function(n){var e=n.parent();return e instanceof In&&"="!==e.operator||(e instanceof kn&&e.expression===this||(e instanceof Nn&&e.condition===this||(e instanceof qn||(e instanceof $n&&e.expression===this||void 0))))}),r($n,function(n){var e=n.parent();if(e instanceof Bn&&e.expression===this){var t=!1;return this.walk(new Te(function(n){return!!(t||n instanceof V)||(n instanceof kn?(t=!0,!0):void 0)})),t}}),r(kn,function(n){var e,t=n.parent();return!!(t instanceof Bn&&t.expression===this||t instanceof An&&t.is_default&&this.expression instanceof Q)||this.expression instanceof Q&&t instanceof $n&&t.expression===this&&(e=n.parent(1))instanceof Hn&&e.left===t}),r(Bn,function(n){var e=n.parent();if(!h(this,n)&&(e instanceof $n||e instanceof kn&&e.expression===this))return!0}),r(Ee,function(n){var e=n.parent();if(e instanceof $n&&e.expression===this){var t=this.getValue();if(t<0||/^0/.test(d(t)))return!0}}),r([Hn,Nn],function(n){var e=n.parent();return e instanceof qn||(e instanceof In&&!(e instanceof Hn)||(e instanceof kn&&e.expression===this||(e instanceof Nn&&e.condition===this||(e instanceof $n&&e.expression===this||(this instanceof Hn&&this.left instanceof nn&&!1===this.left.is_array||void 0)))))}),n(B,function(n,e){e.print_string(n.value,n.quote),e.semicolon()}),n(X,function(n,e){e.print("..."),n.expression.print(e)}),n(nn,function(n,e){e.print(n.is_array?"[":"{");var t=n.names.length;n.names.forEach(function(n,i){i>0&&e.comma(),n.print(e),i==t-1&&n instanceof ke&&e.comma()}),e.print(n.is_array?"]":"}")}),n(k,function(n,e){e.print("debugger"),e.semicolon()}),S.DEFMETHOD("_do_print_body",function(n){p(this.body,n)}),n(x,function(n,e){n.body.print(e),e.semicolon()}),n(W,function(n,e){o(n.body,!0,e,!0),e.print("")}),n(I,function(n,e){n.label.print(e),e.colon(),n.body.print(e)}),n(O,function(n,e){n.body.print(e),e.semicolon()}),n(q,function(n,e){u(n,e)}),n(T,function(n,e){e.semicolon()}),n(P,function(n,e){e.print("do"),e.space(),m(n.body,e),e.space(),e.print("while"),e.space(),e.with_parens(function(){n.condition.print(e)}),e.semicolon()}),n(R,function(n,e){e.print("while"),e.space(),e.with_parens(function(){n.condition.print(e)}),e.space(),n._do_print_body(e)}),n(j,function(n,e){e.print("for"),e.space(),e.with_parens(function(){n.init?(n.init instanceof yn?n.init.print(e):f(n.init,e,!0),e.print(";"),e.space()):e.print(";"),n.condition?(n.condition.print(e),e.print(";"),e.space()):e.print(";"),n.step&&n.step.print(e)}),e.space(),n._do_print_body(e)}),n(U,function(n,e){e.print("for"),n.await&&(e.space(),e.print("await")),e.space(),e.with_parens(function(){n.init.print(e),e.space(),e.print(n instanceof L?"of":"in"),e.space(),n.object.print(e)}),e.space(),n._do_print_body(e)}),n(Y,function(n,e){e.print("with"),e.space(),e.with_parens(function(){n.expression.print(e)}),e.space(),n._do_print_body(e)}),J.DEFMETHOD("_do_print",function(n,e){var t=this;e||(t.async&&(n.print("async"),n.space()),n.print("function"),t.is_generator&&n.star(),t.name&&n.space()),t.name instanceof Qn?t.name.print(n):e&&t.name instanceof A&&n.with_square(function(){t.name.print(n)}),n.with_parens(function(){t.argnames.forEach(function(e,t){t&&n.comma(),e.print(n)})}),n.space(),u(t,n,!0)}),n(J,function(n,e){n._do_print(e)}),n(en,function(n,e){var t=n.prefix,i=t instanceof K||t instanceof In||t instanceof Nn||t instanceof On||t instanceof qn;i&&e.print("("),n.prefix.print(e),i&&e.print(")"),n.template_string.print(e)}),n(tn,function(n,e){var t=e.parent()instanceof en;e.print("`");for(var i=0;i<n.segments.length;i++)n.segments[i]instanceof rn?t?e.print(n.segments[i].raw):e.print_template_string_chars(n.segments[i].value):(e.print("${"),n.segments[i].print(e),e.print("}"));e.print("`")}),K.DEFMETHOD("_do_print",function(n){var e=this,t=n.parent(),i=t instanceof In||t instanceof qn||t instanceof kn&&e===t.expression;i&&n.print("("),e.async&&(n.print("async"),n.space()),1===e.argnames.length&&e.argnames[0]instanceof Qn?e.argnames[0].print(n):n.with_parens(function(){e.argnames.forEach(function(e,t){t&&n.comma(),e.print(n)})}),n.space(),n.print("=>"),n.space(),e.body instanceof A?e.body.print(n):u(e,n),i&&n.print(")")}),an.DEFMETHOD("_do_print",function(n,e){n.print(e),this.value&&(n.space(),this.value.print(n)),n.semicolon()}),n(un,function(n,e){n._do_print(e,"return")}),n(sn,function(n,e){n._do_print(e,"throw")}),n(qe,function(n,e){var t=n.is_star?"*":"";e.print("yield"+t),n.expression&&(e.space(),n.expression.print(e))}),n(ze,function(n,e){e.print("await"),e.space();var t=n.expression,i=!(t instanceof kn||t instanceof de||t instanceof $n||t instanceof qn||t instanceof ye);i&&e.print("("),n.expression.print(e),i&&e.print(")")}),cn.DEFMETHOD("_do_print",function(n,e){n.print(e),this.label&&(n.space(),this.label.print(n)),n.semicolon()}),n(fn,function(n,e){n._do_print(e,"break")}),n(ln,function(n,e){n._do_print(e,"continue")}),n(pn,function(n,e){e.print("if"),e.space(),e.with_parens(function(){n.condition.print(e)}),e.space(),n.alternative?(!function(n,e){var t=n.body;if(""===t.print_to_string()){e.newline();var i=new Array(e.next_indent()).join(" ");return e.print(i+";"),void e.newline()}if(e.option("braces")||e.option("ie8")&&t instanceof P)return m(t,e);if(!t)return e.force_semicolon();for(;;)if(t instanceof pn){if(!t.alternative)return void m(n.body,e);t=t.alternative}else{if(!(t instanceof S))break;t=t.body}p(n.body,e)}(n,e),""!==n.body.print_to_string()&&e.space(),e.print("else"),e.space(),n.alternative instanceof pn?n.alternative.print(e):p(n.alternative,e)):n._do_print_body(e)}),n(hn,function(n,e){e.print("switch"),e.space(),e.with_parens(function(){n.expression.print(e)}),e.space();var t=n.body.length-1;t<0?a(n,e):e.with_block(function(){n.body.forEach(function(n,i){e.indent(!0),n.print(e),i<t&&n.body.length>0&&e.newline()})})}),dn.DEFMETHOD("_do_print_body",function(n){n.newline(),this.body.forEach(function(e){n.indent(),e.print(n),n.newline()})}),n(mn,function(n,e){e.print("default:"),n._do_print_body(e)}),n(vn,function(n,e){e.print("case"),e.space(),n.expression.print(e),e.print(":"),n._do_print_body(e)}),n(Dn,function(n,e){e.print("try"),e.space(),u(n,e),n.bcatch&&(e.space(),n.bcatch.print(e)),n.bfinally&&(e.space(),n.bfinally.print(e))}),n(gn,function(n,e){e.print("catch"),n.argname&&(e.space(),e.with_parens(function(){n.argname.print(e)})),e.space(),u(n,e)}),n(_n,function(n,e){e.print("finally"),e.space(),u(n,e)}),yn.DEFMETHOD("_do_print",function(n,e){n.print(e),n.space(),this.definitions.forEach(function(e,t){t&&n.comma(),e.print(n)});var t=n.parent();(!(t instanceof j||t instanceof U)||t&&t.init!==this)&&n.semicolon()}),n(En,function(n,e){n._do_print(e,"let")}),n(bn,function(n,e){n._do_print(e,"var")}),n(wn,function(n,e){n._do_print(e,"const")}),n(Cn,function(n,e){e.print("import"),e.space(),n.imported_name&&n.imported_name.print(e),n.imported_name&&n.imported_names&&(e.print(","),e.space()),n.imported_names&&(1===n.imported_names.length&&"*"===n.imported_names[0].foreign_name.name?n.imported_names[0].print(e):(e.print("{"),n.imported_names.forEach(function(t,i){e.space(),t.print(e),i<n.imported_names.length-1&&e.print(",")}),e.space(),e.print("}"))),(n.imported_name||n.imported_names)&&(e.space(),e.print("from"),e.space()),n.module_name.print(e),e.semicolon()}),n(Fn,function(n,e){var t=e.parent()instanceof Cn,i=n.name.definition();(i&&i.mangled_name||n.name.name)!==n.foreign_name.name?(t?e.print(n.foreign_name.name):n.name.print(e),e.space(),e.print("as"),e.space(),t?n.name.print(e):e.print(n.foreign_name.name)):n.name.print(e)}),n(An,function(n,e){if(e.print("export"),e.space(),n.is_default&&(e.print("default"),e.space()),n.exported_names)1===n.exported_names.length&&"*"===n.exported_names[0].name.name?n.exported_names[0].print(e):(e.print("{"),n.exported_names.forEach(function(t,i){e.space(),t.print(e),i<n.exported_names.length-1&&e.print(",")}),e.space(),e.print("}"));else if(n.exported_value)n.exported_value.print(e);else if(n.exported_definition&&(n.exported_definition.print(e),n.exported_definition instanceof yn))return;n.module_name&&(e.space(),e.print("from"),e.space(),n.module_name.print(e)),(n.exported_value&&!(n.exported_value instanceof G||n.exported_value instanceof Q||n.exported_value instanceof Xn)||n.module_name||n.exported_names)&&e.semicolon()}),n(xn,function(n,e){if(n.name.print(e),n.value){e.space(),e.print("="),e.space();var t=e.parent(1),i=t instanceof j||t instanceof U;f(n.value,e,i)}}),n(kn,function(n,e){n.expression.print(e),n instanceof Bn&&!h(n,e)||((n.expression instanceof kn||n.expression instanceof J)&&e.add_mapping(n.start),e.with_parens(function(){n.args.forEach(function(n,t){t&&e.comma(),n.print(e)})}))}),n(Bn,function(n,e){e.print("new"),e.space(),kn.prototype._codegen(n,e)}),On.DEFMETHOD("_do_print",function(n){this.expressions.forEach(function(e,t){t>0&&(n.comma(),n.should_break()&&(n.newline(),n.indent())),e.print(n)})}),n(On,function(n,e){n._do_print(e)}),n(Mn,function(n,e){var t=n.expression;t.print(e);var i=n.property;e.option("ie8")&&Ne(i)?(e.print("["),e.add_mapping(n.end),e.print_string(i),e.print("]")):(t instanceof Ee&&t.getValue()>=0&&(/[xa-f.)]/i.test(e.last())||e.print(".")),e.print("."),e.add_mapping(n.end),e.print_name(i))}),n(zn,function(n,e){n.expression.print(e),e.print("["),n.property.print(e),e.print("]")}),n(Tn,function(n,e){var t=n.operator;e.print(t),(/^[a-z]/i.test(t)||/[+-]$/.test(t)&&n.expression instanceof Tn&&/^[+-]/.test(n.expression.operator))&&e.space(),n.expression.print(e)}),n(Sn,function(n,e){n.expression.print(e),e.print(n.operator)}),n(In,function(n,e){var t=n.operator;n.left.print(e),">"==t[0]&&n.left instanceof Sn&&"--"==n.left.operator?e.print(" "):e.space(),e.print(t),("<"==t||"<<"==t)&&n.right instanceof Tn&&"!"==n.right.operator&&n.right.expression instanceof Tn&&"--"==n.right.expression.operator?e.print(" "):e.space(),n.right.print(e)}),n(Nn,function(n,e){n.condition.print(e),e.space(),e.print("?"),e.space(),n.consequent.print(e),e.space(),e.colon(),n.alternative.print(e)}),n(Rn,function(n,e){e.with_square(function(){var t=n.elements,i=t.length;i>0&&e.space(),t.forEach(function(n,t){t&&e.comma(),n.print(e),t===i-1&&n instanceof ke&&e.comma()}),i>0&&e.space()})}),n(jn,function(n,e){n.properties.length>0?e.with_block(function(){n.properties.forEach(function(n,t){t&&(e.print(","),e.newline()),e.indent(),n.print(e)}),e.newline()}):a(n,e)}),n(Xn,function(n,e){if(e.print("class"),e.space(),n.name&&(n.name.print(e),e.space()),n.extends){var t=!(n.extends instanceof de||n.extends instanceof $n||n.extends instanceof Zn||n.extends instanceof Q);e.print("extends"),t?e.print("("):e.space(),n.extends.print(e),t?e.print(")"):e.space()}n.properties.length>0?e.with_block(function(){n.properties.forEach(function(n,t){t&&e.newline(),e.indent(),n.print(e)}),e.newline()}):e.print("{}")}),n(Kn,function(n,e){e.print("new.target")}),n(Ln,function(n,e){function t(n){var e=n.definition();return e?e.mangled_name||e.name:n.name}var i=e.option("shorthand");i&&n.value instanceof Qn&&ut(n.key)&&t(n.value)===n.key&&rt(n.key)?l(n.key,n.quote,e):i&&n.value instanceof Pn&&n.value.left instanceof Qn&&ut(n.key)&&t(n.value.left)===n.key?(l(n.key,n.quote,e),e.space(),e.print("="),e.space(),n.value.right.print(e)):(n.key instanceof A?e.with_square(function(){n.key.print(e)}):l(n.key,n.quote,e),e.colon(),n.value.print(e))}),Un.DEFMETHOD("_print_getter_setter",function(n,e){var t=this;t.static&&(e.print("static"),e.space()),n&&(e.print(n),e.space()),t.key instanceof ae?l(t.key.name,t.quote,e):e.with_square(function(){t.key.print(e)}),t.value._do_print(e,!0)}),n(Yn,function(n,e){n._print_getter_setter("set",e)}),n(Vn,function(n,e){n._print_getter_setter("get",e)}),n(Wn,function(n,e){var t;n.is_generator&&n.async?t="async*":n.is_generator?t="*":n.async&&(t="async"),n._print_getter_setter(t,e)}),Qn.DEFMETHOD("_do_print",function(n){var e=this.definition();n.print_name(e?e.mangled_name||e.name:this.name)}),n(Qn,function(n,e){n._do_print(e)}),n(ke,s),n(ge,function(n,e){e.print("this")}),n(_e,function(n,e){e.print("super")}),n(ye,function(n,e){e.print(n.getValue())}),n(be,function(n,t){t.print_string(n.getValue(),n.quote,e)}),n(Ee,function(n,e){i&&n.start&&null!=n.start.raw?e.print(n.start.raw):e.print(d(n.getValue()))}),n(we,function(n,e){var t=n.getValue().toString();t=e.to_utf8(t),e.print(t);var i=e.parent();i instanceof In&&/^in/.test(i.operator)&&i.left===n&&e.print(" ")}),v([A,I,W],s),v([Rn,q,gn,Xn,ye,k,yn,B,_n,on,J,Bn,jn,S,Qn,hn,dn,Dn],function(n){n.add_mapping(this.start)}),v([Vn,Yn],function(n){n.add_mapping(this.start,this.key.name)}),v([Un],function(n){n.add_mapping(this.start,this.key)})}(),kt.prototype=new _t,u(kt.prototype,{option:function(n){return this.options[n]},exposed:function(n){if(n.export)return!0;if(n.global)for(var e=0,t=n.orig.length;e<t;e++)if(!this.toplevel[n.orig[e]instanceof oe?"funcs":"vars"])return!0;return!1},in_boolean_context:function(){if(!this.option("booleans"))return!1;for(var n,e=this.self(),t=0;n=this.parent(t);t++){if(n instanceof O||n instanceof Nn&&n.condition===e||n instanceof H&&n.condition===e||n instanceof j&&n.condition===e||n instanceof pn&&n.condition===e||n instanceof Tn&&"!"==n.operator&&n.expression===e)return!0;if(!(n instanceof In&&("&&"==n.operator||"||"==n.operator)||n instanceof Nn||n.tail_node()===e))return!1;e=n}},compress:function(n){n=n.resolve_defines(this),this.option("expression")&&n.process_expression(!0);for(var e=+this.options.passes||1,t=1/0,i=!1,r={ie8:this.option("ie8")},o=0;o<e;o++)if(n.figure_out_scope(r),0===o&&this.option("drop_console")&&(n=n.drop_console()),(o>0||this.option("reduce_vars"))&&n.reset_opt_flags(this),n=n.transform(this),e>1){var a=0;if(n.walk(new Te(function(){a++})),this.info("pass "+o+": last_count: "+t+", count: "+a),a<t)t=a,i=!1;else{if(i)break;i=!0}}return this.option("expression")&&n.process_expression(!1),n},info:function(){"verbose"==this.options.warnings&&A.warn.apply(A,arguments)},warn:function(n,e){if(this.options.warnings){var t=m(n,e);t in this.warnings_produced||(this.warnings_produced[t]=!0,A.warn.apply(A,arguments))}},clear_warnings:function(){this.warnings_produced={}},before:function(n,e,t){if(n._squeezed)return n;var i=!1;n instanceof V&&(n=(n=n.hoist_properties(this)).hoist_declarations(this),i=!0),e(n,this),e(n,this);var r=n.optimize(this);return i&&r instanceof V&&(r.drop_unused(this),e(r,this)),r===n&&(r._squeezed=!0),r}}),function(){function n(n,e){n.DEFMETHOD("optimize",function(n){if(this._optimized)return this;if(n.has_directive("use asm"))return this;var t=e(this,n);return t._optimized=!0,t})}function e(n,e){if(!((e=Fe(e))instanceof A)){var t;if(n instanceof Rn){var i=n.elements;if("length"==e)return C(i.length,n);"number"==typeof e&&e in i&&(t=i[e])}else if(n instanceof jn){e=""+e;for(var r=n.properties,o=r.length;--o>=0;){if(!(r[o]instanceof Ln))return;t||r[o].key!==e||(t=r[o].value)}}return t instanceof de&&t.fixed_value()||t}}function r(n,t,i,o,a,u){var s=t.parent(a),c=He(i,s);if(c)return c;if(!u&&s instanceof kn&&s.expression===i&&!(o instanceof K)&&!(o instanceof Xn)&&!s.is_expr_pure(n)&&(!(o instanceof Q)||!(s instanceof Bn)&&o.contains_this()))return!0;if(s instanceof Rn)return r(n,t,s,s,a+1);if(s instanceof Ln&&i===s.value){var f=t.parent(a+1);return r(n,t,f,f,a+2)}if(s instanceof $n&&s.expression===i){var l=e(o,s.property);return!u&&r(n,t,s,l,a+1)}}function o(n){return n instanceof K||n instanceof Q}function a(n){if(n instanceof ge)return!0;if(n instanceof de)return n.definition().orig[0]instanceof ue;if(n instanceof $n){if((n=n.expression)instanceof de){if(n.is_immutable())return!1;n=n.fixed_value()}return!n||!(n instanceof we)&&(n instanceof ye||a(n))}return!1}function u(n,e){if(!(n instanceof de))return!1;for(var t=n.definition().orig,i=t.length;--i>=0;)if(t[i]instanceof e)return!0}function d(n,e){for(var t,i=0;(t=n.parent(i++))&&!(t instanceof V);)if(t instanceof gn&&t.argname){t=t.argname.definition().scope;break}return t.find_variable(e)}function D(n,e,t){return t||(t={}),e&&(t.start||(t.start=e.start),t.end||(t.end=e.end)),new n(t)}function F(n,e){return 1==e.length?e[0]:D(On,n,{expressions:e.reduce(S,[])})}function C(n,e){switch(typeof n){case"string":return D(be,e,{value:n});case"number":return isNaN(n)?D(Ae,e):isFinite(n)?1/n<0?D(Tn,e,{operator:"-",expression:D(Ee,e,{value:-n})}):D(Ee,e,{value:n}):n<0?D(Tn,e,{operator:"-",expression:D(Be,e)}):D(Be,e);case"boolean":return D(n?Me:$e,e);case"undefined":return D(xe,e);default:if(null===n)return D(Ce,e,{value:null});if(n instanceof RegExp)return D(we,e,{value:n});throw new Error(m("Can't handle constant of type: {type}",{type:typeof n}))}}function M(n,e,t){return n instanceof Tn&&"delete"==n.operator||n instanceof kn&&n.expression===e&&(t instanceof $n||t instanceof de&&"eval"==t.name)?F(e,[D(Ee,e,{value:0}),t]):t}function S(n,e){return e instanceof On?n.push.apply(n,e.expressions):n.push(e),n}function L(n){if(null===n)return[];if(n instanceof q)return n.body;if(n instanceof T)return[];if(n instanceof x)return[n];throw new Error("Can't convert thing to statement array")}function sn(n){return null===n||(n instanceof T||n instanceof q&&0==n.body.length)}function Fn(n){return!(n instanceof Jn||n instanceof G||n instanceof En||n instanceof wn||n instanceof An||n instanceof Cn)}function Yn(n){return n instanceof N&&n.body instanceof q?n.body:n}function Kn(n){return"Call"==n.TYPE&&(n.expression instanceof Q||Kn(n.expression))}function ie(n){return n instanceof de&&n.definition().undeclared}n(A,function(n,e){return n}),W.DEFMETHOD("drop_console",function(){return this.transform(new _t(function(n){if("Call"==n.TYPE){var e=n.expression;if(e instanceof $n){for(var t=e.expression;t.expression;)t=t.expression;if(ie(t)&&"console"==t.name)return D(xe,n)}}}))}),A.DEFMETHOD("equivalent_to",function(n){return this.TYPE==n.TYPE&&this.print_to_string()==n.print_to_string()}),V.DEFMETHOD("process_expression",function(n,e){var t=this,i=new _t(function(r){if(n&&r instanceof O)return D(un,r,{value:r.body});if(!n&&r instanceof un){if(e){var o=r.value&&r.value.drop_side_effect_free(e,!0);return o?D(O,r,{body:o}):D(T,r)}return D(O,r,{body:r.value||D(Tn,r,{operator:"void",expression:D(Ee,r,{value:0})})})}if(r instanceof Xn||r instanceof J&&r!==t)return r;if(r instanceof z){var a=r.body.length-1;a>=0&&(r.body[a]=r.body[a].transform(i))}else r instanceof pn?(r.body=r.body.transform(i),r.alternative&&(r.alternative=r.alternative.transform(i))):r instanceof Y&&(r.body=r.body.transform(i));return r});t.transform(i)}),function(n){function t(n,e){e.assignments=0,e.chained=!1,e.direct_access=!1,e.escaped=!1,e.scope.pinned()?e.fixed=!1:e.orig[0]instanceof te||!n.exposed(e)?e.fixed=e.init:e.fixed=!1,e.recursive_refs=0,e.references=[],e.should_replace=void 0,e.single_use=void 0}function i(n,e,i){i.variables.each(function(i){t(e,i),null===i.fixed?(i.safe_ids=n.safe_ids,c(n,i,!0)):i.fixed&&(n.loop_ids[i.id]=n.in_loop,c(n,i,!0))})}function o(n,e){e.block_scope&&e.block_scope.variables.each(function(e){t(n,e)})}function a(n){n.safe_ids=Object.create(n.safe_ids)}function u(n){n.safe_ids=Object.getPrototypeOf(n.safe_ids)}function c(n,e,t){n.safe_ids[e.id]=t}function f(n,e){if("m"==e.single_use)return!1;if(n.safe_ids[e.id]){if(null==e.fixed){var t=e.orig[0];if(t instanceof re||"arguments"==t.name)return!1;e.fixed=D(xe,t)}return!0}return e.fixed instanceof G}function l(n,e,t){return void 0===e.fixed||(null===e.fixed&&e.safe_ids?(e.safe_ids[e.id]=!1,delete e.safe_ids,!0):!!b(n.safe_ids,e.id)&&(!!f(n,e)&&(!1!==e.fixed&&(!(null!=e.fixed&&(!t||e.references.length>e.assignments))&&_(e.orig,function(n){return!(n instanceof te||n instanceof oe||n instanceof ue)})))))}function p(n,t,i,r,o,a,u){var s=n.parent(a);if(o){if(o.is_constant())return;if(o instanceof Zn)return}if(s instanceof Hn&&"="==s.operator&&r===s.right||s instanceof kn&&(r!==s.expression||s instanceof Bn)||s instanceof an&&r===s.value&&r.scope!==t.scope||s instanceof xn&&r===s.value||s instanceof qe&&r===s.value&&r.scope!==t.scope)return!(u>1)||o&&o.is_constant_expression(i)||(u=1),void((!t.escaped||t.escaped>u)&&(t.escaped=u));if(s instanceof Rn||s instanceof ze||s instanceof In&&Ie(s.operator)||s instanceof Nn&&r!==s.condition||s instanceof X||s instanceof On&&r===s.tail_node())p(n,t,i,s,s,a+1,u);else if(s instanceof Ln&&r===s.value){var c=n.parent(a+1);p(n,t,i,c,c,a+2,u)}else if(s instanceof $n&&r===s.expression&&(p(n,t,i,s,o=e(o,s.property),a+1,u+1),o))return;a>0||s instanceof On&&r!==s.tail_node()||s instanceof O||(t.direct_access=!0)}n(A,s);var h=new Te(function(n){if(n instanceof Qn){var e=n.definition();e&&(n instanceof de&&e.references.push(n),e.fixed=!1)}});function d(n,e,t){this.inlined=!1;var r=n.safe_ids;return n.safe_ids=Object.create(null),i(n,t,this),e(),n.safe_ids=r,!0}function m(n,e,t){var r,o=this;return o.inlined=!1,a(n),i(n,t,o),!o.name&&(r=n.parent())instanceof kn&&r.expression===o&&o.argnames.forEach(function(e,t){if(e.definition){var i=e.definition();void 0!==i.fixed||o.uses_arguments&&!n.has_directive("use strict")?i.fixed=!1:(i.fixed=function(){return r.args[t]||D(xe,r)},n.loop_ids[i.id]=n.in_loop,c(n,i,!0))}}),e(),u(n),!0}n(Z,function(n,e,t){return a(n),i(n,t,this),e(),u(n),!0}),n(K,m),n(Hn,function(n,e,t){var i=this;if(i.left instanceof nn)i.left.walk(h);else{var o=i.left;if(o instanceof de){var a=o.definition(),u=l(n,a,o.scope,i.right);if(a.assignments++,u){var s=a.fixed;if(s||"="==i.operator){var f="="==i.operator,d=f?i.right:i;if(!r(t,n,i,d,0))return a.references.push(o),f||(a.chained=!0),a.fixed=f?function(){return i.right}:function(){return D(In,i,{operator:i.operator.slice(0,-1),left:s instanceof A?s:s(),right:i.right})},c(n,a,!1),i.right.walk(n),c(n,a,!0),p(n,a,o.scope,i,d,0,1),!0}}}}}),n(In,function(n){if(Ie(this.operator))return this.left.walk(n),a(n),this.right.walk(n),u(n),!0}),n(z,function(n,e,t){o(t,this)}),n(vn,function(n){return a(n),this.expression.walk(n),u(n),a(n),$(this,n),u(n),!0}),n(Zn,function(n,e){return this.inlined=!1,a(n),e(),u(n),!0}),n(Nn,function(n){return this.condition.walk(n),a(n),this.consequent.walk(n),u(n),a(n),this.alternative.walk(n),u(n),!0}),n(mn,function(n,e){return a(n),e(),u(n),!0}),n(Jn,d),n(G,d),n(P,function(n,e,t){o(t,this);var i=n.in_loop;return n.in_loop=this,a(n),this.body.walk(n),Ze(this)&&(u(n),a(n)),this.condition.walk(n),u(n),n.in_loop=i,!0}),n(j,function(n,e,t){o(t,this),this.init&&this.init.walk(n);var i=n.in_loop;return n.in_loop=this,a(n),this.condition&&this.condition.walk(n),this.body.walk(n),this.step&&(Ze(this)&&(u(n),a(n)),this.step.walk(n)),u(n),n.in_loop=i,!0}),n(U,function(n,e,t){o(t,this),this.init.walk(h),this.object.walk(n);var i=n.in_loop;return n.in_loop=this,a(n),this.body.walk(n),u(n),n.in_loop=i,!0}),n(Q,m),n(pn,function(n){return this.condition.walk(n),a(n),this.body.walk(n),u(n),this.alternative&&(a(n),this.alternative.walk(n),u(n)),!0}),n(I,function(n){return a(n),this.body.walk(n),u(n),!0}),n(fe,function(){this.definition().fixed=!1}),n(de,function(n,e,t){var i,o=this.definition();o.references.push(this),1==o.references.length&&!o.fixed&&o.orig[0]instanceof oe&&(n.loop_ids[o.id]=n.in_loop),void 0!==o.fixed&&f(n,o)?o.fixed&&((i=this.fixed_value())instanceof J&&Ge(n,o)?o.recursive_refs++:i&&!t.exposed(o)&&function(n,e,t){return e.option("unused")&&!t.scope.pinned()&&t.references.length-t.recursive_refs==1&&n.loop_ids[t.id]===n.in_loop}(n,t,o)?o.single_use=i instanceof J&&!i.pinned()||i instanceof Xn||o.scope===this.scope&&i.is_constant_expression():o.single_use=!1,r(t,n,this,i,0,function(n){return!!n&&(n.is_constant()||n instanceof J||n instanceof ge)}(i))&&(o.single_use?o.single_use="m":o.fixed=!1)):o.fixed=!1,p(n,o,this.scope,this,i,0,1)}),n(W,function(n,e,r){this.globals.each(function(n){t(r,n)}),i(n,r,this)}),n(Dn,function(n,e,t){return o(t,this),a(n),$(this,n),u(n),this.bcatch&&(a(n),this.bcatch.walk(n),u(n)),this.bfinally&&this.bfinally.walk(n),!0}),n(qn,function(n,e){var t=this;if("++"==t.operator||"--"==t.operator){var i=t.expression;if(i instanceof de){var r=i.definition(),o=l(n,r,!0);if(r.assignments++,o){var a=r.fixed;if(a)return r.references.push(i),r.chained=!0,r.fixed=function(){return D(In,t,{operator:t.operator.slice(0,-1),left:D(Tn,t,{operator:"+",expression:a instanceof A?a:a()}),right:D(Ee,t,{value:1})})},c(n,r,!0),!0}}}}),n(xn,function(n,e){var t=this;if(t.name instanceof nn)t.name.walk(h);else{var i=t.name.definition();if(t.value){if(l(n,i,t.value))return i.fixed=function(){return t.value},n.loop_ids[i.id]=n.in_loop,c(n,i,!1),e(),c(n,i,!0),!0;i.fixed=!1}}}),n(R,function(n,e,t){o(t,this);var i=n.in_loop;return n.in_loop=this,a(n),e(),u(n),n.in_loop=i,!0})}(function(n,e){n.DEFMETHOD("reduce_vars",e)}),W.DEFMETHOD("reset_opt_flags",function(n){var e=this,t=n.option("reduce_vars"),i=new Te(function(r,o){if(r._squeezed=!1,r._optimized=!1,t)return n.top_retain&&(i.parent()===e?r._top=!0:delete r._top),r.reduce_vars(i,o,n)});i.safe_ids=Object.create(null),i.in_loop=null,i.loop_ids=Object.create(null),e.walk(i)}),Qn.DEFMETHOD("fixed_value",function(){var n=this.definition().fixed;return!n||n instanceof A?n:n()}),de.DEFMETHOD("is_immutable",function(){var n=this.definition().orig;return 1==n.length&&n[0]instanceof ue});var se=g("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");de.DEFMETHOD("is_declared",function(n){return!this.definition().undeclared||n.option("unsafe")&&se(this.name)});var ce,le,pe,he=g("Infinity NaN undefined");function ve(n){return n instanceof Be||n instanceof Ae||n instanceof xe}function De(n,e){var i,s,c=e.find_parent(V).get_defun_scope();!function(){var n=e.self(),t=0;do{if(n instanceof gn||n instanceof _n)t++;else if(n instanceof N)i=!0;else{if(n instanceof V){c=n;break}n instanceof Dn&&(s=!0)}}while(n=e.parent(t++))}();var f,l=10;do{f=!1,d(n),e.option("dead_code")&&g(n,e),e.option("if_return")&&m(n,e),e.sequences_limit>0&&(b(n,e),w(n,e)),e.option("join_vars")&&x(n),e.option("collapse_vars")&&p(n,e)}while(f&&l-- >0);function p(n,e){if(c.pinned())return n;for(var l,p=[],d=n.length,m=new _t(function(n,t){if(I)return n;if(!S)return n!==g[y]?n:++y<g.length?Q(n):(S=!0,(w=function n(e,t,i){var r=m.parent(t);if(r instanceof Hn)return i&&!(r.left instanceof $n||r.left.name in A)?n(r,t+1,i):e;if(r instanceof In)return!i||Ie(r.operator)&&r.left!==e?e:n(r,t+1,i);if(r instanceof kn)return e;if(r instanceof vn)return e;if(r instanceof Nn)return i&&r.condition===e?n(r,t+1,i):e;if(r instanceof yn)return n(r,t+1,!0);if(r instanceof an)return i?n(r,t+1,i):e;if(r instanceof pn)return i&&r.condition===e?n(r,t+1,i):e;if(r instanceof N)return e;if(r instanceof On)return n(r,t+1,r.tail_node()!==e);if(r instanceof O)return n(r,t+1,!0);if(r instanceof hn)return e;if(r instanceof xn)return e;return null}(n,0))===n&&(I=!0),n);var i,r=m.parent();if(n instanceof Hn&&"="!=n.operator&&C.equivalent_to(n.left)||n instanceof ze||n instanceof kn&&C instanceof $n&&C.equivalent_to(n.expression)||n instanceof k||n instanceof nn||n instanceof X&&n.expression instanceof Qn&&n.expression.definition().references.length>1||n instanceof N&&!(n instanceof j)||n instanceof cn||n instanceof Dn||n instanceof Y||n instanceof qe||r instanceof j&&n!==r.init||!$&&n instanceof de&&!n.is_declared(e))return I=!0,n;if(F||x&&$||!(r instanceof In&&Ie(r.operator)&&r.left!==n||r instanceof Nn&&r.condition!==n||r instanceof pn&&r.condition!==n)||(F=r),R&&!(n instanceof Gn)&&C.equivalent_to(n)){if(F)return I=!0,n;if(He(n,r))return E&&P++,n;if(f=I=!0,P++,e.info("Collapsing {name} [{file}:{line},{col}]",{name:n.print_to_string(),file:n.start.file,line:n.start.line,col:n.start.col}),b instanceof Sn)return D(Tn,b,b);if(b instanceof xn){if(E)return I=!1,n;var o=b.name.definition(),a=b.value;return o.references.length-o.replaced!=1||e.exposed(o)?D(Hn,b,{operator:"=",left:D(de,b.name,b.name),right:a}):(o.replaced++,T&&ve(a)?a.transform(e):M(r,n,a))}return b.write_only=!1,b}return(n instanceof kn||n instanceof an&&(B||C instanceof $n||gn(C))||n instanceof $n&&(B||n.expression.may_throw_on_access(e))||n instanceof de&&(A[n.name]||B&&gn(n))||n instanceof xn&&n.value&&(n.name.name in A||B&&gn(n.name))||(i=He(n.left,n))&&(i instanceof $n||i.name in A)||q&&(s?n.has_side_effects(e):function n(e,t){if(e instanceof Hn)return n(e.left,!0);if(e instanceof qn)return n(e.expression,!0);if(e instanceof xn)return e.value&&n(e.value);if(t){if(e instanceof Mn)return n(e.expression,!0);if(e instanceof zn)return n(e.expression,!0);if(e instanceof de)return e.definition().scope!==c}return!1}(n)))&&(w=n,n instanceof V&&(I=!0)),Q(n)},function(n){I||(w===n&&(I=!0),F===n&&(F=null))}),v=new _t(function(n){if(I)return n;if(!S){if(n!==g[y])return n;if(++y<g.length)return;return S=!0,n}return n instanceof de&&n.name==Z.name?(--P||(I=!0),He(n,v.parent())?n:(Z.replaced++,E.replaced--,b.value)):n instanceof mn||n instanceof V?n:void 0});--d>=0;){0==d&&e.option("unused")&&en();var g=[];for(tn(n[d]);p.length>0;){g=p.pop();var y=0,b=g[g.length-1],E=null,w=null,F=null,C=rn(b);if(C&&!a(C)&&!C.has_side_effects(e)){var A=un(b),x=fn(C);C instanceof de&&(A[C.name]=!1);var B=ln(b),$=dn(),q=b.may_throw(e),T=b.name instanceof re,S=T,I=!1,P=0,R=!l||!S;if(!R){for(var L=e.self().argnames.lastIndexOf(b.name)+1;!I&&L<l.length;L++)l[L].transform(m);R=!0}for(var W=d;!I&&W<n.length;W++)n[W].transform(m);if(E){var Z=b.name.definition();if(I&&Z.references.length-Z.replaced>P)P=!1;else{I=!1,y=0,S=T;for(W=d;!I&&W<n.length;W++)n[W].transform(v);E.single_use=!1}}P&&!sn(b)&&n.splice(d,1)}}}function Q(n){if(n instanceof V)return n;if(n instanceof hn){n.expression=n.expression.transform(m);for(var e=0,t=n.body.length;!I&&e<t;e++){var i=n.body[e];if(i instanceof vn){if(!S){if(i!==g[y])continue;y++}if(i.expression=i.expression.transform(m),!$)break}}return I=!0,n}}function G(n,e,t){var i=!1,r=!(n instanceof K);return e.walk(new Te(function(e,o){if(i)return!0;if(e instanceof de&&n.variables.has(e.name)){var a=e.definition().scope;if(a!==c)for(;a=a.parent_scope;)if(a===c)return!0;return i=!0}if((t||r)&&e instanceof ge)return i=!0;if(e instanceof V&&!(e instanceof K)){var u=r;return r=!1,o(),r=u,!0}})),i}function en(){var n,i=e.self();if(o(i)&&!i.name&&!i.uses_arguments&&!i.pinned()&&(n=e.parent())instanceof kn&&n.expression===i&&_(n.args,function(n){return!(n instanceof X)})){var r=e.has_directive("use strict");r&&!t(r,i.body)&&(r=!1);var a=i.argnames.length;l=n.args.slice(a);for(var u=Object.create(null),s=a;--s>=0;){var c=i.argnames[s],f=n.args[s];if(l.unshift(D(xn,c,{name:c,value:f})),!(c.name in u))if(u[c.name]=!0,c instanceof X){var h=n.args.slice(s);_(h,function(n){return!G(i,n,r)})&&p.unshift([D(xn,c,{name:c.expression,value:D(Rn,n,{elements:h})})])}else f?(f instanceof J&&f.pinned()||G(i,f,r))&&(f=null):f=D(xe,c).transform(e),f&&p.unshift([D(xn,c,{name:c,value:f})])}}}function tn(n){if(g.push(n),n instanceof Hn)n.left.has_side_effects(e)||p.push(g.slice()),tn(n.right);else if(n instanceof In)tn(n.left),tn(n.right);else if(n instanceof kn)tn(n.expression),n.args.forEach(tn);else if(n instanceof vn)tn(n.expression);else if(n instanceof Nn)tn(n.condition),tn(n.consequent),tn(n.alternative);else if(!(n instanceof yn)||!e.option("unused")&&n instanceof wn)n instanceof H?(tn(n.condition),n.body instanceof z||tn(n.body)):n instanceof an?n.value&&tn(n.value):n instanceof j?(n.init&&tn(n.init),n.condition&&tn(n.condition),n.step&&tn(n.step),n.body instanceof z||tn(n.body)):n instanceof U?(tn(n.object),n.body instanceof z||tn(n.body)):n instanceof pn?(tn(n.condition),n.body instanceof z||tn(n.body),!n.alternative||n.alternative instanceof z||tn(n.alternative)):n instanceof On?n.expressions.forEach(tn):n instanceof O?tn(n.body):n instanceof hn?(tn(n.expression),n.body.forEach(tn)):n instanceof qn?"++"!=n.operator&&"--"!=n.operator||p.push(g.slice()):n instanceof xn&&n.value&&(p.push(g.slice()),tn(n.value));else{var t=n.definitions.length,i=t-200;for(i<0&&(i=0);i<t;i++)tn(n.definitions[i])}g.pop()}function rn(n){if(!(n instanceof xn&&n.name instanceof Gn)){var i=n[n instanceof Hn?"left":"expression"];return!u(i,te)&&i}var r=n.name.definition();if(t(n.name,r.orig)){var o=r.references.length-r.replaced;if(o)return r.orig.length-r.eliminated>1&&!(n.name instanceof re)||(o>1?function(n){var e=n.value;if(e instanceof de&&"arguments"!=e.name){var t=e.definition();if(!t.undeclared)return E=t}}(n):!e.exposed(r))?D(de,n.name,n.name):void 0}}function on(n){return n[n instanceof Hn?"right":"value"]}function un(n){var t=Object.create(null);if(n instanceof qn)return t;var i=new Te(function(n,o){for(var a=n;a instanceof $n;)a=a.expression;(a instanceof de||a instanceof ge)&&(t[a.name]=t[a.name]||r(e,i,n,n,0))});return on(n).walk(i),t}function sn(t){if(t.name instanceof re){var i=e.parent(),r=e.self().argnames,o=r.indexOf(t.name);if(o<0)i.args.length=Math.min(i.args.length,r.length-1);else{var a=i.args;a[o]&&(a[o]=D(Ee,a[o],{value:0}))}return!0}var u=!1;return n[d].transform(new _t(function(n,e,i){return u?n:n===t||n.body===t?(u=!0,n instanceof xn?(n.value=null,n):i?h.skip:null):void 0},function(n){if(n instanceof On)switch(n.expressions.length){case 0:return null;case 1:return n.expressions[0]}}))}function fn(n){for(;n instanceof $n;)n=n.expression;return n instanceof de&&n.definition().scope===c&&!(i&&(n.name in A||b instanceof qn||b instanceof Hn&&"="!=b.operator))}function ln(n){return!(n instanceof qn)&&on(n).has_side_effects(e)}function dn(){if(B)return!1;if(E)return!0;if(C instanceof de){var n=C.definition();if(n.references.length-n.replaced==(b instanceof xn?1:2))return!0}return!1}function gn(n){if(!n.definition)return!0;var e=n.definition();return!(1==e.orig.length&&e.orig[0]instanceof oe)&&(e.scope.get_defun_scope()!==c||!_(e.references,function(n){var e=n.scope.get_defun_scope();return"Scope"==e.TYPE&&(e=e.parent_scope),e===c}))}}function d(n){for(var e=[],t=0;t<n.length;){var i=n[t];i instanceof q&&_(i.body,Fn)?(f=!0,d(i.body),[].splice.apply(n,[t,1].concat(i.body)),t+=i.body.length):i instanceof T?(f=!0,n.splice(t,1)):i instanceof B?e.indexOf(i.value)<0?(t++,e.push(i.value)):(f=!0,n.splice(t,1)):t++}}function m(n,e){for(var t=e.self(),i=function(n){for(var e=0,t=n.length;--t>=0;){var i=n[t];if(i instanceof pn&&i.body instanceof un&&++e>1)return!0}return!1}(n),r=t instanceof J,o=n.length;--o>=0;){var a=n[o],u=_(o),s=n[u];if(r&&!s&&a instanceof un){if(!a.value){f=!0,n.splice(o,1);continue}if(a.value instanceof Tn&&"void"==a.value.operator){f=!0,n[o]=D(O,a,{body:a.value.expression});continue}}if(a instanceof pn){var c;if(d(c=We(a.body))){c.label&&v(c.label.thedef.references,c),f=!0,(a=a.clone()).condition=a.condition.negate(e);var l=g(a.body,c);a.body=D(q,a,{body:L(a.alternative).concat(m())}),a.alternative=D(q,a,{body:l}),n[o]=a.transform(e);continue}if(d(c=We(a.alternative))){c.label&&v(c.label.thedef.references,c),f=!0,(a=a.clone()).body=D(q,a.body,{body:L(a.body).concat(m())});l=g(a.alternative,c);a.alternative=D(q,a.alternative,{body:l}),n[o]=a.transform(e);continue}}if(a instanceof pn&&a.body instanceof un){var p=a.body.value;if(!p&&!a.alternative&&(r&&!s||s instanceof un&&!s.value)){f=!0,n[o]=D(O,a.condition,{body:a.condition});continue}if(p&&!a.alternative&&s instanceof un&&s.value){f=!0,(a=a.clone()).alternative=s,n.splice(o,1,a.transform(e)),n.splice(u,1);continue}if(p&&!a.alternative&&(!s&&r&&i||s instanceof un)){f=!0,(a=a.clone()).alternative=s||D(un,a,{value:null}),n.splice(o,1,a.transform(e)),s&&n.splice(u,1);continue}var h=n[b(o)];if(e.option("sequences")&&r&&!a.alternative&&h instanceof pn&&h.body instanceof un&&_(u)==n.length&&s instanceof O){f=!0,(a=a.clone()).alternative=D(q,s,{body:[s,D(un,s,{value:null})]}),n.splice(o,1,a.transform(e)),n.splice(u,1);continue}}}function d(i){if(!i)return!1;for(var a=o+1,u=n.length;a<u;a++){var s=n[a];if(s instanceof wn||s instanceof En)return!1}var c,f=i instanceof cn?e.loopcontrol_target(i):null;return i instanceof un&&r&&(!(c=i.value)||c instanceof Tn&&"void"==c.operator)||i instanceof ln&&t===Yn(f)||i instanceof fn&&f instanceof q&&t===f}function m(){var e=n.slice(o+1);return n.length=o+1,e.filter(function(e){return!(e instanceof G)||(n.push(e),!1)})}function g(n,e){var t=L(n).slice(0,-1);return e.value&&t.push(D(O,e.value,{body:e.value.expression})),t}function _(e){for(var t=e+1,i=n.length;t<i;t++){var r=n[t];if(!(r instanceof bn&&y(r)))break}return t}function b(e){for(var t=e;--t>=0;){var i=n[t];if(!(i instanceof bn&&y(i)))break}return t}}function g(n,e){for(var t,i=e.self(),r=0,o=0,a=n.length;r<a;r++){var u=n[r];if(u instanceof cn){var s=e.loopcontrol_target(u);u instanceof fn&&!(s instanceof N)&&Yn(s)===i||u instanceof ln&&Yn(s)===i?u.label&&v(u.label.thedef.references,u):n[o++]=u}else n[o++]=u;if(We(u)){t=n.slice(r+1);break}}n.length=o,f=o!=a,t&&t.forEach(function(t){_e(e,t,n)})}function y(n){return _(n.definitions,function(n){return!n.value})}function b(n,e){if(!(n.length<2)){for(var t=[],i=0,r=0,o=n.length;r<o;r++){var a=n[r];if(a instanceof O){t.length>=e.sequences_limit&&s();var u=a.body;t.length>0&&(u=u.drop_side_effect_free(e)),u&&S(t,u)}else a instanceof yn&&y(a)||a instanceof G?n[i++]=a:(s(),n[i++]=a)}s(),n.length=i,i!=o&&(f=!0)}function s(){if(t.length){var e=F(t[0],t);n[i++]=D(O,e,{body:e}),t=[]}}}function E(n,e){if(!(n instanceof q))return n;for(var t=null,i=0,r=n.body.length;i<r;i++){var o=n.body[i];if(o instanceof bn&&y(o))e.push(o);else{if(t)return!1;t=o}}return t}function w(n,e){function t(n){r--,f=!0;var t=i.body;return F(t,[t,n]).transform(e)}for(var i,r=0,o=0;o<n.length;o++){var a=n[o];if(i)if(a instanceof an)a.value=t(a.value||D(xe,a).transform(e));else if(a instanceof j){if(!(a.init instanceof yn)){var u=!1;i.body.walk(new Te(function(n){return!!(u||n instanceof V)||(n instanceof In&&"in"==n.operator?(u=!0,!0):void 0)})),u||(a.init?a.init=t(a.init):(a.init=i.body,r--,f=!0))}}else a instanceof U?a.init instanceof wn||a.init instanceof En||(a.object=t(a.object)):a instanceof pn?a.condition=t(a.condition):a instanceof hn?a.expression=t(a.expression):a instanceof Y&&(a.expression=t(a.expression));if(e.option("conditionals")&&a instanceof pn){var s=[],c=E(a.body,s),l=E(a.alternative,s);if(!1!==c&&!1!==l&&s.length>0){var p=s.length;s.push(D(pn,a,{condition:a.condition,body:c||D(T,a.body),alternative:l})),s.unshift(r,1),[].splice.apply(n,s),o+=p,r+=p+1,i=null,f=!0;continue}}n[r++]=a,i=a instanceof O?a:null}n.length=r}function C(n,t){if(n instanceof yn){var i,r=n.definitions[n.definitions.length-1];if(r.value instanceof jn)if(t instanceof Hn?i=[t]:t instanceof On&&(i=t.expressions.slice()),i){var o=!1;do{var a=i[0];if(!(a instanceof Hn))break;if("="!=a.operator)break;if(!(a.left instanceof $n))break;var u=a.left.expression;if(!(u instanceof de))break;if(r.name.name!=u.name)break;if(!a.right.is_constant_expression(c))break;var s=a.left.property;if(s instanceof A&&(s=s.evaluate(e)),s instanceof A)break;s=""+s;var f=e.option("ecma")<6&&e.has_directive("use strict")?function(n){return n.key!=s&&n.key.name!=s}:function(n){return n.key.name!=s};if(!_(r.value.properties,f))break;var l=r.value.properties.filter(function(n){return n.key===s})[0];l.value=new On({start:l.start,expressions:[l.value,a.right],end:l.end}),i.shift(),o=!0}while(i.length);return o&&i}}}function x(n){for(var e,t=0,i=-1,r=n.length;t<r;t++){var o=n[t],a=n[i];if(o instanceof yn)a&&a.TYPE==o.TYPE?(a.definitions=a.definitions.concat(o.definitions),f=!0):e&&e.TYPE==o.TYPE&&y(o)?(e.definitions=e.definitions.concat(o.definitions),f=!0):(n[++i]=o,e=o);else if(o instanceof an)o.value=s(o.value);else if(o instanceof j){(u=C(a,o.init))?(f=!0,o.init=u.length?F(o.init,u):null,n[++i]=o):a instanceof bn&&(!o.init||o.init.TYPE==a.TYPE)?(o.init&&(a.definitions=a.definitions.concat(o.init.definitions)),o.init=a,n[i]=o,f=!0):e&&o.init&&e.TYPE==o.init.TYPE&&y(o.init)?(e.definitions=e.definitions.concat(o.init.definitions),o.init=null,n[++i]=o,f=!0):n[++i]=o}else if(o instanceof U)o.object=s(o.object);else if(o instanceof pn)o.condition=s(o.condition);else if(o instanceof O){var u;if(u=C(a,o.body)){if(f=!0,!u.length)continue;o.body=F(o.body,u)}n[++i]=o}else o instanceof hn?o.expression=s(o.expression):o instanceof Y?o.expression=s(o.expression):n[++i]=o}function s(e){n[++i]=o;var t=C(a,e);return t?(f=!0,t.length?F(e,t):e instanceof On?e.tail_node().left:e.left):e}n.length=i+1}}function _e(n,e,t){e instanceof G||n.warn("Dropping unreachable code [{file}:{line},{col}]",e.start),e.walk(new Te(function(i){return i instanceof bn?(n.warn("Declarations in unreachable code! [{file}:{line},{col}]",i.start),i.remove_initializers(),t.push(i),!0):i instanceof G&&(i===e||!n.has_directive("use strict"))?(t.push(i===e?i:D(bn,i,{definitions:[D(xn,i,{name:D(ne,i.name,i.name),value:null})]})),!0):i instanceof V||void 0}))}function Fe(n){return n instanceof ye?n.getValue():n instanceof Tn&&"void"==n.operator&&n.expression instanceof ye?void 0:n}function Se(n,e){return n.is_undefined||n instanceof xe||n instanceof Tn&&"void"==n.operator&&!n.expression.has_side_effects(e)}!function(n){function e(n){return/strict/.test(n.option("pure_getters"))}A.DEFMETHOD("may_throw_on_access",function(n){return!n.option("pure_getters")||this._dot_throw(n)}),n(A,e),n(Ce,f),n(xe,f),n(ye,c),n(Rn,c),n(jn,function(n){if(!e(n))return!1;for(var t=this.properties.length;--t>=0;)if(this.properties[t]._dot_throw(n))return!0;return!1}),n(Un,c),n(Vn,f),n(X,function(n){return this.expression._dot_throw(n)}),n(Q,c),n(K,c),n(Sn,c),n(Tn,function(){return"void"==this.operator}),n(In,function(n){return("&&"==this.operator||"||"==this.operator)&&(this.left._dot_throw(n)||this.right._dot_throw(n))}),n(Hn,function(n){return"="==this.operator&&this.right._dot_throw(n)}),n(Nn,function(n){return this.consequent._dot_throw(n)||this.alternative._dot_throw(n)}),n(Mn,function(n){return!!e(n)&&!(this.expression instanceof Q&&"prototype"==this.property)}),n(On,function(n){return this.tail_node()._dot_throw(n)}),n(de,function(n){if(this.is_undefined)return!0;if(!e(n))return!1;if(ie(this)&&this.is_declared(n))return!1;if(this.is_immutable())return!1;var t=this.fixed_value();return!t||t._dot_throw(n)})}(function(n,e){n.DEFMETHOD("_dot_throw",e)}),le=["!","delete"],pe=["in","instanceof","==","!=","===","!==","<","<=",">=",">"],(ce=function(n,e){n.DEFMETHOD("is_boolean",e)})(A,c),ce(Tn,function(){return t(this.operator,le)}),ce(In,function(){return t(this.operator,pe)||Ie(this.operator)&&this.left.is_boolean()&&this.right.is_boolean()}),ce(Nn,function(){return this.consequent.is_boolean()&&this.alternative.is_boolean()}),ce(Hn,function(){return"="==this.operator&&this.right.is_boolean()}),ce(On,function(){return this.tail_node().is_boolean()}),ce(Me,f),ce($e,f),function(n){n(A,c),n(Ee,f);var e=g("+ - ~ ++ --");n(qn,function(){return e(this.operator)});var t=g("- * / % & | ^ << >> >>>");n(In,function(n){return t(this.operator)||"+"==this.operator&&this.left.is_number(n)&&this.right.is_number(n)}),n(Hn,function(n){return t(this.operator.slice(0,-1))||"="==this.operator&&this.right.is_number(n)}),n(On,function(n){return this.tail_node().is_number(n)}),n(Nn,function(n){return this.consequent.is_number(n)&&this.alternative.is_number(n)})}(function(n,e){n.DEFMETHOD("is_number",e)}),function(n){n(A,c),n(be,f),n(tn,function(){return 1===this.segments.length}),n(Tn,function(){return"typeof"==this.operator}),n(In,function(n){return"+"==this.operator&&(this.left.is_string(n)||this.right.is_string(n))}),n(Hn,function(n){return("="==this.operator||"+="==this.operator)&&this.right.is_string(n)}),n(On,function(n){return this.tail_node().is_string(n)}),n(Nn,function(n){return this.consequent.is_string(n)&&this.alternative.is_string(n)})}(function(n,e){n.DEFMETHOD("is_string",e)});var Ie=g("&& ||"),Ne=g("delete ++ --");function He(n,e){return e instanceof qn&&Ne(e.operator)?e.expression:e instanceof Hn&&e.left===n?n:void 0}function Pe(n,e){return n.print_to_string().length>e.print_to_string().length?e:n}function Re(n,e,t){return(E(n)?function(n,e){return Pe(D(O,n,{body:n}),D(O,e,{body:e})).body}:Pe)(e,t)}function je(n){for(var e in n)n[e]=g(n[e])}!function(n){function e(n,e){n.warn("global_defs "+e.print_to_string()+" redefined [{file}:{line},{col}]",e.start)}W.DEFMETHOD("resolve_defines",function(n){return n.option("global_defs")?(this.figure_out_scope({ie8:n.option("ie8")}),this.transform(new _t(function(t){var i=t._find_defs(n,"");if(i){for(var r,o=0,a=t;(r=this.parent(o++))&&r instanceof $n&&r.expression===a;)a=r;if(!He(a,r))return i;e(n,t)}}))):this}),n(A,s),n(Mn,function(n,e){return this.expression._find_defs(n,"."+this.property+e)}),n(Gn,function(n){this.global()&&b(n.option("global_defs"),this.name)&&e(n,this)}),n(de,function(n,e){if(this.global()){var t=n.option("global_defs"),i=this.name+e;return b(t,i)?function n(e,t){if(e instanceof A)return D(e.CTOR,t,e);if(Array.isArray(e))return D(Rn,t,{elements:e.map(function(e){return n(e,t)})});if(e&&"object"==typeof e){var i=[];for(var r in e)b(e,r)&&i.push(D(Ln,t,{key:r,value:n(e[r],t)}));return D(jn,t,{properties:i})}return C(e,t)}(t[i],this):void 0}})}(function(n,e){n.DEFMETHOD("_find_defs",e)});var Ue=["constructor","toString","valueOf"],Le={Array:["indexOf","join","lastIndexOf","slice"].concat(Ue),Boolean:Ue,Function:Ue,Number:["toExponential","toFixed","toPrecision"].concat(Ue),Object:Ue,RegExp:["test"].concat(Ue),String:["charAt","charCodeAt","concat","indexOf","italics","lastIndexOf","match","replace","search","slice","split","substr","substring","toLowerCase","toUpperCase","trim"].concat(Ue)};je(Le);var Ye={Array:["isArray"],Math:["abs","acos","asin","atan","ceil","cos","exp","floor","log","round","sin","sqrt","tan","atan2","pow","max","min"],Number:["isFinite","isNaN"],Object:["create","getOwnPropertyDescriptor","getOwnPropertyNames","getPrototypeOf","isExtensible","isFrozen","isSealed","keys"],String:["fromCharCode"]};je(Ye),function(n){A.DEFMETHOD("evaluate",function(n){if(!n.option("evaluate"))return this;var e=this._eval(n,1);return!e||e instanceof RegExp?e:"function"==typeof e||"object"==typeof e?this:e});var e=g("! ~ - + void");A.DEFMETHOD("is_constant",function(){return this instanceof ye?!(this instanceof we):this instanceof Tn&&this.expression instanceof ye&&e(this.operator)}),n(x,function(){throw new Error(m("Cannot evaluate a statement [{file}:{line},{col}]",this.start))}),n(J,l),n(Xn,l),n(A,l),n(ye,function(){return this.getValue()}),n(tn,function(){return 1!==this.segments.length?this:this.segments[0].value}),n(Q,function(n){if(n.option("unsafe")){var e=function(){};return e.node=this,e.toString=function(){return this.node.print_to_string()},e}return this}),n(Rn,function(n,e){if(n.option("unsafe")){for(var t=[],i=0,r=this.elements.length;i<r;i++){var o=this.elements[i],a=o._eval(n,e);if(o===a)return this;t.push(a)}return t}return this}),n(jn,function(n,e){if(n.option("unsafe")){for(var t={},i=0,r=this.properties.length;i<r;i++){var o=this.properties[i];if(o instanceof X)return this;var a=o.key;if(a instanceof Qn)a=a.name;else if(a instanceof A&&(a=a._eval(n,e))===o.key)return this;if("function"==typeof Object.prototype[a])return this;if(!(o.value instanceof Q)&&(t[a]=o.value._eval(n,e),t[a]===o.value))return this}return t}return this});var t=g("! typeof void");n(Tn,function(n,e){var i=this.expression;if(n.option("typeofs")&&"typeof"==this.operator&&(i instanceof J||i instanceof de&&i.fixed_value()instanceof J))return"function";if(t(this.operator)||e++,(i=i._eval(n,e))===this.expression)return this;switch(this.operator){case"!":return!i;case"typeof":return i instanceof RegExp?this:typeof i;case"void":return;case"~":return~i;case"-":return-i;case"+":return+i}return this});var i=g("&& || === !==");n(In,function(n,e){i(this.operator)||e++;var t=this.left._eval(n,e);if(t===this.left)return this;var r,o=this.right._eval(n,e);if(o===this.right)return this;switch(this.operator){case"&&":r=t&&o;break;case"||":r=t||o;break;case"|":r=t|o;break;case"&":r=t&o;break;case"^":r=t^o;break;case"+":r=t+o;break;case"*":r=t*o;break;case"**":r=Math.pow(t,o);break;case"/":r=t/o;break;case"%":r=t%o;break;case"-":r=t-o;break;case"<<":r=t<<o;break;case">>":r=t>>o;break;case">>>":r=t>>>o;break;case"==":r=t==o;break;case"===":r=t===o;break;case"!=":r=t!=o;break;case"!==":r=t!==o;break;case"<":r=t<o;break;case"<=":r=t<=o;break;case">":r=t>o;break;case">=":r=t>=o;break;default:return this}return isNaN(r)&&n.find_parent(Y)?this:r}),n(Nn,function(n,e){var t=this.condition._eval(n,e);if(t===this.condition)return this;var i=t?this.consequent:this.alternative,r=i._eval(n,e);return r===i?this:r}),n(de,function(n,e){var t,i=this.fixed_value();if(!i)return this;if(b(i,"_eval"))t=i._eval();else{if(this._eval=l,t=i._eval(n,e),delete this._eval,t===i)return this;i._eval=function(){return t}}if(t&&"object"==typeof t){var r=this.definition().escaped;if(r&&e>r)return this}return t});var r={Array:Array,Math:Math,Number:Number,Object:Object,String:String},o={Math:["E","LN10","LN2","LOG2E","LOG10E","PI","SQRT1_2","SQRT2"],Number:["MAX_VALUE","MIN_VALUE","NaN","NEGATIVE_INFINITY","POSITIVE_INFINITY"]};je(o),n($n,function(n,e){if(n.option("unsafe")){var t=this.property;if(t instanceof A&&(t=t._eval(n,e))===this.property)return this;var i,a=this.expression;if(ie(a)){if(!(o[a.name]||c)(t))return this;i=r[a.name]}else{if(!(i=a._eval(n,e+1))||i===a||!b(i,t))return this;if("function"==typeof i)switch(t){case"name":return i.node.name?i.node.name.name:"";case"length":return i.node.argnames.length;default:return this}}return i[t]}return this}),n(kn,function(n,e){var t=this.expression;if(n.option("unsafe")&&t instanceof $n){var i,o=t.property;if(o instanceof A&&(o=o._eval(n,e))===t.property)return this;var a=t.expression;if(ie(a)){if(!(Ye[a.name]||c)(o))return this;i=r[a.name]}else if((i=a._eval(n,e+1))===a||!(i&&Le[i.constructor.name]||c)(o))return this;for(var u=[],s=0,f=this.args.length;s<f;s++){var l=this.args[s],p=l._eval(n,e);if(l===p)return this;u.push(p)}try{return i[o].apply(i,u)}catch(e){n.warn("Error evaluating {code} [{file}:{line},{col}]",{code:this.print_to_string(),file:this.start.file,line:this.start.line,col:this.start.col})}}return this}),n(Bn,l)}(function(n,e){n.DEFMETHOD("_eval",e)}),function(n){function e(n){return D(Tn,n,{operator:"!",expression:n})}function t(n,t,i){var r=e(n);if(i){var o=D(O,t,{body:t});return Pe(r,o)===o?t:r}return Pe(r,t)}n(A,function(){return e(this)}),n(x,function(){throw new Error("Cannot negate a statement")}),n(Q,function(){return e(this)}),n(K,function(){return e(this)}),n(Tn,function(){return"!"==this.operator?this.expression:e(this)}),n(On,function(n){var e=this.expressions.slice();return e.push(e.pop().negate(n)),F(this,e)}),n(Nn,function(n,e){var i=this.clone();return i.consequent=i.consequent.negate(n),i.alternative=i.alternative.negate(n),t(this,i,e)}),n(In,function(n,i){var r=this.clone(),o=this.operator;if(n.option("unsafe_comps"))switch(o){case"<=":return r.operator=">",r;case"<":return r.operator=">=",r;case">=":return r.operator="<",r;case">":return r.operator="<=",r}switch(o){case"==":return r.operator="!=",r;case"!=":return r.operator="==",r;case"===":return r.operator="!==",r;case"!==":return r.operator="===",r;case"&&":return r.operator="||",r.left=r.left.negate(n,i),r.right=r.right.negate(n),t(this,r,i);case"||":return r.operator="&&",r.left=r.left.negate(n,i),r.right=r.right.negate(n),t(this,r,i)}return e(this)})}(function(n,e){n.DEFMETHOD("negate",function(n,t){return e.call(this,n,t)})});var Ve=g("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");function We(n){return n&&n.aborts()}kn.DEFMETHOD("is_expr_pure",function(n){if(n.option("unsafe")){var e=this.expression;if(ie(e)&&Ve(e.name))return!0;if(e instanceof Mn&&ie(e.expression)&&(Ye[e.expression.name]||c)(e.property))return!0}return this.pure||!n.pure_funcs(this)}),A.DEFMETHOD("is_call_pure",c),Mn.DEFMETHOD("is_call_pure",function(n){if(n.option("unsafe")){var e=this.expression,t=c;return e instanceof Rn?t=Le.Array:e.is_boolean()?t=Le.Boolean:e.is_number(n)?t=Le.Number:e instanceof we?t=Le.RegExp:e.is_string(n)?t=Le.String:this.may_throw_on_access(n)||(t=Le.Object),t(this.property)}}),function(n){function e(n,e){for(var t=n.length;--t>=0;)if(n[t].has_side_effects(e))return!0;return!1}n(A,f),n(T,c),n(ye,c),n(ge,c),n(z,function(n){return e(this.body,n)}),n(kn,function(n){return!(this.is_expr_pure(n)||this.expression.is_call_pure(n)&&!this.expression.has_side_effects(n))||e(this.args,n)}),n(hn,function(n){return this.expression.has_side_effects(n)||e(this.body,n)}),n(vn,function(n){return this.expression.has_side_effects(n)||e(this.body,n)}),n(Dn,function(n){return e(this.body,n)||this.bcatch&&this.bcatch.has_side_effects(n)||this.bfinally&&this.bfinally.has_side_effects(n)}),n(pn,function(n){return this.condition.has_side_effects(n)||this.body&&this.body.has_side_effects(n)||this.alternative&&this.alternative.has_side_effects(n)}),n(I,function(n){return this.body.has_side_effects(n)}),n(O,function(n){return this.body.has_side_effects(n)}),n(J,c),n(Xn,c),n(Jn,f),n(In,function(n){return this.left.has_side_effects(n)||this.right.has_side_effects(n)}),n(Hn,f),n(Nn,function(n){return this.condition.has_side_effects(n)||this.consequent.has_side_effects(n)||this.alternative.has_side_effects(n)}),n(qn,function(n){return Ne(this.operator)||this.expression.has_side_effects(n)}),n(de,function(n){return!this.is_declared(n)}),n(Gn,c),n(jn,function(n){return e(this.properties,n)}),n(Un,function(n){return!!(this.key instanceof Ln&&this.key.has_side_effects(n))||this.value.has_side_effects(n)}),n(Rn,function(n){return e(this.elements,n)}),n(Mn,function(n){return this.expression.may_throw_on_access(n)||this.expression.has_side_effects(n)}),n(zn,function(n){return this.expression.may_throw_on_access(n)||this.expression.has_side_effects(n)||this.property.has_side_effects(n)}),n(On,function(n){return e(this.expressions,n)}),n(yn,function(n){return e(this.definitions,n)}),n(xn,function(n){return this.value}),n(rn,c),n(tn,function(n){return e(this.segments,n)})}(function(n,e){n.DEFMETHOD("has_side_effects",e)}),function(n){function e(n,e){for(var t=n.length;--t>=0;)if(n[t].may_throw(e))return!0;return!1}n(A,f),n(Xn,c),n(ye,c),n(T,c),n(J,c),n(Gn,c),n(ge,c),n(Rn,function(n){return e(this.elements,n)}),n(Hn,function(n){return!!this.right.may_throw(n)||!(!n.has_directive("use strict")&&"="==this.operator&&this.left instanceof de)&&this.left.may_throw(n)}),n(In,function(n){return this.left.may_throw(n)||this.right.may_throw(n)}),n(z,function(n){return e(this.body,n)}),n(kn,function(n){return!!e(this.args,n)||!this.is_expr_pure(n)&&(!!this.expression.may_throw(n)||(!(this.expression instanceof J)||e(this.expression.body,n)))}),n(vn,function(n){return this.expression.may_throw(n)||e(this.body,n)}),n(Nn,function(n){return this.condition.may_throw(n)||this.consequent.may_throw(n)||this.alternative.may_throw(n)}),n(yn,function(n){return e(this.definitions,n)}),n(Mn,function(n){return this.expression.may_throw_on_access(n)||this.expression.may_throw(n)}),n(pn,function(n){return this.condition.may_throw(n)||this.body&&this.body.may_throw(n)||this.alternative&&this.alternative.may_throw(n)}),n(I,function(n){return this.body.may_throw(n)}),n(jn,function(n){return e(this.properties,n)}),n(Un,function(n){return this.value.may_throw(n)}),n(un,function(n){return this.value&&this.value.may_throw(n)}),n(On,function(n){return e(this.expressions,n)}),n(O,function(n){return this.body.may_throw(n)}),n(zn,function(n){return this.expression.may_throw_on_access(n)||this.expression.may_throw(n)||this.property.may_throw(n)}),n(hn,function(n){return this.expression.may_throw(n)||e(this.body,n)}),n(de,function(n){return!this.is_declared(n)}),n(Dn,function(n){return this.bcatch?this.bcatch.may_throw(n):e(this.body,n)||this.bfinally&&this.bfinally.may_throw(n)}),n(qn,function(n){return!("typeof"==this.operator&&this.expression instanceof de)&&this.expression.may_throw(n)}),n(xn,function(n){return!!this.value&&this.value.may_throw(n)})}(function(n,e){n.DEFMETHOD("may_throw",e)}),function(n){function e(n){for(var e=n.length;--e>=0;)if(!n[e].is_constant_expression())return!1;return!0}function i(n){var e=this,i=!0;return e.walk(new Te(function(r){if(!i)return!0;if(r instanceof de){if(e.inlined)return i=!1,!0;var o=r.definition();if(t(o,e.enclosed)&&!e.variables.has(o.name)){if(n){var a=n.find_variable(r);if(o.undeclared?!a:a===o)return i="f",!0}i=!1}return!0}return r instanceof ge&&e instanceof K?(i=!1,!0):void 0})),i}n(A,c),n(ye,f),n(Xn,function(n){return!(this.extends&&!this.extends.is_constant_expression(n))&&i.call(this,n)}),n(J,i),n(qn,function(){return this.expression.is_constant_expression()}),n(In,function(){return this.left.is_constant_expression()&&this.right.is_constant_expression()}),n(Rn,function(){return e(this.elements)}),n(jn,function(){return e(this.properties)}),n(Un,function(){return!(this.key instanceof A)&&this.value.is_constant_expression()})}(function(n,e){n.DEFMETHOD("is_constant_expression",e)}),function(n){function e(){for(var n=0;n<this.body.length;n++)if(We(this.body[n]))return this.body[n];return null}n(x,p),n(on,l),n(Cn,function(){return null}),n(q,e),n(dn,e),n(pn,function(){return this.alternative&&We(this.body)&&We(this.alternative)&&this})}(function(n,e){n.DEFMETHOD("aborts",e)});var Xe=["use asm","use strict"];function Je(n,e){return De(n.body,e),e.option("side_effects")&&1==n.body.length&&n.body[0]===e.has_directive("use strict")&&(n.body.length=0),n}function Ze(n,e){var t=!1,i=new Te(function(e){return!!(t||e instanceof V)||(e instanceof cn&&i.loopcontrol_target(e)===n?t=!0:void 0)});return e instanceof I&&i.push(e),i.push(n),n.body.walk(i),t}function Qe(n,e){return e.top_retain&&n instanceof G&&n._top&&n.name&&e.top_retain(n.name)}n(B,function(n,e){return!e.option("directives")||t(n.value,Xe)&&e.has_directive(n.value)===n?n:D(T,n)}),n(k,function(n,e){return e.option("drop_debugger")?D(T,n):n}),n(I,function(n,e){return n.body instanceof fn&&e.loopcontrol_target(n.body)===n.body?D(T,n):0==n.label.references.length?n.body:n}),n(z,function(n,e){return De(n.body,e),n}),n(q,function(n,e){switch(De(n.body,e),n.body.length){case 1:if(!e.has_directive("use strict")&&e.parent()instanceof pn&&!((t=n.body[0])instanceof wn||t instanceof En||t instanceof Xn)||Fn(n.body[0]))return n.body[0];break;case 0:return D(T,n)}var t;return n}),n(J,Je),V.DEFMETHOD("drop_unused",function(n){if(n.option("unused")&&!n.has_directive("use asm")){var e=this;if(!e.pinned()){var t=!(e instanceof W)||n.toplevel.funcs,i=!(e instanceof W)||n.toplevel.vars,r=/keep_assign/.test(n.option("unused"))?c:function(n){return n instanceof Hn&&(n.write_only||"="==n.operator)?n.left:n instanceof qn&&n.write_only?n.expression:void 0},o=[],a=Object.create(null),s=Object.create(null);e instanceof W&&n.top_retain&&e.variables.each(function(e){!n.top_retain(e)||e.id in a||(a[e.id]=!0,o.push(e))});var f=new y,l=new y,p=null,d=this,m=new Te(function(r,u){if(r instanceof J&&r.uses_arguments&&!m.has_directive("use strict")&&r.argnames.forEach(function(n){if(n instanceof Gn){var e=n.definition();e.id in a||(a[e.id]=!0,o.push(e))}}),r!==e){if(r instanceof G||r instanceof Jn){var c=r.name.definition();return((h=m.parent()instanceof An)||!t&&d===e)&&(!c.global||c.id in a||(a[c.id]=!0,o.push(c))),l.add(c.id,r),!0}if(r instanceof re&&d===e&&f.add(r.definition().id,r),r instanceof yn&&d===e){var h=m.parent()instanceof An;return r.definitions.forEach(function(e){if(e.name instanceof ne&&f.add(e.name.definition().id,e),!h&&i||e.name.walk(new Te(function(n){if(n instanceof Gn){var e=n.definition();!h&&!e.global||e.id in a||(a[e.id]=!0,o.push(e))}})),e.value){if(e.name instanceof nn){var t=p;p=e.value,e.walk(m),p=t}else{var r=e.name.definition();l.add(r.id,e.value),r.chained||e.name.fixed_value()!==e.value||(s[r.id]=e)}e.value.has_side_effects(n)&&e.value.walk(m)}}),!0}return r.destructuring&&p&&l.add(r.name,p),C(r,u)}});e.walk(m),m=new Te(C);for(var g=0;g<o.length;g++){var b=l.get(o[g].id);b&&b.forEach(function(n){n.walk(m)})}var E=new _t(function(o,u,c){var l=E.parent();if(i&&(C=r(o))instanceof de){var p=(m=C.definition()).id in a;if(o instanceof Hn){if(!p||m.id in s&&s[m.id]!==o)return M(l,o,o.right.transform(E))}else if(!p)return D(Ee,o,{value:0})}if(d===e){var m;if(o.name&&(o instanceof Zn&&!w(n.option("keep_classnames"),(m=o.name.definition()).name)||o instanceof Q&&!w(n.option("keep_fnames"),(m=o.name.definition()).name))&&(m.id in a&&!(m.orig.length>1)||(o.name=null)),o instanceof J&&!(o instanceof Z))for(var g=!n.option("keep_fargs"),y=o.argnames,b=y.length;--b>=0;){var C;(C=y[b])instanceof X&&(C=C.expression),C instanceof Pn&&(C=C.left),C instanceof nn||C.definition().id in a?g=!1:(C.__unused=!0,g&&(y.pop(),n[C.unreferenced()?"warn":"info"]("Dropping unused function argument {name} [{file}:{line},{col}]",N(C))))}if((o instanceof G||o instanceof Jn)&&o!==e)if(!((m=o.name.definition()).id in a||!t&&m.global))return n[o.name.unreferenced()?"warn":"info"]("Dropping unused function {name} [{file}:{line},{col}]",N(o.name)),m.eliminated++,D(T,o);if(o instanceof yn&&!(l instanceof U&&l.init===o)){var A=!(l instanceof W||o instanceof bn),x=[],k=[],B=[],$=[];switch(o.definitions.forEach(function(e){e.value&&(e.value=e.value.transform(E));var t=e.name instanceof nn,r=t?new yt(null,{name:"<destructure>"}):e.name.definition();if(A&&r.global)return B.push(e);if(!i&&!A||t&&(e.name.names.length||e.name.is_array||1!=n.option("pure_getters"))||r.id in a){if(e.value&&r.id in s&&s[r.id]!==e&&(e.value=e.value.drop_side_effect_free(n)),e.name instanceof ne){var u=f.get(r.id);if(u.length>1&&(!e.value||r.orig.indexOf(e.name)>r.eliminated)){if(n.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]",N(e.name)),e.value){var c=D(de,e.name,e.name);r.references.push(c);var l=D(Hn,e,{operator:"=",left:c,right:e.value});s[r.id]===e&&(s[r.id]=l),$.push(l.transform(E))}return v(u,e),void r.eliminated++}}e.value?($.length>0&&(B.length>0?($.push(e.value),e.value=F(e.value,$)):x.push(D(O,o,{body:F(o,$)})),$=[]),B.push(e)):k.push(e)}else if(r.orig[0]instanceof fe){(p=e.value&&e.value.drop_side_effect_free(n))&&$.push(p),e.value=null,k.push(e)}else{var p;(p=e.value&&e.value.drop_side_effect_free(n))?(t||n.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]",N(e.name)),$.push(p)):t||n[e.name.unreferenced()?"warn":"info"]("Dropping unused variable {name} [{file}:{line},{col}]",N(e.name)),r.eliminated++}}),(k.length>0||B.length>0)&&(o.definitions=k.concat(B),x.push(o)),$.length>0&&x.push(D(O,o,{body:F(o,$)})),x.length){case 0:return c?h.skip:D(T,o);case 1:return x[0];default:return c?h.splice(x):D(q,o,{body:x})}}if(o instanceof j)return u(o,this),o.init instanceof q&&(z=o.init,o.init=z.body.pop(),z.body.push(o)),o.init instanceof O?o.init=o.init.body:sn(o.init)&&(o.init=null),z?c?h.splice(z.body):z:o;if(o instanceof I&&o.body instanceof j){if(u(o,this),o.body instanceof q){var z=o.body;return o.body=z.body.pop(),z.body.push(o),c?h.splice(z.body):z}return o}if(o instanceof q)return u(o,this),c&&_(o.body,Fn)?h.splice(o.body):o;if(o instanceof V){var S=d;return d=o,u(o,this),d=S,o}}function N(n){return{name:n.name,file:n.start.file,line:n.start.line,col:n.start.col}}});e.transform(E)}}function C(n,t){var i,c=r(n);if(c instanceof de&&!u(n.left,ee)&&e.variables.get(c.name)===(i=c.definition()))return n instanceof Hn&&(n.right.walk(m),i.chained||n.left.fixed_value()!==n.right||(s[i.id]=n)),!0;if(n instanceof de)return(i=n.definition()).id in a||(a[i.id]=!0,o.push(i),(i=i.redefined())&&(a[i.id]=!0,o.push(i))),!0;if(n instanceof V){var f=d;return d=n,t(),d=f,!0}}}),V.DEFMETHOD("hoist_declarations",function(n){var e=this;if(n.has_directive("use asm"))return e;if(!Array.isArray(e.body))return e;var t=n.option("hoist_funs"),r=n.option("hoist_vars");if(t||r){var o=[],a=[],u=new y,s=0,c=0;e.walk(new Te(function(n){return n instanceof V&&n!==e||(n instanceof bn?(++c,!0):void 0)})),r=r&&c>1;var f=new _t(function(i){if(i!==e){if(i instanceof B)return o.push(i),D(T,i);if(t&&i instanceof G&&!(f.parent()instanceof An)&&f.parent()===e)return a.push(i),D(T,i);if(r&&i instanceof bn){i.definitions.forEach(function(n){n.name instanceof nn||(u.set(n.name.name,n),++s)});var c=i.to_assignments(n),l=f.parent();if(l instanceof U&&l.init===i){if(null==c){var p=i.definitions[0].name;return D(de,p,p)}return c}return l instanceof j&&l.init===i?c:c?D(O,i,{body:c}):D(T,i)}if(i instanceof V)return i}});if(e=e.transform(f),s>0){var l=[];if(u.each(function(n,t){e instanceof J&&i(function(e){return e.name==n.name.name},e.args_as_names())?u.del(t):((n=n.clone()).value=null,l.push(n),u.set(t,n))}),l.length>0){for(var p=0;p<e.body.length;){if(e.body[p]instanceof O){var h,d,m=e.body[p].body;if(m instanceof Hn&&"="==m.operator&&(h=m.left)instanceof Qn&&u.has(h.name)){if((g=u.get(h.name)).value)break;g.value=m.right,v(l,g),l.push(g),e.body.splice(p,1);continue}if(m instanceof On&&(d=m.expressions[0])instanceof Hn&&"="==d.operator&&(h=d.left)instanceof Qn&&u.has(h.name)){var g;if((g=u.get(h.name)).value)break;g.value=d.right,v(l,g),l.push(g),e.body[p].body=F(m,m.expressions.slice(1));continue}}if(e.body[p]instanceof T)e.body.splice(p,1);else{if(!(e.body[p]instanceof q))break;var _=[p,1].concat(e.body[p].body);e.body.splice.apply(e.body,_)}}l=D(bn,e,{definitions:l}),a.push(l)}}e.body=o.concat(a,e.body)}return e}),V.DEFMETHOD("var_names",function(){var n=this._var_names;return n||(this._var_names=n=Object.create(null),this.enclosed.forEach(function(e){n[e.name]=!0}),this.variables.each(function(e,t){n[t]=!0})),n}),V.DEFMETHOD("make_var_name",function(n){for(var e=this.var_names(),t=n=n.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi,"_"),i=0;e[t];i++)t=n+"$"+i;return e[t]=!0,t}),V.DEFMETHOD("hoist_properties",function(n){var e=this;if(!n.option("hoist_props")||n.has_directive("use asm"))return e;var t=e instanceof W&&n.top_retain||c,i=Object.create(null),r=new _t(function(o,a){if(o instanceof yn&&r.parent()instanceof An)return o;var u;if(o instanceof xn&&((f=o.name).scope===e&&1!=(l=f.definition()).escaped&&!l.assignments&&!l.direct_access&&!l.single_use&&!n.exposed(l)&&!t(l)&&(u=f.fixed_value())===o.value&&u instanceof jn)){a(o,this);var s=new y,c=[];return u.properties.forEach(function(n){c.push(D(xn,o,{name:p(n.key),value:n.value}))}),i[l.id]=s,h.splice(c)}if(o instanceof $n&&o.expression instanceof de&&(s=i[o.expression.definition().id])){var f,l=s.get(Fe(o.property));return(f=D(de,o,{name:l.name,scope:o.expression.scope,thedef:l})).reference({}),f}function p(n){var t=D(f.CTOR,f,{name:e.make_var_name(f.name+"_"+n),scope:e}),i=e.def_variable(t);return s.set(n,i),e.enclosed.push(i),t}});return e.transform(r)}),function(n){function e(n,e,t){var i=n.length;if(!i)return null;for(var r=[],o=!1,a=0;a<i;a++){var u=n[a].drop_side_effect_free(e,t);o|=u!==n[a],u&&(r.push(u),t=!1)}return o?r.length?r:null:n}n(A,l),n(ye,p),n(ge,p),n(kn,function(n,t){if(!this.is_expr_pure(n)){if(this.expression.is_call_pure(n)){var i=this.args.slice();return i.unshift(this.expression.expression),(i=e(i,n,t))&&F(this,i)}if(o(this.expression)&&(!this.expression.name||!this.expression.name.definition().references.length)){var r=this.clone();return r.expression.process_expression(!1,n),r}return this}this.pure&&n.warn("Dropping __PURE__ call [{file}:{line},{col}]",this.start);var a=e(this.args,n,t);return a&&F(this,a)}),n(Z,p),n(Q,p),n(K,p),n(Zn,p),n(In,function(n,e){var t=this.right.drop_side_effect_free(n);if(!t)return this.left.drop_side_effect_free(n,e);if(Ie(this.operator)){if(t===this.right)return this;var i=this.clone();return i.right=t,i}var r=this.left.drop_side_effect_free(n,e);return r?F(this,[r,t]):this.right.drop_side_effect_free(n,e)}),n(Hn,function(n){var e=this.left;if(e.has_side_effects(n)||n.has_directive("use strict")&&e instanceof $n&&e.expression.is_constant())return this;for(this.write_only=!0;e instanceof $n;)e=e.expression;return e.is_constant_expression(n.find_parent(V))?this.right.drop_side_effect_free(n):this}),n(Nn,function(n){var e=this.consequent.drop_side_effect_free(n),t=this.alternative.drop_side_effect_free(n);if(e===this.consequent&&t===this.alternative)return this;if(!e)return t?D(In,this,{operator:"||",left:this.condition,right:t}):this.condition.drop_side_effect_free(n);if(!t)return D(In,this,{operator:"&&",left:this.condition,right:e});var i=this.clone();return i.consequent=e,i.alternative=t,i}),n(qn,function(n,e){if(Ne(this.operator))return this.write_only=!this.expression.has_side_effects(n),this;if("typeof"==this.operator&&this.expression instanceof de)return null;var t=this.expression.drop_side_effect_free(n,e);return e&&t&&Kn(t)?t===this.expression&&"!"==this.operator?this:t.negate(n,e):t}),n(de,function(n){return this.is_declared(n)?null:this}),n(jn,function(n,t){var i=e(this.properties,n,t);return i&&F(this,i)}),n(Un,function(n,e){return this.value.drop_side_effect_free(n,e)}),n(Rn,function(n,t){var i=e(this.elements,n,t);return i&&F(this,i)}),n(Mn,function(n,e){return this.expression.may_throw_on_access(n)?this:this.expression.drop_side_effect_free(n,e)}),n(zn,function(n,e){if(this.expression.may_throw_on_access(n))return this;var t=this.expression.drop_side_effect_free(n,e);if(!t)return this.property.drop_side_effect_free(n,e);var i=this.property.drop_side_effect_free(n);return i?F(this,[t,i]):t}),n(On,function(n){var e=this.tail_node(),t=e.drop_side_effect_free(n);if(t===e)return this;var i=this.expressions.slice(0,-1);return t&&i.push(t),F(this,i)}),n(X,function(n,e){return this.expression.drop_side_effect_free(n,e)}),n(rn,p),n(tn,function(n){var t=e(this.segments,n,E);return t&&F(this,t)})}(function(n,e){n.DEFMETHOD("drop_side_effect_free",e)}),n(O,function(n,e){if(e.option("side_effects")){var t=n.body,i=t.drop_side_effect_free(e,!0);if(!i)return e.warn("Dropping side-effect-free statement [{file}:{line},{col}]",n.start),D(T,n);if(i!==t)return D(O,n,{body:i})}return n}),n(R,function(n,e){return e.option("loops")?D(j,n,n).optimize(e):n}),n(P,function(n,e){if(!e.option("loops"))return n;var t=n.condition.tail_node().evaluate(e);if(!(t instanceof A)){if(t)return D(j,n,{body:D(q,n.body,{body:[n.body,D(O,n.condition,{body:n.condition})]})}).optimize(e);if(!Ze(n,e.parent()))return D(q,n.body,{body:[n.body,D(O,n.condition,{body:n.condition})]}).optimize(e)}return n}),n(j,function(n,e){if(!e.option("loops"))return n;if(e.option("side_effects")&&n.init&&(n.init=n.init.drop_side_effect_free(e)),n.condition){var t=n.condition.evaluate(e);if(!(t instanceof A))if(t)n.condition=null;else if(!e.option("dead_code")){var i=n.condition;n.condition=C(t,n.condition),n.condition=Pe(n.condition.transform(e),i)}if(e.option("dead_code")&&(t instanceof A&&(t=n.condition.tail_node().evaluate(e)),!t)){var r=[];return _e(e,n.body,r),n.init instanceof x?r.push(n.init):n.init&&r.push(D(O,n.init,{body:n.init})),r.push(D(O,n.condition,{body:n.condition})),D(q,n,{body:r}).optimize(e)}}return function n(e,t){var i=e.body instanceof q?e.body.body[0]:e.body;if(t.option("dead_code")&&o(i)){var r=[];return e.init instanceof x?r.push(e.init):e.init&&r.push(D(O,e.init,{body:e.init})),e.condition&&r.push(D(O,e.condition,{body:e.condition})),_e(t,e.body,r),D(q,e,{body:r})}return i instanceof pn&&(o(i.body)?(e.condition?e.condition=D(In,e.condition,{left:e.condition,operator:"&&",right:i.condition.negate(t)}):e.condition=i.condition.negate(t),a(i.alternative)):o(i.alternative)&&(e.condition?e.condition=D(In,e.condition,{left:e.condition,operator:"&&",right:i.condition}):e.condition=i.condition,a(i.body))),e;function o(n){return n instanceof fn&&t.loopcontrol_target(n)===t.self()}function a(i){i=L(i),e.body instanceof q?(e.body=e.body.clone(),e.body.body=i.concat(e.body.body.slice(1)),e.body=e.body.transform(t)):e.body=D(q,e.body,{body:i}).transform(t),e=n(e,t)}}(n,e)}),n(pn,function(n,e){if(sn(n.alternative)&&(n.alternative=null),!e.option("conditionals"))return n;var t=n.condition.evaluate(e);if(!(e.option("dead_code")||t instanceof A)){var i=n.condition;n.condition=C(t,i),n.condition=Pe(n.condition.transform(e),i)}if(e.option("dead_code")){if(t instanceof A&&(t=n.condition.tail_node().evaluate(e)),!t){e.warn("Condition always false [{file}:{line},{col}]",n.condition.start);var r=[];return _e(e,n.body,r),r.push(D(O,n.condition,{body:n.condition})),n.alternative&&r.push(n.alternative),D(q,n,{body:r}).optimize(e)}if(!(t instanceof A)){e.warn("Condition always true [{file}:{line},{col}]",n.condition.start);r=[];return n.alternative&&_e(e,n.alternative,r),r.push(D(O,n.condition,{body:n.condition})),r.push(n.body),D(q,n,{body:r}).optimize(e)}}var o=n.condition.negate(e),a=n.condition.print_to_string().length,u=o.print_to_string().length,s=u<a;if(n.alternative&&s){s=!1,n.condition=o;var c=n.body;n.body=n.alternative||D(T,n),n.alternative=c}if(sn(n.body)&&sn(n.alternative))return D(O,n.condition,{body:n.condition.clone()}).optimize(e);if(n.body instanceof O&&n.alternative instanceof O)return D(O,n,{body:D(Nn,n,{condition:n.condition,consequent:n.body.body,alternative:n.alternative.body})}).optimize(e);if(sn(n.alternative)&&n.body instanceof O)return a===u&&!s&&n.condition instanceof In&&"||"==n.condition.operator&&(s=!0),s?D(O,n,{body:D(In,n,{operator:"||",left:o,right:n.body.body})}).optimize(e):D(O,n,{body:D(In,n,{operator:"&&",left:n.condition,right:n.body.body})}).optimize(e);if(n.body instanceof T&&n.alternative instanceof O)return D(O,n,{body:D(In,n,{operator:"||",left:n.condition,right:n.alternative.body})}).optimize(e);if(n.body instanceof an&&n.alternative instanceof an&&n.body.TYPE==n.alternative.TYPE)return D(n.body.CTOR,n,{value:D(Nn,n,{condition:n.condition,consequent:n.body.value||D(xe,n.body),alternative:n.alternative.value||D(xe,n.alternative)}).transform(e)}).optimize(e);if(n.body instanceof pn&&!n.body.alternative&&!n.alternative&&(n=D(pn,n,{condition:D(In,n.condition,{operator:"&&",left:n.condition,right:n.body.condition}),body:n.body.body,alternative:null})),We(n.body)&&n.alternative){var f=n.alternative;return n.alternative=null,D(q,n,{body:[n,f]}).optimize(e)}if(We(n.alternative)){r=n.body;return n.body=n.alternative,n.condition=s?o:n.condition.negate(e),n.alternative=null,D(q,n,{body:[n,r]}).optimize(e)}return n}),n(hn,function(n,e){if(!e.option("switches"))return n;var t,i=n.expression.evaluate(e);if(!(i instanceof A)){var r=n.expression;n.expression=C(i,r),n.expression=Pe(n.expression.transform(e),r)}if(!e.option("dead_code"))return n;i instanceof A&&(i=n.expression.tail_node().evaluate(e));for(var o,a,u=[],s=[],c=0,f=n.body.length;c<f&&!a;c++){if((t=n.body[c])instanceof mn)o?_(t,s[s.length-1]):o=t;else if(!(i instanceof A)){if(!((v=t.expression.evaluate(e))instanceof A)&&v!==i){_(t,s[s.length-1]);continue}if(v instanceof A&&(v=t.expression.tail_node().evaluate(e)),v===i&&(a=t,o)){var l=s.indexOf(o);s.splice(l,1),_(o,s[l-1]),o=null}}if(We(t)){var p=s[s.length-1];We(p)&&p.body.length==t.body.length&&D(q,p,p).equivalent_to(D(q,t,t))&&(p.body=[])}s.push(t)}for(;c<f;)_(n.body[c++],s[s.length-1]);for(s.length>0&&(s[0].body=u.concat(s[0].body)),n.body=s;t=s[s.length-1];){var h=t.body[t.body.length-1];if(h instanceof fn&&e.loopcontrol_target(h)===n&&t.body.pop(),t.body.length||t instanceof vn&&(o||t.expression.has_side_effects(e)))break;s.pop()===o&&(o=null)}if(0==s.length)return D(q,n,{body:u.concat(D(O,n.expression,{body:n.expression}))}).optimize(e);if(1==s.length&&(s[0]===a||s[0]===o)){var d=!1,m=new Te(function(e){if(d||e instanceof J||e instanceof O)return!0;e instanceof fn&&m.loopcontrol_target(e)===n&&(d=!0)});if(n.walk(m),!d){var v,g=s[0].body.slice();return(v=s[0].expression)&&g.unshift(D(O,v,{body:v})),g.unshift(D(O,n.expression,{body:n.expression})),D(q,n,{body:g}).optimize(e)}}return n;function _(n,t){t&&!We(t)?t.body=t.body.concat(n.body):_e(e,n,u)}}),n(Dn,function(n,e){if(De(n.body,e),n.bcatch&&n.bfinally&&_(n.bfinally.body,sn)&&(n.bfinally=null),e.option("dead_code")&&_(n.body,sn)){var t=[];return n.bcatch&&(_e(e,n.bcatch,t),t.forEach(function(n){n instanceof yn&&n.definitions.forEach(function(n){var e=n.name.definition().redefined();e&&(n.name=n.name.clone(),n.name.thedef=e)})})),n.bfinally&&(t=t.concat(n.bfinally.body)),D(q,n,{body:t}).optimize(e)}return n}),yn.DEFMETHOD("remove_initializers",function(){var n=[];this.definitions.forEach(function(e){e.name instanceof Gn?(e.value=null,n.push(e)):e.name.walk(new Te(function(t){t instanceof Gn&&n.push(D(xn,e,{name:t,value:null}))}))}),this.definitions=n}),yn.DEFMETHOD("to_assignments",function(n){var e=n.option("reduce_vars"),t=this.definitions.reduce(function(n,t){if(!t.value||t.name instanceof nn){if(t.value){var i=D(xn,t,{name:t.name,value:t.value}),r=D(bn,t,{definitions:[i]});n.push(r)}}else{var o=D(de,t.name,t.name);n.push(D(Hn,t,{operator:"=",left:o,right:t.value})),e&&(o.definition().fixed=!1)}return(t=t.name.definition()).eliminated++,t.replaced--,n},[]);return 0==t.length?null:F(this,t)}),n(yn,function(n,e){return 0==n.definitions.length?D(T,n):n}),n(Cn,function(n,e){return n}),n(kn,function(n,e){var t=n.expression,i=t,r=_(n.args,function(n){return!(n instanceof X)});e.option("reduce_vars")&&i instanceof de&&Qe(i=i.fixed_value(),e)&&(i=t);var a=i instanceof J;if(e.option("unused")&&r&&a&&!i.uses_arguments&&!i.pinned()){for(var u=0,s=0,c=0,f=n.args.length;c<f;c++){if(i.argnames[c]instanceof X){if(i.argnames[c].expression.__unused)for(;c<f;){(y=n.args[c++].drop_side_effect_free(e))&&(n.args[u++]=y)}else for(;c<f;)n.args[u++]=n.args[c++];s=u;break}var l=c>=i.argnames.length;if(l||i.argnames[c].__unused){if(y=n.args[c].drop_side_effect_free(e))n.args[u++]=y;else if(!l){n.args[u++]=D(Ee,n.args[c],{value:0});continue}}else n.args[u++]=n.args[c];s=u}n.args.length=s}if(e.option("unsafe"))if(ie(t))switch(t.name){case"Array":if(1!=n.args.length)return D(Rn,n,{elements:n.args}).optimize(e);break;case"Object":if(0==n.args.length)return D(jn,n,{properties:[]});break;case"String":if(0==n.args.length)return D(be,n,{value:""});if(n.args.length<=1)return D(In,n,{left:n.args[0],operator:"+",right:D(be,n,{value:""})}).optimize(e);break;case"Number":if(0==n.args.length)return D(Ee,n,{value:0});if(1==n.args.length)return D(Tn,n,{expression:n.args[0],operator:"+"}).optimize(e);case"Boolean":if(0==n.args.length)return D($e,n);if(1==n.args.length)return D(Tn,n,{expression:D(Tn,n,{expression:n.args[0],operator:"!"}),operator:"!"}).optimize(e);break;case"RegExp":var p=[];if(_(n.args,function(n){var t=n.evaluate(e);return p.unshift(t),n!==t}))try{return Re(e,n,D(we,n,{value:RegExp.apply(RegExp,p)}))}catch(t){e.warn("Error converting {expr} [{file}:{line},{col}]",{expr:n.print_to_string(),file:n.start.file,line:n.start.line,col:n.start.col})}}else if(t instanceof Mn)switch(t.property){case"toString":if(0==n.args.length&&!t.expression.may_throw_on_access(e))return D(In,n,{left:D(be,n,{value:""}),operator:"+",right:t.expression}).optimize(e);break;case"join":if(t.expression instanceof Rn)n:{var h;if(!(n.args.length>0&&(h=n.args[0].evaluate(e))===n.args[0])){var d,m=[],v=[];for(c=0,f=t.expression.elements.length;c<f;c++){var g=t.expression.elements[c];if(g instanceof X)break n;(P=g.evaluate(e))!==g?v.push(P):(v.length>0&&(m.push(D(be,n,{value:v.join(h)})),v.length=0),m.push(g))}return v.length>0&&m.push(D(be,n,{value:v.join(h)})),0==m.length?D(be,n,{value:""}):1==m.length?m[0].is_string(e)?m[0]:D(In,m[0],{operator:"+",left:D(be,n,{value:""}),right:m[0]}):""==h?(d=m[0].is_string(e)||m[1].is_string(e)?m.shift():D(be,n,{value:""}),m.reduce(function(n,e){return D(In,e,{operator:"+",left:n,right:e})},d).optimize(e)):((y=n.clone()).expression=y.expression.clone(),y.expression.expression=y.expression.expression.clone(),y.expression.expression.elements=m,Re(e,n,y));var y}}break;case"charAt":if(t.expression.is_string(e)){var b=n.args[0],E=b?b.evaluate(e):0;if(E!==b)return D(zn,t,{expression:t.expression,property:C(0|E,b||t)}).optimize(e)}break;case"apply":if(2==n.args.length&&n.args[1]instanceof Rn)return(I=n.args[1].elements.slice()).unshift(n.args[0]),D(kn,n,{expression:D(Mn,t,{expression:t.expression,property:"call"}),args:I}).optimize(e);break;case"call":var w=t.expression;if(w instanceof de&&(w=w.fixed_value()),w instanceof J&&!w.contains_this())return(n.args.length?F(this,[n.args[0],D(kn,n,{expression:t.expression,args:n.args.slice(1)})]):D(kn,n,{expression:t.expression,args:[]})).optimize(e)}if(e.option("unsafe_Function")&&ie(t)&&"Function"==t.name){if(0==n.args.length)return D(Q,n,{argnames:[],body:[]}).optimize(e);if(_(n.args,function(n){return n instanceof be}))try{var x=gt(M="n(function("+n.args.slice(0,-1).map(function(n){return n.value}).join(",")+"){"+n.args[n.args.length-1].value+"})"),k={ie8:e.option("ie8")};x.figure_out_scope(k);var B,$=new kt(e.options);(x=x.transform($)).figure_out_scope(k),Ft.reset(),x.compute_char_frequency(k),x.mangle_names(k),x.walk(new Te(function(n){return!!B||(o(n)?(B=n,!0):void 0)})),B.body instanceof A&&(B.body=[D(un,B.body,{value:B.body})]);var M=xt();return q.prototype._codegen.call(B,B,M),n.args=[D(be,n,{value:B.argnames.map(function(n){return n.print_to_string()}).join(",")}),D(be,n.args[n.args.length-1],{value:M.get().replace(/^\{|\}$/g,"")})],n}catch(t){if(!(t instanceof st))throw t;e.warn("Error parsing code passed to new Function [{file}:{line},{col}]",n.args[n.args.length-1].start),e.warn(t.toString())}}var z=a&&i.body;z instanceof A?z=D(un,z,{value:z}):z&&(z=z[0]);var T=a&&!i.is_generator&&!i.async,S=e.option("inline")&&!n.is_expr_pure(e);if(S&&z instanceof un&&T&&(!(P=z.value)||P.is_constant_expression())){P=P?P.clone(!0):D(xe,n);var I=n.args.concat(P);return F(n,I).optimize(e)}if(T){var H,P,R,j,U=-1;if(S&&r&&!i.uses_arguments&&!i.pinned()&&!(e.parent()instanceof Xn)&&!(i.name&&i instanceof Q)&&(!(e.find_parent(J)instanceof K)||0==i.argnames.length&&(i.body instanceof A||1==i.body.length))&&(P=function(n){var t=i.body instanceof A?[i.body]:i.body,r=t.length;if(e.option("inline")<3)return 1==r&&Y(n);n=null;for(var o=0;o<r;o++){var a=t[o];if(a instanceof bn){if(n&&!_(a.definitions,function(n){return!n.value}))return!1}else{if(n)return!1;n=a}}return Y(n)}(z))&&(t===i||e.option("unused")&&1==(H=t.definition()).references.length&&!Ge(e,H)&&i.is_constant_expression(t.scope))&&!n.pure&&!i.contains_this()&&function(){var n=Object.create(null);do{if(!(R=e.parent(++U)).is_block_scope()||e.parent(U-1)instanceof V||R.block_scope&&R.block_scope.variables.each(function(e){n[e.name]=!0}),R instanceof gn)R.argname&&(n[R.argname.name]=!0);else if(R instanceof N)j=[];else if(R instanceof de&&R.fixed_value()instanceof V)return!1}while(!(R instanceof V)||R instanceof K);var t=!(R instanceof W)||e.toplevel.vars,r=e.option("inline");return!(!function(n,e){for(var t=i.body.length,r=0;r<t;r++){var o=i.body[r];if(o instanceof bn){if(!e)return!1;for(var a=o.definitions.length;--a>=0;){var u=o.definitions[a].name;if(u instanceof nn||n[u.name]||he(u.name)||R.var_names()[u.name])return!1;j&&j.push(u.definition())}}}return!0}(n,r>=3&&t)||!function(n,e){for(var t=0,r=i.argnames.length;t<r;t++){var o=i.argnames[t];if(o instanceof Pn){if(o.left.__unused)continue;return!1}if(o instanceof nn)return!1;if(o instanceof X){if(o.expression.__unused)continue;return!1}if(!o.__unused){if(!e||n[o.name]||he(o.name)||R.var_names()[o.name])return!1;j&&j.push(o.definition())}}return!0}(n,r>=2&&t)||j&&0!=j.length&&et(i,j))}()&&!(R instanceof Xn))return i._squeezed=!0,F(n,function(){var t=[],r=[];(function(e,t){for(var r=i.argnames.length,o=n.args.length;--o>=r;)t.push(n.args[o]);for(o=r;--o>=0;){var a=i.argnames[o],u=n.args[o];if(a.__unused||!a.name||R.var_names()[a.name])u&&t.push(u);else{var s=D(ne,a,a);a.definition().orig.push(s),!u&&j&&(u=D(xe,n)),Z(e,t,s,u)}}e.reverse(),t.reverse()})(t,r),function(n,e){for(var t=e.length,r=0,o=i.body.length;r<o;r++){var a=i.body[r];if(a instanceof bn)for(var u=0,s=a.definitions.length;u<s;u++){var c=a.definitions[u],f=c.name;if(Z(n,e,f,c.value),j&&_(i.argnames,function(n){return n.name!=f.name})){var l=i.variables.get(f.name),p=D(de,f,f);l.references.push(p),e.splice(t++,0,D(Hn,c,{operator:"=",left:p,right:D(xe,f)}))}}}}(t,r),r.push(P),t.length&&(c=R.body.indexOf(e.parent(U-1))+1,R.body.splice(c,0,D(bn,i,{definitions:t})));return r}()).optimize(e);if(e.option("side_effects")&&!(i.body instanceof A)&&_(i.body,sn)){I=n.args.concat(D(xe,n));return F(n,I).optimize(e)}}if(e.option("negate_iife")&&e.parent()instanceof O&&Kn(n))return n.negate(e,!0);var L=n.evaluate(e);return L!==n?(L=C(L,n).optimize(e),Re(e,L,n)):n;function Y(e){return e?e instanceof un?e.value?e.value.clone(!0):D(xe,n):e instanceof O?D(Tn,e,{operator:"void",expression:e.body.clone(!0)}):void 0:D(xe,n)}function Z(e,t,i,r){var o=i.definition();R.variables.set(i.name,o),R.enclosed.push(o),R.var_names()[i.name]||(R.var_names()[i.name]=!0,e.push(D(xn,i,{name:i,value:null})));var a=D(de,i,i);o.references.push(a),r&&t.push(D(Hn,n,{operator:"=",left:a,right:r.clone()}))}}),n(Bn,function(n,e){if(e.option("unsafe")){var t=n.expression;if(ie(t))switch(t.name){case"Object":case"RegExp":case"Function":case"Error":case"Array":return D(kn,n,n).transform(e)}}return n}),n(On,function(n,e){if(!e.option("side_effects"))return n;var t,i,r=[];t=E(e),i=n.expressions.length-1,n.expressions.forEach(function(n,o){o<i&&(n=n.drop_side_effect_free(e,t)),n&&(S(r,n),t=!1)});var o=r.length-1;return function(){for(;o>0&&Se(r[o],e);)o--;o<r.length-1&&(r[o]=D(Tn,n,{operator:"void",expression:r[o]}),r.length=o+1)}(),0==o?((n=M(e.parent(),e.self(),r[0]))instanceof On||(n=n.optimize(e)),n):(n.expressions=r,n)}),qn.DEFMETHOD("lift_sequences",function(n){if(n.option("sequences")&&this.expression instanceof On){var e=this.expression.expressions.slice(),t=this.clone();return t.expression=e.pop(),e.push(t),F(this,e).optimize(n)}return this}),n(Sn,function(n,e){return n.lift_sequences(e)}),n(Tn,function(n,e){var t=n.expression;if("delete"==n.operator&&!(t instanceof de||t instanceof $n||ve(t)))return t instanceof On?((t=t.expressions.slice()).push(D(Me,n)),F(n,t).optimize(e)):F(n,[t,D(Me,n)]).optimize(e);var i=n.lift_sequences(e);if(i!==n)return i;if(e.option("side_effects")&&"void"==n.operator)return(t=t.drop_side_effect_free(e))?(n.expression=t,n):D(xe,n).optimize(e);if(e.in_boolean_context())switch(n.operator){case"!":if(t instanceof Tn&&"!"==t.operator)return t.expression;t instanceof In&&(n=Re(e,n,t.negate(e,E(e))));break;case"typeof":return e.warn("Boolean expression always true [{file}:{line},{col}]",n.start),(t instanceof de?D(Me,n):F(n,[t,D(Me,n)])).optimize(e)}if("-"==n.operator&&t instanceof Be&&(t=t.transform(e)),t instanceof In&&("+"==n.operator||"-"==n.operator)&&("*"==t.operator||"/"==t.operator||"%"==t.operator))return D(In,n,{operator:t.operator,left:D(Tn,t.left,{operator:n.operator,expression:t.left}),right:t.right});if("-"!=n.operator||!(t instanceof Ee||t instanceof Be)){var r=n.evaluate(e);if(r!==n)return Re(e,r=C(r,n).optimize(e),n)}return n}),In.DEFMETHOD("lift_sequences",function(n){if(n.option("sequences")){if(this.left instanceof On){var e=this.left.expressions.slice();return(t=this.clone()).left=e.pop(),e.push(t),F(this,e).optimize(n)}if(this.right instanceof On&&!this.left.has_side_effects(n)){for(var t,i="="==this.operator&&this.left instanceof de,r=(e=this.right.expressions).length-1,o=0;o<r&&(i||!e[o].has_side_effects(n));o++);if(o==r)return e=e.slice(),(t=this.clone()).right=e.pop(),e.push(t),F(this,e).optimize(n);if(o>0)return(t=this.clone()).right=F(this.right,e.slice(o)),(e=e.slice(0,o)).push(t),F(this,e).optimize(n)}}return this});var Ke=g("== === != !== * & | ^");function Ge(n,e){for(var t,i=0;t=n.parent(i);i++)if(t instanceof J){var r=t.name;if(r&&r.definition()===e)break}return t}function nt(n,e){return n instanceof de||n.TYPE===e.TYPE}function et(n,e){var i=!1,r=new Te(function(n){return!!i||(n instanceof de&&t(n.definition(),e)?i=!0:void 0)}),o=new Te(function(e){if(i)return!0;if(e instanceof V&&e!==n){var t=o.parent();if(t instanceof kn&&t.expression===e)return;return e.walk(r),!0}});return n.walk(o),i}n(In,function(n,e){function t(){return n.left.is_constant()||n.right.is_constant()||!n.left.has_side_effects(e)&&!n.right.has_side_effects(e)}function i(e){if(t()){e&&(n.operator=e);var i=n.left;n.left=n.right,n.right=i}}if(Ke(n.operator)&&n.right.is_constant()&&!n.left.is_constant()&&(n.left instanceof In&&vt[n.left.operator]>=vt[n.operator]||i()),n=n.lift_sequences(e),e.option("comparisons"))switch(n.operator){case"===":case"!==":var r=!0;(n.left.is_string(e)&&n.right.is_string(e)||n.left.is_number(e)&&n.right.is_number(e)||n.left.is_boolean()&&n.right.is_boolean()||n.left.equivalent_to(n.right))&&(n.operator=n.operator.substr(0,2));case"==":case"!=":if(!r&&Se(n.left,e))n.left=D(Ce,n.left);else if(e.option("typeofs")&&n.left instanceof be&&"undefined"==n.left.value&&n.right instanceof Tn&&"typeof"==n.right.operator){var o=n.right.expression;(o instanceof de?!o.is_declared(e):o instanceof $n&&e.option("ie8"))||(n.right=o,n.left=D(xe,n.left).optimize(e),2==n.operator.length&&(n.operator+="="))}else if(n.left instanceof de&&n.right instanceof de&&n.left.definition()===n.right.definition()&&((s=n.left.fixed_value())instanceof Rn||s instanceof J||s instanceof jn||s instanceof Xn))return D("="==n.operator[0]?Me:$e,n);break;case"&&":case"||":var a=n.left;if(a.operator==n.operator&&(a=a.right),a instanceof In&&a.operator==("&&"==n.operator?"!==":"===")&&n.right instanceof In&&a.operator==n.right.operator&&(Se(a.left,e)&&n.right.left instanceof Ce||a.left instanceof Ce&&Se(n.right.left,e))&&!a.right.has_side_effects(e)&&a.right.equivalent_to(n.right.right)){var u=D(In,n,{operator:a.operator.slice(0,-1),left:D(Ce,n),right:a.right});return a!==n.left&&(u=D(In,n,{operator:n.operator,left:n.left.left,right:u})),u}}var s;if("+"==n.operator&&e.in_boolean_context()){var c=n.left.evaluate(e),f=n.right.evaluate(e);if(c&&"string"==typeof c)return e.warn("+ in boolean context always true [{file}:{line},{col}]",n.start),F(n,[n.right,D(Me,n)]).optimize(e);if(f&&"string"==typeof f)return e.warn("+ in boolean context always true [{file}:{line},{col}]",n.start),F(n,[n.left,D(Me,n)]).optimize(e)}if(e.option("comparisons")&&n.is_boolean()){if(!(e.parent()instanceof In)||e.parent()instanceof Hn){var l=D(Tn,n,{operator:"!",expression:n.negate(e,E(e))});n=Re(e,n,l)}if(e.option("unsafe_comps"))switch(n.operator){case"<":i(">");break;case"<=":i(">=")}}if("+"==n.operator){if(n.right instanceof be&&""==n.right.getValue()&&n.left.is_string(e))return n.left;if(n.left instanceof be&&""==n.left.getValue()&&n.right.is_string(e))return n.right;if(n.left instanceof In&&"+"==n.left.operator&&n.left.left instanceof be&&""==n.left.left.getValue()&&n.right.is_string(e))return n.left=n.left.right,n.transform(e)}if(e.option("evaluate")){switch(n.operator){case"&&":if(!(c=!!n.left.truthy||!n.left.falsy&&n.left.evaluate(e)))return e.warn("Condition left of && always false [{file}:{line},{col}]",n.start),M(e.parent(),e.self(),n.left).optimize(e);if(!(c instanceof A))return e.warn("Condition left of && always true [{file}:{line},{col}]",n.start),F(n,[n.left,n.right]).optimize(e);if(f=n.right.evaluate(e)){if(!(f instanceof A)){if("&&"==(p=e.parent()).operator&&p.left===e.self()||e.in_boolean_context())return e.warn("Dropping side-effect-free && [{file}:{line},{col}]",n.start),n.left.optimize(e)}}else{if(e.in_boolean_context())return e.warn("Boolean && always false [{file}:{line},{col}]",n.start),F(n,[n.left,D($e,n)]).optimize(e);n.falsy=!0}if("||"==n.left.operator)if(!(h=n.left.right.evaluate(e)))return D(Nn,n,{condition:n.left.left,consequent:n.right,alternative:n.left.right}).optimize(e);break;case"||":var p,h;if(!(c=!!n.left.truthy||!n.left.falsy&&n.left.evaluate(e)))return e.warn("Condition left of || always false [{file}:{line},{col}]",n.start),F(n,[n.left,n.right]).optimize(e);if(!(c instanceof A))return e.warn("Condition left of || always true [{file}:{line},{col}]",n.start),M(e.parent(),e.self(),n.left).optimize(e);if(f=n.right.evaluate(e)){if(!(f instanceof A)){if(e.in_boolean_context())return e.warn("Boolean || always true [{file}:{line},{col}]",n.start),F(n,[n.left,D(Me,n)]).optimize(e);n.truthy=!0}}else if("||"==(p=e.parent()).operator&&p.left===e.self()||e.in_boolean_context())return e.warn("Dropping side-effect-free || [{file}:{line},{col}]",n.start),n.left.optimize(e);if("&&"==n.left.operator)if((h=n.left.right.evaluate(e))&&!(h instanceof A))return D(Nn,n,{condition:n.left.left,consequent:n.left.right,alternative:n.right}).optimize(e)}var d=!0;switch(n.operator){case"+":if(n.left instanceof ye&&n.right instanceof In&&"+"==n.right.operator&&n.right.left instanceof ye&&n.right.is_string(e)&&(n=D(In,n,{operator:"+",left:D(be,n.left,{value:""+n.left.getValue()+n.right.left.getValue(),start:n.left.start,end:n.right.left.end}),right:n.right.right})),n.right instanceof ye&&n.left instanceof In&&"+"==n.left.operator&&n.left.right instanceof ye&&n.left.is_string(e)&&(n=D(In,n,{operator:"+",left:n.left.left,right:D(be,n.right,{value:""+n.left.right.getValue()+n.right.getValue(),start:n.left.right.start,end:n.right.end})})),n.left instanceof In&&"+"==n.left.operator&&n.left.is_string(e)&&n.left.right instanceof ye&&n.right instanceof In&&"+"==n.right.operator&&n.right.left instanceof ye&&n.right.is_string(e)&&(n=D(In,n,{operator:"+",left:D(In,n.left,{operator:"+",left:n.left.left,right:D(be,n.left.right,{value:""+n.left.right.getValue()+n.right.left.getValue(),start:n.left.right.start,end:n.right.left.end})}),right:n.right.right})),n.right instanceof Tn&&"-"==n.right.operator&&n.left.is_number(e)){n=D(In,n,{operator:"-",left:n.left,right:n.right.expression});break}if(n.left instanceof Tn&&"-"==n.left.operator&&t()&&n.right.is_number(e)){n=D(In,n,{operator:"-",left:n.right,right:n.left.expression});break}case"*":d=e.option("unsafe_math");case"&":case"|":case"^":if(n.left.is_number(e)&&n.right.is_number(e)&&t()&&!(n.left instanceof In&&n.left.operator!=n.operator&&vt[n.left.operator]>=vt[n.operator])){var m=D(In,n,{operator:n.operator,left:n.right,right:n.left});n=n.right instanceof ye&&!(n.left instanceof ye)?Re(e,m,n):Re(e,n,m)}d&&n.is_number(e)&&(n.right instanceof In&&n.right.operator==n.operator&&(n=D(In,n,{operator:n.operator,left:D(In,n.left,{operator:n.operator,left:n.left,right:n.right.left,start:n.left.start,end:n.right.left.end}),right:n.right.right})),n.right instanceof ye&&n.left instanceof In&&n.left.operator==n.operator&&(n.left.left instanceof ye?n=D(In,n,{operator:n.operator,left:D(In,n.left,{operator:n.operator,left:n.left.left,right:n.right,start:n.left.left.start,end:n.right.end}),right:n.left.right}):n.left.right instanceof ye&&(n=D(In,n,{operator:n.operator,left:D(In,n.left,{operator:n.operator,left:n.left.right,right:n.right,start:n.left.right.start,end:n.right.end}),right:n.left.left}))),n.left instanceof In&&n.left.operator==n.operator&&n.left.right instanceof ye&&n.right instanceof In&&n.right.operator==n.operator&&n.right.left instanceof ye&&(n=D(In,n,{operator:n.operator,left:D(In,n.left,{operator:n.operator,left:D(In,n.left.left,{operator:n.operator,left:n.left.right,right:n.right.left,start:n.left.right.start,end:n.right.left.end}),right:n.left.left}),right:n.right.right})))}}if(n.right instanceof In&&n.right.operator==n.operator&&(Ie(n.operator)||"+"==n.operator&&(n.right.left.is_string(e)||n.left.is_string(e)&&n.right.right.is_string(e))))return n.left=D(In,n.left,{operator:n.operator,left:n.left,right:n.right.left}),n.right=n.right.right,n.transform(e);var v=n.evaluate(e);return v!==n?(v=C(v,n).optimize(e),Re(e,v,n)):n}),n(me,function(n,e){return n}),n(de,function(n,e){if(!e.option("ie8")&&ie(n)&&(!n.scope.uses_with||!e.find_parent(Y)))switch(n.name){case"undefined":return D(xe,n).optimize(e);case"NaN":return D(Ae,n).optimize(e);case"Infinity":return D(Be,n).optimize(e)}var t=e.parent();if(e.option("reduce_vars")&&He(n,t)!==n){var i=n.definition();if(e.top_retain&&i.global&&e.top_retain(i))return i.fixed=!1,i.should_replace=!1,i.single_use=!1,n;var r=n.fixed_value(),a=i.single_use&&!(t instanceof kn&&t.is_expr_pure(e));if(a&&(r instanceof J||r instanceof Xn))if(Qe(r,e))a=!1;else if(i.scope!==n.scope&&(!e.option("reduce_funcs")&&r instanceof J||1==i.escaped||r.inlined||function(n){for(var e,t=0;e=n.parent(t++);){if(e instanceof x)return!1;if(e instanceof Rn||e instanceof Ln||e instanceof jn)return!0}return!1}(e)))a=!1;else if(Ge(e,i))a=!1;else if((i.scope!==n.scope||i.orig[0]instanceof re)&&"f"==(a=r.is_constant_expression(n.scope))){var u=n.scope;do{(u instanceof G||o(u))&&(u.inlined=!0)}while(u=u.parent_scope)}if(a&&r){var s;if(r instanceof Jn&&(r=D(Zn,r,r)),r instanceof G&&(r._squeezed=!0,r=D(Q,r,r)),i.recursive_refs>0&&r.name instanceof oe){var c=(s=r.clone(!0)).name.definition(),f=s.variables.get(s.name.name),l=f&&f.orig[0];l instanceof ue||((l=D(ue,s.name,s.name)).scope=s,s.name=l,f=s.def_function(l)),s.walk(new Te(function(n){n instanceof de&&n.definition()===c&&(n.thedef=f,f.references.push(n))}))}else(s=r.optimize(e))===r&&(s=r.clone(!0));return s}if(r&&void 0===i.should_replace){var p;if(r instanceof ge)i.orig[0]instanceof re||!_(i.references,function(n){return i.scope===n.scope})||(p=r);else{var h=r.evaluate(e);h===r||!e.option("unsafe_regexp")&&h instanceof RegExp||(p=C(h,r))}if(p){var d,m=p.optimize(e).print_to_string().length;!function(n){var e;return n.walk(new Te(function(n){if(n instanceof de&&(e=!0),e)return!0})),e}(r)?(m=Math.min(m,r.print_to_string().length),d=function(){var n=Pe(p.optimize(e),r);return n===p||n===r?n.clone(!0):n}):d=function(){var n=p.optimize(e);return n===p?n.clone(!0):n};var v=i.name.length,g=0;e.option("unused")&&!e.exposed(i)&&(g=(v+2+m)/(i.references.length-i.assignments)),i.should_replace=m<=v+g&&d}else i.should_replace=!1}if(i.should_replace)return i.should_replace()}return n}),n(xe,function(n,e){if(e.option("unsafe_undefined")){var t=d(e,"undefined");if(t){var i=D(de,n,{name:"undefined",scope:t.scope,thedef:t});return i.is_undefined=!0,i}}var r=He(e.self(),e.parent());return r&&nt(r,n)?n:D(Tn,n,{operator:"void",expression:D(Ee,n,{value:0})})}),n(Be,function(n,e){var t=He(e.self(),e.parent());return t&&nt(t,n)?n:!e.option("keep_infinity")||t&&!nt(t,n)||d(e,"Infinity")?D(In,n,{operator:"/",left:D(Ee,n,{value:1}),right:D(Ee,n,{value:0})}):n}),n(Ae,function(n,e){var t=He(e.self(),e.parent());return t&&!nt(t,n)||d(e,"NaN")?D(In,n,{operator:"/",left:D(Ee,n,{value:0}),right:D(Ee,n,{value:0})}):n});var tt=["+","-","/","*","%",">>","<<",">>>","|","^","&"],it=["*","|","^","&"];function rt(n,e){return n instanceof de&&(n=n.fixed_value()),!!n&&(!(n instanceof J||n instanceof Xn)||e.parent()instanceof Bn||!n.contains_this())}function ot(n,e){return e.in_boolean_context()?Re(e,n,F(n,[n,D(Me,n)]).optimize(e)):n}function at(n,e){if(!e.option("computed_props"))return n;if(!(n.key instanceof ye))return n;if(n.key instanceof be||n.key instanceof Ee){if("constructor"==n.key.value&&e.parent()instanceof Xn)return n;n.key=n instanceof Ln?n.key.value:D(ae,n.key,{name:n.key.value})}return n}n(Hn,function(n,e){var i;if(e.option("dead_code")&&n.left instanceof de&&(i=n.left.definition()).scope===e.find_parent(J)){var r,o=0,a=n;do{if(r=a,(a=e.parent(o++))instanceof an){if(u(o,a))break;if(et(i.scope,[i]))break;return"="==n.operator?n.right:(i.fixed=!1,D(In,n,{operator:n.operator.slice(0,-1),left:n.left,right:n.right}).optimize(e))}}while(a instanceof In&&a.right===r||a instanceof On&&a.tail_node()===r)}return"="==(n=n.lift_sequences(e)).operator&&n.left instanceof de&&n.right instanceof In&&(n.right.left instanceof de&&n.right.left.name==n.left.name&&t(n.right.operator,tt)?(n.operator=n.right.operator+"=",n.right=n.right.right):n.right.right instanceof de&&n.right.right.name==n.left.name&&t(n.right.operator,it)&&!n.right.left.has_side_effects(e)&&(n.operator=n.right.operator+"=",n.right=n.right.left)),n;function u(t,i){var r=n.right;n.right=D(Ce,r);var o=i.may_throw(e);n.right=r;for(var a,u=n.left.definition().scope;(a=e.parent(t++))!==u;)if(a instanceof Dn){if(a.bfinally)return!0;if(o&&a.bcatch)return!0}}}),n(Pn,function(n,e){if(!e.option("evaluate"))return n;var t=n.right.evaluate(e);return void 0===t?n=n.left:t!==n.right&&(t=C(t,n.right),n.right=Pe(t,n.right)),n}),n(Nn,function(n,e){if(!e.option("conditionals"))return n;if(n.condition instanceof On){var t=n.condition.expressions.slice();return n.condition=t.pop(),t.push(n),F(n,t)}var i=n.condition.evaluate(e);if(i!==n.condition)return i?(e.warn("Condition always true [{file}:{line},{col}]",n.start),M(e.parent(),e.self(),n.consequent)):(e.warn("Condition always false [{file}:{line},{col}]",n.start),M(e.parent(),e.self(),n.alternative));var r=i.negate(e,E(e));Re(e,i,r)===r&&(n=D(Nn,n,{condition:r,consequent:n.alternative,alternative:n.consequent}));var o,a=n.condition,u=n.consequent,s=n.alternative;if(a instanceof de&&u instanceof de&&a.definition()===u.definition())return D(In,n,{operator:"||",left:a,right:s});if(u instanceof Hn&&s instanceof Hn&&u.operator==s.operator&&u.left.equivalent_to(s.left)&&(!n.condition.has_side_effects(e)||"="==u.operator&&!u.left.has_side_effects(e)))return D(Hn,n,{operator:u.operator,left:u.left,right:D(Nn,n,{condition:n.condition,consequent:u.right,alternative:s.right})});if(u instanceof kn&&s.TYPE===u.TYPE&&u.args.length>0&&u.args.length==s.args.length&&u.expression.equivalent_to(s.expression)&&!n.condition.has_side_effects(e)&&!u.expression.has_side_effects(e)&&"number"==typeof(o=function(){for(var n=u.args,e=s.args,t=0,i=n.length;t<i;t++){if(n[t]instanceof X)return;if(!n[t].equivalent_to(e[t])){if(e[t]instanceof X)return;for(var r=t+1;r<i;r++){if(n[r]instanceof X)return;if(!n[r].equivalent_to(e[r]))return}return t}}}())){var c=u.clone();return c.args[o]=D(Nn,n,{condition:n.condition,consequent:u.args[o],alternative:s.args[o]}),c}if(u instanceof Nn&&u.alternative.equivalent_to(s))return D(Nn,n,{condition:D(In,n,{left:n.condition,operator:"&&",right:u.condition}),consequent:u.consequent,alternative:s});if(u.equivalent_to(s))return F(n,[n.condition,u]).optimize(e);if(u instanceof In&&"||"==u.operator&&u.right.equivalent_to(s))return D(In,n,{operator:"||",left:D(In,n,{operator:"&&",left:n.condition,right:u.left}),right:s}).optimize(e);var f=e.in_boolean_context();return p(n.consequent)?h(n.alternative)?l(n.condition):D(In,n,{operator:"||",left:l(n.condition),right:n.alternative}):h(n.consequent)?p(n.alternative)?l(n.condition.negate(e)):D(In,n,{operator:"&&",left:l(n.condition.negate(e)),right:n.alternative}):p(n.alternative)?D(In,n,{operator:"||",left:l(n.condition.negate(e)),right:n.consequent}):h(n.alternative)?D(In,n,{operator:"&&",left:l(n.condition),right:n.consequent}):n;function l(n){return n.is_boolean()?n:D(Tn,n,{operator:"!",expression:n.negate(e)})}function p(n){return n instanceof Me||f&&n instanceof ye&&n.getValue()||n instanceof Tn&&"!"==n.operator&&n.expression instanceof ye&&!n.expression.getValue()}function h(n){return n instanceof $e||f&&n instanceof ye&&!n.getValue()||n instanceof Tn&&"!"==n.operator&&n.expression instanceof ye&&n.expression.getValue()}}),n(Oe,function(n,e){if(e.in_boolean_context())return D(Ee,n,{value:+n.value});var t=e.parent();return e.option("booleans_as_integers")?(t instanceof In&&("==="==t.operator||"!=="==t.operator)&&(t.operator=t.operator.replace(/=$/,"")),D(Ee,n,{value:+n.value})):e.option("booleans")?t instanceof In&&("=="==t.operator||"!="==t.operator)?(e.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]",{operator:t.operator,value:n.value,file:t.start.file,line:t.start.line,col:t.start.col}),D(Ee,n,{value:+n.value})):D(Tn,n,{operator:"!",expression:D(Ee,n,{value:1-n.value})}):n}),n(zn,function(n,e){var t,i=n.expression,r=n.property;if(e.option("properties")){var o=r.evaluate(e);if(o!==r){if("string"==typeof o)if("undefined"==o)o=void 0;else(E=parseFloat(o)).toString()==o&&(o=E);r=n.property=Pe(r,C(o,r).transform(e));var a=""+o;if(ut(a)&&a.length<=r.print_to_string().length+1)return D(Mn,n,{expression:i,property:a}).optimize(e)}}n:if(e.option("arguments")&&i instanceof de&&"arguments"==i.name&&1==i.definition().orig.length&&(t=i.scope)instanceof J&&t.uses_arguments&&!(t instanceof K)&&r instanceof Ee){for(var u=r.getValue(),s=Object.create(null),c=t.argnames,f=0;f<c.length;f++){if(!(c[f]instanceof re))break n;var l=c[f].name;if(l in s)break n;s[l]=!0}var p=t.argnames[u];if(p&&e.has_directive("use strict")){var h=p.definition();(!e.option("reduce_vars")||h.assignments||h.orig.length>1)&&(p=null)}else if(!p&&!e.option("keep_fargs")&&u<t.argnames.length+5)for(;u>=t.argnames.length;)p=D(re,t,{name:t.make_var_name("argument_"+t.argnames.length),scope:t}),t.argnames.push(p),t.enclosed.push(t.def_variable(p));if(p){var d=D(de,n,p);return d.reference({}),delete p.__unused,d}}if(He(n,e.parent()))return n;if(o!==r){var m=n.flatten_object(a,e);m&&(i=n.expression=m.expression,r=n.property=m.property)}if(e.option("properties")&&e.option("side_effects")&&r instanceof Ee&&i instanceof Rn){u=r.getValue();var v=i.elements,g=v[u];n:if(rt(g,e)){for(var _=!0,y=[],b=v.length;--b>u;){(E=v[b].drop_side_effect_free(e))&&(y.unshift(E),_&&E.has_side_effects(e)&&(_=!1))}if(g instanceof X)break n;for(g=g instanceof ke?D(xe,g):g,_||y.unshift(g);--b>=0;){var E;if((E=v[b])instanceof X)break n;(E=E.drop_side_effect_free(e))?y.unshift(E):u--}return _?(y.push(g),F(n,y).optimize(e)):D(zn,n,{expression:D(Rn,i,{elements:y}),property:D(Ee,r,{value:u})})}}var w=n.evaluate(e);return w!==n?Re(e,w=C(w,n).optimize(e),n):n}),J.DEFMETHOD("contains_this",function(){var n,e=this;return e.walk(new Te(function(t){return!!n||(t instanceof ge?n=!0:t!==e&&t instanceof V&&!(t instanceof K)||void 0)})),n}),$n.DEFMETHOD("flatten_object",function(n,e){if(e.option("properties")){var t=e.option("unsafe_arrows")&&e.option("ecma")>=6,i=this.expression;if(i instanceof jn)for(var r=i.properties,o=r.length;--o>=0;){var a=r[o];if(""+(a instanceof Wn?a.key.name:a.key)==n){if(!_(r,function(n){return n instanceof Ln||t&&n instanceof Wn&&!n.is_generator}))break;if(!rt(a.value,e))break;return D(zn,this,{expression:D(Rn,i,{elements:r.map(function(n){var e=n.value;e instanceof Z&&(e=D(Q,e,e));var t=n.key;return t instanceof A&&!(t instanceof ae)?F(n,[t,e]):e})}),property:D(Ee,this,{value:o})})}}}}),n(Mn,function(n,e){if("arguments"!=n.property&&"caller"!=n.property||e.warn("Function.protoype.{prop} not supported [{file}:{line},{col}]",{prop:n.property,file:n.start.file,line:n.start.line,col:n.start.col}),He(n,e.parent()))return n;if(e.option("unsafe_proto")&&n.expression instanceof Mn&&"prototype"==n.expression.property){var t=n.expression.expression;if(ie(t))switch(t.name){case"Array":n.expression=D(Rn,n.expression,{elements:[]});break;case"Function":n.expression=D(Q,n.expression,{argnames:[],body:[]});break;case"Number":n.expression=D(Ee,n.expression,{value:0});break;case"Object":n.expression=D(jn,n.expression,{properties:[]});break;case"RegExp":n.expression=D(we,n.expression,{value:/t/});break;case"String":n.expression=D(be,n.expression,{value:""})}}var i=n.flatten_object(n.property,e);if(i)return i.optimize(e);var r=n.evaluate(e);return r!==n?Re(e,r=C(r,n).optimize(e),n):n}),n(Rn,ot),n(jn,ot),n(we,ot),n(un,function(n,e){return n.value&&Se(n.value,e)&&(n.value=null),n}),n(K,function(n,e){if(n.body instanceof A||(n=Je(n,e)),e.option("arrows")&&1==n.body.length&&n.body[0]instanceof un){var t=n.body[0].value;n.body=t||[]}return n}),n(Q,function(n,e){if(n=Je(n,e),e.option("unsafe_arrows")&&e.option("ecma")>=6&&!n.name&&!n.is_generator&&!n.uses_arguments&&!n.pinned()){var t=!1;if(n.walk(new Te(function(n){return!!t||(n instanceof ge?(t=!0,!0):void 0)})),!t)return D(K,n,n).optimize(e)}return n}),n(Xn,function(n,e){return n}),n(qe,function(n,e){return n.expression&&!n.is_star&&Se(n.expression,e)&&(n.expression=null),n}),n(tn,function(n,e){if(!e.option("evaluate")||e.parent()instanceof en)return n;for(var t=[],i=0;i<n.segments.length;i++){var r=n.segments[i];if(r instanceof A){var o=r.evaluate(e);if(o!==r&&(o+"").length<=r.print_to_string().length+"${}".length){t[t.length-1].value=t[t.length-1].value+o+n.segments[++i].value;continue}}t.push(r)}return n.segments=t,1==t.length?D(be,n,t[0]):n}),n(en,function(n,e){return n}),n(Un,at),n(Wn,function(n,e){if(at(n,e),e.option("arrows")&&e.parent()instanceof jn&&!n.is_generator&&!n.value.uses_arguments&&!n.value.pinned()&&1==n.value.body.length&&n.value.body[0]instanceof un&&n.value.body[0].value&&!n.value.contains_this()){var t=D(K,n.value,n.value);return t.async=n.async,t.is_generator=n.is_generator,D(Ln,n,{key:n.key instanceof ae?n.key.name:n.key,value:t,quote:n.quote})}return n}),n(Ln,function(n,e){at(n,e);var t=e.option("unsafe_methods");if(t&&e.option("ecma")>=6&&(!(t instanceof RegExp)||t.test(n.key+""))){var i=n.key,r=n.value;if((r instanceof K&&Array.isArray(r.body)&&!r.contains_this()||r instanceof Q)&&!r.name)return D(Wn,n,{async:r.async,is_generator:r.is_generator,key:i instanceof A?i:D(ae,n,{name:i}),value:D(Z,r,r),quote:n.quote})}return n}),n(nn,function(n,e){if(1==e.option("pure_getters")&&e.option("unused")&&!n.is_array&&Array.isArray(n.names)&&!function(n){for(var e=[/^VarDef$/,/^(Const|Let|Var)$/,/^Export$/],t=0,i=0,r=e.length;t<r;i++){var o=n.parent(i);if(!o)return!1;if(0!==t||"Destructuring"!=o.TYPE){if(!e[t].test(o.TYPE))return!1;t++}}return!0}(e)){for(var t=[],i=0;i<n.names.length;i++){var r=n.names[i];r instanceof Ln&&"string"==typeof r.key&&r.value instanceof Gn&&!o(e,r.value.definition())||t.push(r)}t.length!=n.names.length&&(n.names=t)}return n;function o(n,e){return!!e.references.length||!!e.global&&(!n.toplevel.vars||!!n.top_retain&&n.top_retain(e))}})}(),function(){var e=function(n){for(var e=!0,t=0;t<n.length;t++)e&&n[t]instanceof x&&n[t].body instanceof be?n[t]=new B({start:n[t].start,end:n[t].end,value:n[t].body.value}):!e||n[t]instanceof x&&n[t].body instanceof be||(e=!1);return n},t={Program:function(n){return new W({start:r(n),end:o(n),body:e(n.body.map(s))})},ArrayPattern:function(n){return new nn({start:r(n),end:o(n),names:n.elements.map(function(n){return null===n?new ke:s(n)}),is_array:!0})},ObjectPattern:function(n){return new nn({start:r(n),end:o(n),names:n.properties.map(s),is_array:!1})},AssignmentPattern:function(n){return new In({start:r(n),end:o(n),left:s(n.left),operator:"=",right:s(n.right)})},SpreadElement:function(n){return new X({start:r(n),end:o(n),expression:s(n.argument)})},RestElement:function(n){return new X({start:r(n),end:o(n),expression:s(n.argument)})},TemplateElement:function(n){return new rn({start:r(n),end:o(n),value:n.value.cooked,raw:n.value.raw})},TemplateLiteral:function(n){for(var e=[],t=0;t<n.quasis.length;t++)e.push(s(n.quasis[t])),n.expressions[t]&&e.push(s(n.expressions[t]));return new tn({start:r(n),end:o(n),segments:e})},TaggedTemplateExpression:function(n){return new en({start:r(n),end:o(n),template_string:s(n.quasi),prefix:s(n.tag)})},FunctionDeclaration:function(n){return new G({start:r(n),end:o(n),name:s(n.id),argnames:n.params.map(s),is_generator:n.generator,async:n.async,body:e(s(n.body).body)})},FunctionExpression:function(n){return new Q({start:r(n),end:o(n),name:s(n.id),argnames:n.params.map(s),is_generator:n.generator,async:n.async,body:e(s(n.body).body)})},ArrowFunctionExpression:function(n){return new K({start:r(n),end:o(n),argnames:n.params.map(s),body:s(n.body),async:n.async})},ExpressionStatement:function(n){return new O({start:r(n),end:o(n),body:s(n.expression)})},TryStatement:function(n){var e=n.handlers||[n.handler];if(e.length>1||n.guardedHandlers&&n.guardedHandlers.length)throw new Error("Multiple catch clauses are not supported.");return new Dn({start:r(n),end:o(n),body:s(n.block).body,bcatch:s(e[0]),bfinally:n.finalizer?new _n(s(n.finalizer)):null})},Property:function(n){var e=n.key,t={start:r(e||n.value),end:o(n.value),key:"Identifier"==e.type?e.name:e.value,value:s(n.value)};return n.computed&&(t.key=s(n.key)),n.method?(t.is_generator=n.value.generator,t.async=n.value.async,n.computed?t.key=s(n.key):t.key=new ae({name:t.key}),new Wn(t)):"init"==n.kind?("Identifier"!=e.type&&"Literal"!=e.type&&(t.key=s(e)),new Ln(t)):("string"!=typeof t.key&&"number"!=typeof t.key||(t.key=new ae({name:t.key})),t.value=new Z(t.value),"get"==n.kind?new Vn(t):"set"==n.kind?new Yn(t):"method"==n.kind?(t.async=n.value.async,t.is_generator=n.value.generator,t.quote=n.computed?'"':null,new Wn(t)):void 0)},MethodDefinition:function(n){var e={start:r(n),end:o(n),key:n.computed?s(n.key):new ae({name:n.key.name||n.key.value}),value:s(n.value),static:n.static};return"get"==n.kind?new Vn(e):"set"==n.kind?new Yn(e):(e.is_generator=n.value.generator,e.async=n.value.async,new Wn(e))},ArrayExpression:function(n){return new Rn({start:r(n),end:o(n),elements:n.elements.map(function(n){return null===n?new ke:s(n)})})},ObjectExpression:function(n){return new jn({start:r(n),end:o(n),properties:n.properties.map(function(n){return"SpreadElement"===n.type?s(n):(n.type="Property",s(n))})})},SequenceExpression:function(n){return new On({start:r(n),end:o(n),expressions:n.expressions.map(s)})},MemberExpression:function(n){return new(n.computed?zn:Mn)({start:r(n),end:o(n),property:n.computed?s(n.property):n.property.name,expression:s(n.object)})},SwitchCase:function(n){return new(n.test?vn:mn)({start:r(n),end:o(n),expression:s(n.test),body:n.consequent.map(s)})},VariableDeclaration:function(n){return new("const"===n.kind?wn:"let"===n.kind?En:bn)({start:r(n),end:o(n),definitions:n.declarations.map(s)})},ImportDeclaration:function(n){var e=null,t=null;return n.specifiers.forEach(function(n){"ImportSpecifier"===n.type?(t||(t=[]),t.push(new Fn({start:r(n),end:o(n),foreign_name:s(n.imported),name:s(n.local)}))):"ImportDefaultSpecifier"===n.type?e=s(n.local):"ImportNamespaceSpecifier"===n.type&&(t||(t=[]),t.push(new Fn({start:r(n),end:o(n),foreign_name:new pe({name:"*"}),name:s(n.local)})))}),new Cn({start:r(n),end:o(n),imported_name:e,imported_names:t,module_name:s(n.source)})},ExportAllDeclaration:function(n){return new An({start:r(n),end:o(n),exported_names:[new Fn({name:new ve({name:"*"}),foreign_name:new ve({name:"*"})})],module_name:s(n.source)})},ExportNamedDeclaration:function(n){return new An({start:r(n),end:o(n),exported_definition:s(n.declaration),exported_names:n.specifiers&&n.specifiers.length?n.specifiers.map(function(n){return new Fn({foreign_name:s(n.exported),name:s(n.local)})}):null,module_name:s(n.source)})},ExportDefaultDeclaration:function(n){return new An({start:r(n),end:o(n),exported_value:s(n.declaration),is_default:!0})},Literal:function(n){var e=n.value,t={start:r(n),end:o(n)};if(null===e)return new Ce(t);var i=n.regex;if(i&&i.pattern){t.value=new RegExp(i.pattern,i.flags);var a=t.value.toString();return t.value.raw_source=i.flags?a.substring(0,a.length-i.flags.length)+i.flags:a,new we(t)}if(i)return t.value=n.regex&&n.raw?n.raw:e,new we(t);switch(typeof e){case"string":return t.value=e,new be(t);case"number":return t.value=e,new Ee(t);case"boolean":return new(e?Me:$e)(t)}},MetaProperty:function(n){if("new"===n.meta.name&&"target"===n.property.name)return new Kn({start:r(n),end:o(n)})},Identifier:function(n){var e=u[u.length-2];return new("LabeledStatement"==e.type?he:"VariableDeclarator"==e.type&&e.id===n?"const"==e.kind?te:"let"==e.kind?ie:ne:/Import.*Specifier/.test(e.type)?e.local===n?le:pe:"ExportSpecifier"==e.type?e.local===n?me:ve:"FunctionExpression"==e.type?e.id===n?ue:re:"FunctionDeclaration"==e.type?e.id===n?oe:re:"ArrowFunctionExpression"==e.type?-1!==e.params.indexOf(n)?re:de:"ClassExpression"==e.type?e.id===n?ce:de:"Property"==e.type?e.key===n&&e.computed||e.value===n?de:ae:"ClassDeclaration"==e.type?e.id===n?se:de:"MethodDefinition"==e.type?e.computed?de:ae:"CatchClause"==e.type?fe:"BreakStatement"==e.type||"ContinueStatement"==e.type?De:de)({start:r(n),end:o(n),name:n.name})}};function i(n){if("Literal"==n.type)return null!=n.raw?n.raw:n.value+""}function r(n){var e=n.loc,t=e&&e.start,r=n.range;return new C({file:e&&e.source,line:t&&t.line,col:t&&t.column,pos:r?r[0]:n.start,endline:t&&t.line,endcol:t&&t.column,endpos:r?r[0]:n.start,raw:i(n)})}function o(n){var e=n.loc,t=e&&e.end,r=n.range;return new C({file:e&&e.source,line:t&&t.line,col:t&&t.column,pos:r?r[1]:n.end,endline:t&&t.line,endcol:t&&t.column,endpos:r?r[1]:n.end,raw:i(n)})}function a(e,i,a){var u="function From_Moz_"+e+"(M){\n";u+="return new U2."+i.name+"({\nstart: my_start_token(M),\nend: my_end_token(M)";var f="function To_Moz_"+e+"(M){\n";f+="return {\ntype: "+JSON.stringify(e),a&&a.split(/\s*,\s*/).forEach(function(n){var e=/([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(n);if(!e)throw new Error("Can't understand property map: "+n);var t=e[1],i=e[2],r=e[3];switch(u+=",\n"+r+": ",f+=",\n"+t+": ",i){case"@":u+="M."+t+".map(from_moz)",f+="M."+r+".map(to_moz)";break;case">":u+="from_moz(M."+t+")",f+="to_moz(M."+r+")";break;case"=":u+="M."+t,f+="M."+r;break;case"%":u+="from_moz(M."+t+").body",f+="to_moz_block(M)";break;default:throw new Error("Can't understand operator in propmap: "+n)}}),u+="\n})\n}",f+="\n}\n}",u=new Function("U2","my_start_token","my_end_token","from_moz","return("+u+")")(n,r,o,s),f=new Function("to_moz","to_moz_block","to_moz_scope","return("+f+")")(l,h,d),t[e]=u,c(i,f)}t.UpdateExpression=t.UnaryExpression=function(n){return new(("prefix"in n?n.prefix:"UnaryExpression"==n.type)?Tn:Sn)({start:r(n),end:o(n),operator:n.operator,expression:s(n.argument)})},t.ClassDeclaration=t.ClassExpression=function(n){return new("ClassDeclaration"===n.type?Jn:Zn)({start:r(n),end:o(n),name:s(n.id),extends:s(n.superClass),properties:n.body.body.map(s)})},a("EmptyStatement",T),a("BlockStatement",q,"body@body"),a("IfStatement",pn,"test>condition, consequent>body, alternate>alternative"),a("LabeledStatement",I,"label>label, body>body"),a("BreakStatement",fn,"label>label"),a("ContinueStatement",ln,"label>label"),a("WithStatement",Y,"object>expression, body>body"),a("SwitchStatement",hn,"discriminant>expression, cases@body"),a("ReturnStatement",un,"argument>value"),a("ThrowStatement",sn,"argument>value"),a("WhileStatement",R,"test>condition, body>body"),a("DoWhileStatement",P,"test>condition, body>body"),a("ForStatement",j,"init>init, test>condition, update>step, body>body"),a("ForInStatement",U,"left>init, right>object, body>body"),a("ForOfStatement",L,"left>init, right>object, body>body, await=await"),a("AwaitExpression",ze,"argument>expression"),a("YieldExpression",qe,"argument>expression, delegate=is_star"),a("DebuggerStatement",k),a("VariableDeclarator",xn,"id>name, init>value"),a("CatchClause",gn,"param>argname, body%body"),a("ThisExpression",ge),a("Super",_e),a("BinaryExpression",In,"operator=operator, left>left, right>right"),a("LogicalExpression",In,"operator=operator, left>left, right>right"),a("AssignmentExpression",Hn,"operator=operator, left>left, right>right"),a("ConditionalExpression",Nn,"test>condition, consequent>consequent, alternate>alternative"),a("NewExpression",Bn,"callee>expression, arguments@args"),a("CallExpression",kn,"callee>expression, arguments@args"),c(W,function(n){return d("Program",n)}),c(X,function(n,e){return{type:p()?"RestElement":"SpreadElement",argument:l(n.expression)}}),c(en,function(n){return{type:"TaggedTemplateExpression",tag:l(n.prefix),quasi:l(n.template_string)}}),c(tn,function(n){for(var e=[],t=[],i=0;i<n.segments.length;i++)i%2!=0?t.push(l(n.segments[i])):e.push({type:"TemplateElement",value:{raw:n.segments[i].raw,cooked:n.segments[i].value},tail:i===n.segments.length-1});return{type:"TemplateLiteral",quasis:e,expressions:t}}),c(G,function(n){return{type:"FunctionDeclaration",id:l(n.name),params:n.argnames.map(l),generator:n.is_generator,async:n.async,body:d("BlockStatement",n)}}),c(Q,function(n,e){var t=void 0!==e.is_generator?e.is_generator:n.is_generator;return{type:"FunctionExpression",id:l(n.name),params:n.argnames.map(l),generator:t,async:n.async,body:d("BlockStatement",n)}}),c(K,function(n){var e=n.body instanceof Array?{type:"BlockStatement",body:n.body.map(l)}:l(n.body);return{type:"ArrowFunctionExpression",params:n.argnames.map(l),async:n.async,body:e}}),c(nn,function(n){return n.is_array?{type:"ArrayPattern",elements:n.names.map(l)}:{type:"ObjectPattern",properties:n.names.map(l)}}),c(B,function(n){return{type:"ExpressionStatement",expression:{type:"Literal",value:n.value}}}),c(O,function(n){return{type:"ExpressionStatement",expression:l(n.body)}}),c(dn,function(n){return{type:"SwitchCase",test:l(n.expression),consequent:n.body.map(l)}}),c(Dn,function(n){return{type:"TryStatement",block:h(n),handler:l(n.bcatch),guardedHandlers:[],finalizer:l(n.bfinally)}}),c(gn,function(n){return{type:"CatchClause",param:l(n.argname),guard:null,body:h(n)}}),c(yn,function(n){return{type:"VariableDeclaration",kind:n instanceof wn?"const":n instanceof En?"let":"var",declarations:n.definitions.map(l)}}),c(An,function(n){return n.exported_names?"*"===n.exported_names[0].name.name?{type:"ExportAllDeclaration",source:l(n.module_name)}:{type:"ExportNamedDeclaration",specifiers:n.exported_names.map(function(n){return{type:"ExportSpecifier",exported:l(n.foreign_name),local:l(n.name)}}),declaration:l(n.exported_definition),source:l(n.module_name)}:{type:n.is_default?"ExportDefaultDeclaration":"ExportNamedDeclaration",declaration:l(n.exported_value||n.exported_definition)}}),c(Cn,function(n){var e=[];return n.imported_name&&e.push({type:"ImportDefaultSpecifier",local:l(n.imported_name)}),n.imported_names&&"*"===n.imported_names[0].foreign_name.name?e.push({type:"ImportNamespaceSpecifier",local:l(n.imported_names[0].name)}):n.imported_names&&n.imported_names.forEach(function(n){e.push({type:"ImportSpecifier",local:l(n.name),imported:l(n.foreign_name)})}),{type:"ImportDeclaration",specifiers:e,source:l(n.module_name)}}),c(On,function(n){return{type:"SequenceExpression",expressions:n.expressions.map(l)}}),c($n,function(n){var e=n instanceof zn;return{type:"MemberExpression",object:l(n.expression),computed:e,property:e?l(n.property):{type:"Identifier",name:n.property}}}),c(qn,function(n){return{type:"++"==n.operator||"--"==n.operator?"UpdateExpression":"UnaryExpression",operator:n.operator,prefix:n instanceof Tn,argument:l(n.expression)}}),c(In,function(n){return"="==n.operator&&p()?{type:"AssignmentPattern",left:l(n.left),right:l(n.right)}:{type:"&&"==n.operator||"||"==n.operator?"LogicalExpression":"BinaryExpression",left:l(n.left),operator:n.operator,right:l(n.right)}}),c(Rn,function(n){return{type:"ArrayExpression",elements:n.elements.map(l)}}),c(jn,function(n){return{type:"ObjectExpression",properties:n.properties.map(l)}}),c(Un,function(n,e){var t,i=n.key instanceof A?l(n.key):{type:"Identifier",value:n.key};"number"==typeof n.key&&(i={type:"Literal",value:Number(n.key)}),"string"==typeof n.key&&(i={type:"Identifier",name:n.key});var r="string"==typeof n.key||"number"==typeof n.key,o=!r&&(!(n.key instanceof Qn)||n.key instanceof de);return n instanceof Ln?(t="init",o=!r):n instanceof Vn?t="get":n instanceof Yn&&(t="set"),e instanceof Xn?{type:"MethodDefinition",computed:o,kind:t,static:n.static,key:l(n.key),value:l(n.value)}:{type:"Property",computed:o,kind:t,key:i,value:l(n.value)}}),c(Wn,function(n,e){return e instanceof jn?{type:"Property",computed:!(n.key instanceof Qn)||n.key instanceof de,kind:"init",method:!0,shorthand:!1,key:l(n.key),value:l(n.value)}:{type:"MethodDefinition",computed:!(n.key instanceof Qn)||n.key instanceof de,kind:"constructor"===n.key?"constructor":"method",static:n.static,key:l(n.key),value:l(n.value)}}),c(Xn,function(n){return{type:n instanceof Zn?"ClassExpression":"ClassDeclaration",superClass:l(n.extends),id:n.name?l(n.name):null,body:{type:"ClassBody",body:n.properties.map(l)}}}),c(Kn,function(n){return{type:"MetaProperty",meta:{type:"Identifier",name:"new"},property:{type:"Identifier",name:"target"}}}),c(Qn,function(n,e){if(n instanceof ae&&e.quote)return{type:"Literal",value:n.name};var t=n.definition();return{type:"Identifier",name:t?t.mangled_name||t.name:n.name}}),c(we,function(n){var e=n.value.source,t=n.value.toString().match(/[gimuys]*$/)[0];return{type:"Literal",value:new RegExp(e,t),raw:n.value.raw_source,regex:{pattern:e,flags:t}}}),c(ye,function(n){var e=n.value;return"number"==typeof e&&(e<0||0===e&&1/e<0)?{type:"UnaryExpression",operator:"-",prefix:!0,argument:{type:"Literal",value:-e,raw:n.start.raw}}:{type:"Literal",value:e,raw:n.start.raw}}),c(Fe,function(n){return{type:"Identifier",name:String(n.value)}}),Oe.DEFMETHOD("to_mozilla_ast",ye.prototype.to_mozilla_ast),Ce.DEFMETHOD("to_mozilla_ast",ye.prototype.to_mozilla_ast),ke.DEFMETHOD("to_mozilla_ast",function(){return null}),z.DEFMETHOD("to_mozilla_ast",q.prototype.to_mozilla_ast),J.DEFMETHOD("to_mozilla_ast",Q.prototype.to_mozilla_ast);var u=null;function s(n){u.push(n);var e=null!=n?t[n.type](n):null;return u.pop(),e}function c(n,e){n.DEFMETHOD("to_mozilla_ast",function(n){return t=this,i=e(this,n),r=t.start,o=t.end,null!=r.pos&&null!=o.endpos&&(i.range=[r.pos,o.endpos]),r.line&&(i.loc={start:{line:r.line,column:r.col},end:o.endline?{line:o.endline,column:o.endcol}:null},r.file&&(i.loc.source=r.file)),i;var t,i,r,o})}A.from_mozilla_ast=function(n){var e=u;u=[];var t=s(n);return u=e,t};var f=null;function l(n){null===f&&(f=[]),f.push(n);var e=null!=n?n.to_mozilla_ast(f[f.length-2]):null;return f.pop(),0===f.length&&(f=null),e}function p(){for(var n=f.length;n--;)if(f[n]instanceof nn)return!0;return!1}function h(n){return{type:"BlockStatement",body:n.body.map(l)}}function d(n,e){var t=e.body.map(l);return e.body[0]instanceof O&&e.body[0].body instanceof be&&t.unshift(l(new T(e.body[0]))),{type:n,body:t}}}();var Bt=require("../tools/domprops.json");function Ot(n,e){function t(n){d(e,n)}n.walk(new Te(function(n){n instanceof Ln&&n.quote?t(n.key):n instanceof Un&&n.quote?t(n.key.name):n instanceof zn&&$t(n.property,t)}))}function $t(n,e){n.walk(new Te(function(n){return n instanceof On?$t(n.tail_node(),e):n instanceof be?e(n.value):n instanceof Nn&&($t(n.consequent,e),$t(n.alternative,e)),!0}))}function Mt(n,e){var t=(e=a(e,{builtins:!1,cache:null,debug:!1,keep_quoted:!1,only_cache:!1,regex:null,reserved:null},!0)).reserved;Array.isArray(t)||(t=[t]),e.builtins||function(n){n.push.apply(n,Bt);var e={},t="object"==typeof global?global:self;function i(e){d(n,e)}["Symbol","Map","Promise","Proxy","Reflect","Set","WeakMap","WeakSet"].forEach(function(n){e[n]=t[n]||new Function}),["null","true","false","Infinity","-Infinity","undefined"].forEach(i),[Object,Array,Function,Number,String,Boolean,Error,Math,Date,RegExp,e.Symbol,ArrayBuffer,DataView,decodeURI,decodeURIComponent,encodeURI,encodeURIComponent,eval,EvalError,Float32Array,Float64Array,Int8Array,Int16Array,Int32Array,isFinite,isNaN,JSON,e.Map,parseFloat,parseInt,e.Promise,e.Proxy,RangeError,ReferenceError,e.Reflect,e.Set,SyntaxError,TypeError,Uint8Array,Uint8ClampedArray,Uint16Array,Uint32Array,URIError,e.WeakMap,e.WeakSet].forEach(function(n){Object.getOwnPropertyNames(n).map(i),n.prototype&&Object.getOwnPropertyNames(n.prototype).map(i)})}(t);var i,r=-1;e.cache?(i=e.cache.props).each(function(n){d(t,n)}):i=new y;var o,u=e.regex,s=!1!==e.debug;s&&(o=!0===e.debug?"":e.debug);var c=[],f=[];return n.walk(new Te(function(n){n instanceof Ln?"string"==typeof n.key&&h(n.key):n instanceof Un?h(n.key.name):n instanceof Mn?h(n.property):n instanceof zn?$t(n.property,h):n instanceof kn&&"Object.defineProperty"==n.expression.print_to_string()&&$t(n.args[1],h)})),n.transform(new _t(function(n){n instanceof Ln?"string"==typeof n.key&&(n.key=m(n.key)):n instanceof Un?n.key.name=m(n.key.name):n instanceof Mn?n.property=m(n.property):!e.keep_quoted&&n instanceof zn?n.property=v(n.property):n instanceof kn&&"Object.defineProperty"==n.expression.print_to_string()&&(n.args[1]=v(n.args[1]))}));function l(n){return!(f.indexOf(n)>=0)&&(!(t.indexOf(n)>=0)&&(e.only_cache?i.has(n):!/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(n)))}function p(n){return!(u&&!u.test(n))&&(!(t.indexOf(n)>=0)&&(i.has(n)||c.indexOf(n)>=0))}function h(n){l(n)&&d(c,n),p(n)||d(f,n)}function m(n){if(!p(n))return n;var e=i.get(n);if(!e){if(s){var t="_$"+n+"$"+o+"_";l(t)&&(e=t)}if(!e)do{e=Ft(++r)}while(!l(e));i.set(n,e)}return e}function v(n){return n.transform(new _t(function(n){if(n instanceof On){var e=n.expressions.length-1;n.expressions[e]=v(n.expressions[e])}else n instanceof be?n.value=m(n.value):n instanceof Nn&&(n.consequent=v(n.consequent),n.alternative=v(n.alternative));return n}))}}var zt="undefined"==typeof atob?function(n){if(Buffer.from&&Buffer.from!==Uint8Array.from)return Buffer.from(n,"base64").toString();if("string"!=typeof n)throw new Errror('"b64" must be a string');return new Buffer(n,"base64").toString()}:atob,qt="undefined"==typeof btoa?function(n){if(Buffer.from&&Buffer.from!==Uint8Array.from)return Buffer.from(n).toString("base64");if("string"!=typeof n)throw new Errror('"str" must be a string');return new Buffer(n).toString("base64")}:btoa;function Tt(n,e,t){e[n]&&t.forEach(function(t){e[t]&&("object"!=typeof e[t]&&(e[t]={}),n in e[t]||(e[t][n]=e[n]))})}function St(n){n&&("props"in n?n.props instanceof y||(n.props=y.fromObject(n.props)):n.props=new y)}function It(n){return{props:n.props.toObject()}}n.Dictionary=y,n.minify=function(n,e){var t,i,r=A.warn_function;try{var o,u=(e=a(e,{compress:{},ecma:void 0,enclose:!1,ie8:!1,keep_classnames:void 0,keep_fnames:!1,mangle:{},module:!1,nameCache:null,output:{},parse:{},rename:void 0,safari10:!1,sourceMap:!1,timings:!1,toplevel:!1,warnings:!1,wrap:!1},!0)).timings&&{start:Date.now()};void 0===e.keep_classnames&&(e.keep_classnames=e.keep_fnames),void 0===e.rename&&(e.rename=e.compress&&e.mangle),Tt("ecma",e,["parse","compress","output"]),Tt("ie8",e,["compress","mangle","output"]),Tt("keep_classnames",e,["compress","mangle"]),Tt("keep_fnames",e,["compress","mangle"]),Tt("module",e,["parse","compress","mangle"]),Tt("safari10",e,["mangle","output"]),Tt("toplevel",e,["compress","mangle"]),Tt("warnings",e,["compress"]),e.mangle&&(e.mangle=a(e.mangle,{cache:e.nameCache&&(e.nameCache.vars||{}),eval:!1,ie8:!1,keep_classnames:!1,keep_fnames:!1,module:!1,properties:!1,reserved:[],safari10:!1,toplevel:!1},!0),e.mangle.properties&&("object"!=typeof e.mangle.properties&&(e.mangle.properties={}),e.mangle.properties.keep_quoted&&(o=e.mangle.properties.reserved,Array.isArray(o)||(o=[]),e.mangle.properties.reserved=o),!e.nameCache||"cache"in e.mangle.properties||(e.mangle.properties.cache=e.nameCache.props||{})),St(e.mangle.cache),St(e.mangle.properties.cache)),e.sourceMap&&(e.sourceMap=a(e.sourceMap,{content:null,filename:null,includeSources:!1,root:null,url:null},!0));var s,c=[];if(e.warnings&&!A.warn_function&&(A.warn_function=function(n){c.push(n)}),u&&(u.parse=Date.now()),n instanceof W)s=n;else{for(var f in"string"==typeof n&&(n=[n]),e.parse=e.parse||{},e.parse.toplevel=null,n)if(b(n,f)&&(e.parse.filename=f,e.parse.toplevel=gt(n[f],e.parse),e.sourceMap&&"inline"==e.sourceMap.content)){if(Object.keys(n).length>1)throw new Error("inline source map only works with singular input");e.sourceMap.content=(t=n[f],i=void 0,(i=/\n\/\/# sourceMappingURL=data:application\/json(;.*?)?;base64,(.*)/.exec(t))?zt(i[2]):(A.warn("inline source map not found"),null))}s=e.parse.toplevel}o&&Ot(s,o),e.wrap&&(s=s.wrap_commonjs(e.wrap)),e.enclose&&(s=s.wrap_enclose(e.enclose)),u&&(u.rename=Date.now()),u&&(u.compress=Date.now()),e.compress&&(s=new kt(e.compress).compress(s)),u&&(u.scope=Date.now()),e.mangle&&s.figure_out_scope(e.mangle),u&&(u.mangle=Date.now()),e.mangle&&(Ft.reset(),s.compute_char_frequency(e.mangle),s.mangle_names(e.mangle)),u&&(u.properties=Date.now()),e.mangle&&e.mangle.properties&&(s=Mt(s,e.mangle.properties)),u&&(u.output=Date.now());var l={};if(e.output.ast&&(l.ast=s),!b(e.output,"code")||e.output.code){if(e.sourceMap&&("string"==typeof e.sourceMap.content&&(e.sourceMap.content=JSON.parse(e.sourceMap.content)),e.output.source_map=function(n){n=a(n,{file:null,root:null,orig:null,orig_line_diff:0,dest_line_diff:0});var e=new(require("source-map").SourceMapGenerator)({file:n.file,sourceRoot:n.root}),t=n.orig&&new(require("source-map").SourceMapConsumer)(n.orig);return t&&Array.isArray(n.orig.sources)&&t._sources.toArray().forEach(function(n){var i=t.sourceContentFor(n,!0);i&&e.setSourceContent(n,i)}),{add:function(i,r,o,a,u,s){if(t){var c=t.originalPositionFor({line:a,column:u});if(null===c.source)return;i=c.source,a=c.line,u=c.column,s=c.name||s}e.addMapping({generated:{line:r+n.dest_line_diff,column:o},original:{line:a+n.orig_line_diff,column:u},source:i,name:s})},get:function(){return e},toString:function(){return JSON.stringify(e.toJSON())}}}({file:e.sourceMap.filename,orig:e.sourceMap.content,root:e.sourceMap.root}),e.sourceMap.includeSources)){if(n instanceof W)throw new Error("original source content unavailable");for(var f in n)b(n,f)&&e.output.source_map.get().setSourceContent(f,n[f])}delete e.output.ast,delete e.output.code;var p=xt(e.output);s.print(p),l.code=p.get(),e.sourceMap&&(l.map=e.output.source_map.toString(),"inline"==e.sourceMap.url?l.code+="\n//# sourceMappingURL=data:application/json;charset=utf-8;base64,"+qt(l.map):e.sourceMap.url&&(l.code+="\n//# sourceMappingURL="+e.sourceMap.url))}return e.nameCache&&e.mangle&&(e.mangle.cache&&(e.nameCache.vars=It(e.mangle.cache)),e.mangle.properties&&e.mangle.properties.cache&&(e.nameCache.props=It(e.mangle.properties.cache))),u&&(u.end=Date.now(),l.timings={parse:.001*(u.rename-u.parse),rename:.001*(u.compress-u.rename),compress:.001*(u.scope-u.compress),scope:.001*(u.mangle-u.scope),mangle:.001*(u.properties-u.mangle),properties:.001*(u.output-u.properties),output:.001*(u.end-u.output),total:.001*(u.end-u.start)}),c.length&&(l.warnings=c),l}catch(n){return{error:n}}finally{A.warn_function=r}},n.parse=gt,n.push_uniq=d,n.OutputStream=xt,n.TreeTransformer=_t,n.TreeWalker=Te,n.string_template=m,n.Compressor=kt,n.defaults=a,n.base54=Ft,n.mangle_properties=Mt,n.reserve_quoted_keys=Ot,n.to_ascii=zt}("undefined"!=typeof module?module.exports:Terser={});
//# sourceMappingURL=bundle.js.map